/* notification.c generated by valac 0.56.12, the Vala compiler
 * generated from notification.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgie-private.h"
#include <gio/gdesktopappinfo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

enum  {
	BUDGIE_NOTIFICATION_0_PROPERTY,
	BUDGIE_NOTIFICATION_APP_INFO_PROPERTY,
	BUDGIE_NOTIFICATION_APP_ID_PROPERTY,
	BUDGIE_NOTIFICATION_URGENCY_PROPERTY,
	BUDGIE_NOTIFICATION_ID_PROPERTY,
	BUDGIE_NOTIFICATION_APP_NAME_PROPERTY,
	BUDGIE_NOTIFICATION_HINTS_PROPERTY,
	BUDGIE_NOTIFICATION_ACTIONS_PROPERTY,
	BUDGIE_NOTIFICATION_APP_ICON_PROPERTY,
	BUDGIE_NOTIFICATION_BODY_PROPERTY,
	BUDGIE_NOTIFICATION_SUMMARY_PROPERTY,
	BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY,
	BUDGIE_NOTIFICATION_CATEGORY_PROPERTY,
	BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY,
	BUDGIE_NOTIFICATION_IMAGE_PROPERTY,
	BUDGIE_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* budgie_notification_properties[BUDGIE_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _BudgieNotificationPrivate {
	GDesktopAppInfo* _app_info;
	gchar* _app_id;
	GNotificationPriority _urgency;
	guint32 _id;
	gchar* _app_name;
	GHashTable* _hints;
	gchar** _actions;
	gint _actions_length1;
	gint __actions_size_;
	gchar* _app_icon;
	gchar* _body;
	gchar* _summary;
	guint _expire_timeout;
	gchar* _category;
	gint64 _timestamp;
	GtkImage* _image;
};

static gint BudgieNotification_private_offset;
static gpointer budgie_notification_parent_class = NULL;
static GRegex* budgie_notification_entity_regex;
static GRegex* budgie_notification_entity_regex = NULL;
static GRegex* budgie_notification_tag_regex;
static GRegex* budgie_notification_tag_regex = NULL;

static GdkPixbuf* budgie_notification_decode_image (BudgieNotification* self,
                                             GVariant* img);
static gchar* budgie_notification_fix_markup (BudgieNotification* self,
                                       const gchar* markup);
static void budgie_notification_set_app_info (BudgieNotification* self,
                                       GDesktopAppInfo* value);
static void budgie_notification_set_app_id (BudgieNotification* self,
                                     const gchar* value);
static void budgie_notification_set_urgency (BudgieNotification* self,
                                      GNotificationPriority value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GObject * budgie_notification_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void budgie_notification_finalize (GObject * obj);
static GType budgie_notification_get_type_once (void);
static void _vala_budgie_notification_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_budgie_notification_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
 * Enumeration of why a notification was closed.
 */
static GType
budgie_notification_close_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED, "BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED", "expired"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED", "dismissed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED", "closed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED, "BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType budgie_notification_close_reason_type_id;
	budgie_notification_close_reason_type_id = g_enum_register_static ("BudgieNotificationCloseReason", values);
	return budgie_notification_close_reason_type_id;
}

GType
budgie_notification_close_reason_get_type (void)
{
	static volatile gsize budgie_notification_close_reason_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_close_reason_type_id__once)) {
		GType budgie_notification_close_reason_type_id;
		budgie_notification_close_reason_type_id = budgie_notification_close_reason_get_type_once ();
		g_once_init_leave (&budgie_notification_close_reason_type_id__once, budgie_notification_close_reason_type_id);
	}
	return budgie_notification_close_reason_type_id__once;
}

/**
 * Enumeration of where notification popups will be shown.
 */
static GType
budgie_notification_position_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_POSITION_TOP_LEFT, "BUDGIE_NOTIFICATION_POSITION_TOP_LEFT", "top-left"}, {BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT, "BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT", "top-right"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT", "bottom-left"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType budgie_notification_position_type_id;
	budgie_notification_position_type_id = g_enum_register_static ("BudgieNotificationPosition", values);
	return budgie_notification_position_type_id;
}

GType
budgie_notification_position_get_type (void)
{
	static volatile gsize budgie_notification_position_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_position_type_id__once)) {
		GType budgie_notification_position_type_id;
		budgie_notification_position_type_id = budgie_notification_position_get_type_once ();
		g_once_init_leave (&budgie_notification_position_type_id__once, budgie_notification_position_type_id);
	}
	return budgie_notification_position_type_id__once;
}

static inline gpointer
budgie_notification_get_instance_private (BudgieNotification* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieNotification_private_offset);
}

BudgieNotification*
budgie_notification_construct (GType object_type,
                               guint32 id,
                               const gchar* app_name,
                               const gchar* app_icon,
                               const gchar* summary,
                               const gchar* body,
                               gchar** actions,
                               gint actions_length1,
                               GHashTable* hints,
                               guint expire_timeout)
{
	BudgieNotification * self = NULL;
#line 66 "../src/lib/notification.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 66 "../src/lib/notification.vala"
	g_return_val_if_fail (app_icon != NULL, NULL);
#line 66 "../src/lib/notification.vala"
	g_return_val_if_fail (summary != NULL, NULL);
#line 66 "../src/lib/notification.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 66 "../src/lib/notification.vala"
	g_return_val_if_fail (hints != NULL, NULL);
#line 76 "../src/lib/notification.vala"
	self = (BudgieNotification*) g_object_new (object_type, "id", id, "app-name", app_name, "app-icon", app_icon, "summary", summary, "body", body, "actions", actions, "hints", hints, "expire-timeout", expire_timeout, NULL);
#line 66 "../src/lib/notification.vala"
	return self;
#line 193 "notification.c"
}

BudgieNotification*
budgie_notification_new (guint32 id,
                         const gchar* app_name,
                         const gchar* app_icon,
                         const gchar* summary,
                         const gchar* body,
                         gchar** actions,
                         gint actions_length1,
                         GHashTable* hints,
                         guint expire_timeout)
{
#line 66 "../src/lib/notification.vala"
	return budgie_notification_construct (BUDGIE_TYPE_NOTIFICATION, id, app_name, app_icon, summary, body, actions, actions_length1, hints, expire_timeout);
#line 209 "notification.c"
}

static GdkPixbuf*
budgie_notification_decode_image (BudgieNotification* self,
                                  GVariant* img)
{
	gint width = 0;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gint _tmp2_;
	gint height = 0;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gint _tmp5_;
	gint rowstride = 0;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gint _tmp8_;
	gboolean has_alpha = FALSE;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	gboolean _tmp11_;
	gint bits_per_sample = 0;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint _tmp14_;
	guint8* raw = NULL;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	void* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint raw_length1;
	gint _raw_size_;
	GdkPixbuf* pixbuf = NULL;
	guint8* _tmp19_;
	gint _tmp19__length1;
	GdkPixbuf* _tmp20_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* result;
#line 199 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 199 "../src/lib/notification.vala"
	g_return_val_if_fail (img != NULL, NULL);
#line 201 "../src/lib/notification.vala"
	_tmp0_ = g_variant_get_child_value (img, (gsize) 0);
#line 201 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 201 "../src/lib/notification.vala"
	_tmp2_ = (gint) g_variant_get_int32 (_tmp1_);
#line 201 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp1_);
#line 201 "../src/lib/notification.vala"
	width = _tmp2_;
#line 202 "../src/lib/notification.vala"
	_tmp3_ = g_variant_get_child_value (img, (gsize) 1);
#line 202 "../src/lib/notification.vala"
	_tmp4_ = _tmp3_;
#line 202 "../src/lib/notification.vala"
	_tmp5_ = (gint) g_variant_get_int32 (_tmp4_);
#line 202 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp4_);
#line 202 "../src/lib/notification.vala"
	height = _tmp5_;
#line 203 "../src/lib/notification.vala"
	_tmp6_ = g_variant_get_child_value (img, (gsize) 2);
#line 203 "../src/lib/notification.vala"
	_tmp7_ = _tmp6_;
#line 203 "../src/lib/notification.vala"
	_tmp8_ = (gint) g_variant_get_int32 (_tmp7_);
#line 203 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp7_);
#line 203 "../src/lib/notification.vala"
	rowstride = _tmp8_;
#line 204 "../src/lib/notification.vala"
	_tmp9_ = g_variant_get_child_value (img, (gsize) 3);
#line 204 "../src/lib/notification.vala"
	_tmp10_ = _tmp9_;
#line 204 "../src/lib/notification.vala"
	_tmp11_ = g_variant_get_boolean (_tmp10_);
#line 204 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp10_);
#line 204 "../src/lib/notification.vala"
	has_alpha = _tmp11_;
#line 205 "../src/lib/notification.vala"
	_tmp12_ = g_variant_get_child_value (img, (gsize) 4);
#line 205 "../src/lib/notification.vala"
	_tmp13_ = _tmp12_;
#line 205 "../src/lib/notification.vala"
	_tmp14_ = (gint) g_variant_get_int32 (_tmp13_);
#line 205 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp13_);
#line 205 "../src/lib/notification.vala"
	bits_per_sample = _tmp14_;
#line 207 "../src/lib/notification.vala"
	_tmp15_ = g_variant_get_child_value (img, (gsize) 6);
#line 207 "../src/lib/notification.vala"
	_tmp16_ = _tmp15_;
#line 207 "../src/lib/notification.vala"
	_tmp17_ = g_variant_get_data (_tmp16_);
#line 207 "../src/lib/notification.vala"
	_tmp18_ = (guint8*) _tmp17_;
#line 207 "../src/lib/notification.vala"
	_tmp18__length1 = -1;
#line 207 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp16_);
#line 207 "../src/lib/notification.vala"
	raw = _tmp18_;
#line 207 "../src/lib/notification.vala"
	raw_length1 = _tmp18__length1;
#line 207 "../src/lib/notification.vala"
	_raw_size_ = raw_length1;
#line 210 "../src/lib/notification.vala"
	_tmp19_ = raw;
#line 210 "../src/lib/notification.vala"
	_tmp19__length1 = raw_length1;
#line 210 "../src/lib/notification.vala"
	_tmp20_ = gdk_pixbuf_new_from_data (_tmp19_, GDK_COLORSPACE_RGB, has_alpha, bits_per_sample, width, height, rowstride, (GdkPixbufDestroyNotify) NULL, NULL);
#line 210 "../src/lib/notification.vala"
	pixbuf = _tmp20_;
#line 221 "../src/lib/notification.vala"
	if (height != 48) {
#line 333 "notification.c"
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 222 "../src/lib/notification.vala"
		_tmp21_ = pixbuf;
#line 222 "../src/lib/notification.vala"
		_tmp22_ = gdk_pixbuf_scale_simple (_tmp21_, 48, 48, GDK_INTERP_BILINEAR);
#line 222 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 222 "../src/lib/notification.vala"
		pixbuf = _tmp22_;
#line 344 "notification.c"
	}
#line 225 "../src/lib/notification.vala"
	_tmp23_ = pixbuf;
#line 225 "../src/lib/notification.vala"
	_tmp24_ = gdk_pixbuf_copy (_tmp23_);
#line 225 "../src/lib/notification.vala"
	result = _tmp24_;
#line 225 "../src/lib/notification.vala"
	_g_object_unref0 (pixbuf);
#line 225 "../src/lib/notification.vala"
	return result;
#line 356 "notification.c"
}

/**
 * Taken from gnome-shell. Notification markup is always a mess, and this is cleaner
 * than our previous solution.
 */
static gchar*
budgie_notification_fix_markup (BudgieNotification* self,
                                const gchar* markup)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 232 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 232 "../src/lib/notification.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 233 "../src/lib/notification.vala"
	_tmp0_ = g_strdup (markup);
#line 233 "../src/lib/notification.vala"
	text = _tmp0_;
#line 379 "notification.c"
	{
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 236 "../src/lib/notification.vala"
		_tmp2_ = budgie_notification_entity_regex;
#line 236 "../src/lib/notification.vala"
		_tmp3_ = strlen (markup);
#line 236 "../src/lib/notification.vala"
		_tmp4_ = _tmp3_;
#line 236 "../src/lib/notification.vala"
		_tmp5_ = g_regex_replace (_tmp2_, markup, (gssize) _tmp4_, 0, "&amp;", 0, &_inner_error0_);
#line 236 "../src/lib/notification.vala"
		_tmp1_ = _tmp5_;
#line 236 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 407 "notification.c"
			goto __catch0_g_error;
		}
#line 236 "../src/lib/notification.vala"
		_tmp6_ = _tmp1_;
#line 236 "../src/lib/notification.vala"
		_tmp1_ = NULL;
#line 236 "../src/lib/notification.vala"
		_g_free0 (text);
#line 236 "../src/lib/notification.vala"
		text = _tmp6_;
#line 237 "../src/lib/notification.vala"
		_tmp8_ = budgie_notification_tag_regex;
#line 237 "../src/lib/notification.vala"
		_tmp9_ = text;
#line 237 "../src/lib/notification.vala"
		_tmp10_ = text;
#line 237 "../src/lib/notification.vala"
		_tmp11_ = strlen (_tmp10_);
#line 237 "../src/lib/notification.vala"
		_tmp12_ = _tmp11_;
#line 237 "../src/lib/notification.vala"
		_tmp13_ = g_regex_replace (_tmp8_, _tmp9_, (gssize) _tmp12_, 0, "&lt;", 0, &_inner_error0_);
#line 237 "../src/lib/notification.vala"
		_tmp7_ = _tmp13_;
#line 237 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "../src/lib/notification.vala"
			_g_free0 (_tmp1_);
#line 436 "notification.c"
			goto __catch0_g_error;
		}
#line 237 "../src/lib/notification.vala"
		_tmp14_ = _tmp7_;
#line 237 "../src/lib/notification.vala"
		_tmp7_ = NULL;
#line 237 "../src/lib/notification.vala"
		_g_free0 (text);
#line 237 "../src/lib/notification.vala"
		text = _tmp14_;
#line 235 "../src/lib/notification.vala"
		_g_free0 (_tmp7_);
#line 235 "../src/lib/notification.vala"
		_g_free0 (_tmp1_);
#line 451 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 235 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 235 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 239 "../src/lib/notification.vala"
		_tmp15_ = e;
#line 239 "../src/lib/notification.vala"
		_tmp16_ = _tmp15_->message;
#line 239 "../src/lib/notification.vala"
		g_warning ("notification.vala:239: Invalid regex: %s", _tmp16_);
#line 235 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 471 "notification.c"
	}
	__finally0:
#line 235 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../src/lib/notification.vala"
		_g_free0 (text);
#line 235 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 235 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 235 "../src/lib/notification.vala"
		return NULL;
#line 484 "notification.c"
	}
#line 242 "../src/lib/notification.vala"
	result = text;
#line 242 "../src/lib/notification.vala"
	return result;
#line 490 "notification.c"
}

GDesktopAppInfo*
budgie_notification_get_app_info (BudgieNotification* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 42 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_info;
#line 42 "../src/lib/notification.vala"
	result = _tmp0_;
#line 42 "../src/lib/notification.vala"
	return result;
#line 506 "notification.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/lib/notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 514 "notification.c"
}

static void
budgie_notification_set_app_info (BudgieNotification* self,
                                  GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 42 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_info (self);
#line 42 "../src/lib/notification.vala"
	if (old_value != value) {
#line 528 "notification.c"
		GDesktopAppInfo* _tmp0_;
#line 42 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 42 "../src/lib/notification.vala"
		self->priv->_app_info = _tmp0_;
#line 42 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY]);
#line 538 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_id (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_id;
#line 43 "../src/lib/notification.vala"
	result = _tmp0_;
#line 43 "../src/lib/notification.vala"
	return result;
#line 555 "notification.c"
}

static void
budgie_notification_set_app_id (BudgieNotification* self,
                                const gchar* value)
{
	gchar* old_value;
#line 43 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_id (self);
#line 43 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 569 "notification.c"
		gchar* _tmp0_;
#line 43 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_id);
#line 43 "../src/lib/notification.vala"
		self->priv->_app_id = _tmp0_;
#line 43 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY]);
#line 579 "notification.c"
	}
}

GNotificationPriority
budgie_notification_get_urgency (BudgieNotification* self)
{
	GNotificationPriority result;
#line 44 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/lib/notification.vala"
	result = self->priv->_urgency;
#line 44 "../src/lib/notification.vala"
	return result;
#line 593 "notification.c"
}

static void
budgie_notification_set_urgency (BudgieNotification* self,
                                 GNotificationPriority value)
{
	GNotificationPriority old_value;
#line 44 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/lib/notification.vala"
	old_value = budgie_notification_get_urgency (self);
#line 44 "../src/lib/notification.vala"
	if (old_value != value) {
#line 44 "../src/lib/notification.vala"
		self->priv->_urgency = value;
#line 44 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY]);
#line 611 "notification.c"
	}
}

guint32
budgie_notification_get_id (BudgieNotification* self)
{
	guint32 result;
#line 46 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../src/lib/notification.vala"
	result = self->priv->_id;
#line 46 "../src/lib/notification.vala"
	return result;
#line 625 "notification.c"
}

static void
budgie_notification_set_id (BudgieNotification* self,
                            guint32 value)
{
	guint32 old_value;
#line 46 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/lib/notification.vala"
	old_value = budgie_notification_get_id (self);
#line 46 "../src/lib/notification.vala"
	if (old_value != value) {
#line 46 "../src/lib/notification.vala"
		self->priv->_id = value;
#line 46 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY]);
#line 643 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_name (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_name;
#line 49 "../src/lib/notification.vala"
	result = _tmp0_;
#line 49 "../src/lib/notification.vala"
	return result;
#line 660 "notification.c"
}

static void
budgie_notification_set_app_name (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 49 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_name (self);
#line 49 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 674 "notification.c"
		gchar* _tmp0_;
#line 49 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_name);
#line 49 "../src/lib/notification.vala"
		self->priv->_app_name = _tmp0_;
#line 49 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY]);
#line 684 "notification.c"
	}
}

GHashTable*
budgie_notification_get_hints (BudgieNotification* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 50 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_hints;
#line 50 "../src/lib/notification.vala"
	result = _tmp0_;
#line 50 "../src/lib/notification.vala"
	return result;
#line 701 "notification.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 50 "../src/lib/notification.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 709 "notification.c"
}

static void
budgie_notification_set_hints (BudgieNotification* self,
                               GHashTable* value)
{
	GHashTable* old_value;
#line 50 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/lib/notification.vala"
	old_value = budgie_notification_get_hints (self);
#line 50 "../src/lib/notification.vala"
	if (old_value != value) {
#line 723 "notification.c"
		GHashTable* _tmp0_;
#line 50 "../src/lib/notification.vala"
		_tmp0_ = _g_hash_table_ref0 (value);
#line 50 "../src/lib/notification.vala"
		_g_hash_table_unref0 (self->priv->_hints);
#line 50 "../src/lib/notification.vala"
		self->priv->_hints = _tmp0_;
#line 50 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY]);
#line 733 "notification.c"
	}
}

gchar**
budgie_notification_get_actions (BudgieNotification* self,
                                 gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 51 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_actions;
#line 51 "../src/lib/notification.vala"
	_tmp0__length1 = self->priv->_actions_length1;
#line 51 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/lib/notification.vala"
	_tmp1__length1 = _tmp0__length1;
#line 51 "../src/lib/notification.vala"
	if (result_length1) {
#line 51 "../src/lib/notification.vala"
		*result_length1 = _tmp1__length1;
#line 760 "notification.c"
	}
#line 51 "../src/lib/notification.vala"
	result = _tmp1_;
#line 51 "../src/lib/notification.vala"
	return result;
#line 766 "notification.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 51 "../src/lib/notification.vala"
	if (length >= 0) {
#line 775 "notification.c"
		gchar** result;
		gssize i;
#line 51 "../src/lib/notification.vala"
		result = g_new0 (gchar*, length + 1);
#line 51 "../src/lib/notification.vala"
		for (i = 0; i < length; i++) {
#line 782 "notification.c"
			gchar* _tmp0_;
#line 51 "../src/lib/notification.vala"
			_tmp0_ = g_strdup (self[i]);
#line 51 "../src/lib/notification.vala"
			result[i] = _tmp0_;
#line 788 "notification.c"
		}
#line 51 "../src/lib/notification.vala"
		return result;
#line 792 "notification.c"
	}
#line 51 "../src/lib/notification.vala"
	return NULL;
#line 796 "notification.c"
}

static void
budgie_notification_set_actions (BudgieNotification* self,
                                 gchar** value,
                                 gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 51 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/lib/notification.vala"
	old_value = budgie_notification_get_actions (self, &old_value_length);
#line 51 "../src/lib/notification.vala"
	if (old_value != value) {
#line 812 "notification.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 51 "../src/lib/notification.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
#line 51 "../src/lib/notification.vala"
		_tmp0__length1 = value_length1;
#line 51 "../src/lib/notification.vala"
		self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/lib/notification.vala"
		self->priv->_actions = _tmp0_;
#line 51 "../src/lib/notification.vala"
		self->priv->_actions_length1 = _tmp0__length1;
#line 51 "../src/lib/notification.vala"
		self->priv->__actions_size_ = self->priv->_actions_length1;
#line 51 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY]);
#line 829 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_icon (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_icon;
#line 52 "../src/lib/notification.vala"
	result = _tmp0_;
#line 52 "../src/lib/notification.vala"
	return result;
#line 846 "notification.c"
}

static void
budgie_notification_set_app_icon (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 52 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_icon (self);
#line 52 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 860 "notification.c"
		gchar* _tmp0_;
#line 52 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_icon);
#line 52 "../src/lib/notification.vala"
		self->priv->_app_icon = _tmp0_;
#line 52 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ICON_PROPERTY]);
#line 870 "notification.c"
	}
}

const gchar*
budgie_notification_get_body (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_body;
#line 53 "../src/lib/notification.vala"
	result = _tmp0_;
#line 53 "../src/lib/notification.vala"
	return result;
#line 887 "notification.c"
}

void
budgie_notification_set_body (BudgieNotification* self,
                              const gchar* value)
{
	gchar* old_value;
#line 53 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/lib/notification.vala"
	old_value = budgie_notification_get_body (self);
#line 53 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 901 "notification.c"
		gchar* _tmp0_;
#line 53 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 53 "../src/lib/notification.vala"
		_g_free0 (self->priv->_body);
#line 53 "../src/lib/notification.vala"
		self->priv->_body = _tmp0_;
#line 53 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY]);
#line 911 "notification.c"
	}
}

const gchar*
budgie_notification_get_summary (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_summary;
#line 54 "../src/lib/notification.vala"
	result = _tmp0_;
#line 54 "../src/lib/notification.vala"
	return result;
#line 928 "notification.c"
}

void
budgie_notification_set_summary (BudgieNotification* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 54 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/lib/notification.vala"
	old_value = budgie_notification_get_summary (self);
#line 54 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 942 "notification.c"
		gchar* _tmp0_;
#line 54 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/lib/notification.vala"
		_g_free0 (self->priv->_summary);
#line 54 "../src/lib/notification.vala"
		self->priv->_summary = _tmp0_;
#line 54 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY]);
#line 952 "notification.c"
	}
}

guint
budgie_notification_get_expire_timeout (BudgieNotification* self)
{
	guint result;
#line 55 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/lib/notification.vala"
	result = self->priv->_expire_timeout;
#line 55 "../src/lib/notification.vala"
	return result;
#line 966 "notification.c"
}

void
budgie_notification_set_expire_timeout (BudgieNotification* self,
                                        guint value)
{
	guint old_value;
#line 55 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/lib/notification.vala"
	old_value = budgie_notification_get_expire_timeout (self);
#line 55 "../src/lib/notification.vala"
	if (old_value != value) {
#line 55 "../src/lib/notification.vala"
		self->priv->_expire_timeout = value;
#line 55 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY]);
#line 984 "notification.c"
	}
}

const gchar*
budgie_notification_get_category (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 57 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_category;
#line 57 "../src/lib/notification.vala"
	result = _tmp0_;
#line 57 "../src/lib/notification.vala"
	return result;
#line 1001 "notification.c"
}

void
budgie_notification_set_category (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 57 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/lib/notification.vala"
	old_value = budgie_notification_get_category (self);
#line 57 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1015 "notification.c"
		gchar* _tmp0_;
#line 57 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 57 "../src/lib/notification.vala"
		_g_free0 (self->priv->_category);
#line 57 "../src/lib/notification.vala"
		self->priv->_category = _tmp0_;
#line 57 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY]);
#line 1025 "notification.c"
	}
}

gint64
budgie_notification_get_timestamp (BudgieNotification* self)
{
	gint64 result;
#line 58 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 58 "../src/lib/notification.vala"
	result = self->priv->_timestamp;
#line 58 "../src/lib/notification.vala"
	return result;
#line 1039 "notification.c"
}

void
budgie_notification_set_timestamp (BudgieNotification* self,
                                   gint64 value)
{
	gint64 old_value;
#line 58 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/lib/notification.vala"
	old_value = budgie_notification_get_timestamp (self);
#line 58 "../src/lib/notification.vala"
	if (old_value != value) {
#line 58 "../src/lib/notification.vala"
		self->priv->_timestamp = value;
#line 58 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY]);
#line 1057 "notification.c"
	}
}

GtkImage*
budgie_notification_get_image (BudgieNotification* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 61 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_image;
#line 61 "../src/lib/notification.vala"
	result = _tmp0_;
#line 61 "../src/lib/notification.vala"
	return result;
#line 1074 "notification.c"
}

void
budgie_notification_set_image (BudgieNotification* self,
                               GtkImage* value)
{
	GtkImage* old_value;
#line 61 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/lib/notification.vala"
	old_value = budgie_notification_get_image (self);
#line 61 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1088 "notification.c"
		GtkImage* _tmp0_;
#line 61 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_image);
#line 61 "../src/lib/notification.vala"
		self->priv->_image = _tmp0_;
#line 61 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY]);
#line 1098 "notification.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1121 "notification.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1125 "notification.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1131 "notification.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1135 "notification.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1139 "notification.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1147 "notification.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1175 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1184 "notification.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1198 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1207 "notification.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1221 "notification.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1230 "notification.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1239 "notification.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 1258 "notification.c"
}

static GObject *
budgie_notification_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieNotification * self;
	GVariant* variant = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GHashTable* _tmp5_;
	gconstpointer _tmp6_;
	GVariant* _tmp7_;
	gboolean _tmp11_ = FALSE;
	GHashTable* _tmp12_;
	gconstpointer _tmp13_;
	GVariant* _tmp14_;
	gboolean _tmp19_ = FALSE;
	GHashTable* _tmp20_;
	gconstpointer _tmp21_;
	GVariant* _tmp22_;
	gboolean image_found = FALSE;
	gboolean _tmp35_ = FALSE;
	GHashTable* _tmp36_;
	gconstpointer _tmp37_;
	GVariant* _tmp38_;
	gboolean _tmp100_ = FALSE;
	const gchar* _tmp112_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/lib/notification.vala"
	parent_class = G_OBJECT_CLASS (budgie_notification_parent_class);
#line 97 "../src/lib/notification.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 97 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 98 "../src/lib/notification.vala"
	variant = NULL;
#line 99 "../src/lib/notification.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 99 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/lib/notification.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 99 "../src/lib/notification.vala"
	_tmp3_ = _tmp2_;
#line 99 "../src/lib/notification.vala"
	budgie_notification_set_timestamp (self, g_date_time_to_unix (_tmp3_));
#line 99 "../src/lib/notification.vala"
	_g_date_time_unref0 (_tmp3_);
#line 99 "../src/lib/notification.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 102 "../src/lib/notification.vala"
	_tmp5_ = self->priv->_hints;
#line 102 "../src/lib/notification.vala"
	_tmp6_ = g_hash_table_lookup (_tmp5_, "urgency");
#line 102 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp6_;
#line 102 "../src/lib/notification.vala"
	_tmp7_ = variant;
#line 102 "../src/lib/notification.vala"
	if (_tmp7_ != NULL) {
#line 1326 "notification.c"
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
#line 102 "../src/lib/notification.vala"
		_tmp8_ = variant;
#line 102 "../src/lib/notification.vala"
		_tmp9_ = G_VARIANT_TYPE_BYTE;
#line 102 "../src/lib/notification.vala"
		_tmp4_ = g_variant_is_of_type (_tmp8_, _tmp9_);
#line 1335 "notification.c"
	} else {
#line 102 "../src/lib/notification.vala"
		_tmp4_ = FALSE;
#line 1339 "notification.c"
	}
#line 102 "../src/lib/notification.vala"
	if (_tmp4_) {
#line 1343 "notification.c"
		GVariant* _tmp10_;
#line 103 "../src/lib/notification.vala"
		_tmp10_ = variant;
#line 103 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, (GNotificationPriority) g_variant_get_byte (_tmp10_));
#line 1349 "notification.c"
	}
#line 107 "../src/lib/notification.vala"
	_tmp12_ = self->priv->_hints;
#line 107 "../src/lib/notification.vala"
	_tmp13_ = g_hash_table_lookup (_tmp12_, "category");
#line 107 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp13_;
#line 107 "../src/lib/notification.vala"
	_tmp14_ = variant;
#line 107 "../src/lib/notification.vala"
	if (_tmp14_ != NULL) {
#line 1361 "notification.c"
		GVariant* _tmp15_;
		const GVariantType* _tmp16_;
#line 107 "../src/lib/notification.vala"
		_tmp15_ = variant;
#line 107 "../src/lib/notification.vala"
		_tmp16_ = G_VARIANT_TYPE_STRING;
#line 107 "../src/lib/notification.vala"
		_tmp11_ = g_variant_is_of_type (_tmp15_, _tmp16_);
#line 1370 "notification.c"
	} else {
#line 107 "../src/lib/notification.vala"
		_tmp11_ = FALSE;
#line 1374 "notification.c"
	}
#line 107 "../src/lib/notification.vala"
	if (_tmp11_) {
#line 1378 "notification.c"
		GVariant* _tmp17_;
		const gchar* _tmp18_;
#line 108 "../src/lib/notification.vala"
		_tmp17_ = variant;
#line 108 "../src/lib/notification.vala"
		_tmp18_ = g_variant_get_string (_tmp17_, NULL);
#line 108 "../src/lib/notification.vala"
		budgie_notification_set_category (self, _tmp18_);
#line 1387 "notification.c"
	}
#line 112 "../src/lib/notification.vala"
	_tmp20_ = self->priv->_hints;
#line 112 "../src/lib/notification.vala"
	_tmp21_ = g_hash_table_lookup (_tmp20_, "desktop-entry");
#line 112 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp21_;
#line 112 "../src/lib/notification.vala"
	_tmp22_ = variant;
#line 112 "../src/lib/notification.vala"
	if (_tmp22_ != NULL) {
#line 1399 "notification.c"
		GVariant* _tmp23_;
		const GVariantType* _tmp24_;
#line 112 "../src/lib/notification.vala"
		_tmp23_ = variant;
#line 112 "../src/lib/notification.vala"
		_tmp24_ = G_VARIANT_TYPE_STRING;
#line 112 "../src/lib/notification.vala"
		_tmp19_ = g_variant_is_of_type (_tmp23_, _tmp24_);
#line 1408 "notification.c"
	} else {
#line 112 "../src/lib/notification.vala"
		_tmp19_ = FALSE;
#line 1412 "notification.c"
	}
#line 112 "../src/lib/notification.vala"
	if (_tmp19_) {
#line 1416 "notification.c"
		GVariant* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GDesktopAppInfo* _tmp33_;
		GDesktopAppInfo* _tmp34_;
#line 113 "../src/lib/notification.vala"
		_tmp25_ = variant;
#line 113 "../src/lib/notification.vala"
		_tmp26_ = g_variant_get_string (_tmp25_, NULL);
#line 113 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, _tmp26_);
#line 114 "../src/lib/notification.vala"
		_tmp27_ = self->priv->_app_id;
#line 114 "../src/lib/notification.vala"
		_tmp28_ = string_replace (_tmp27_, ".desktop", "");
#line 114 "../src/lib/notification.vala"
		_tmp29_ = _tmp28_;
#line 114 "../src/lib/notification.vala"
		_g_free0 (_tmp29_);
#line 115 "../src/lib/notification.vala"
		_tmp30_ = self->priv->_app_id;
#line 115 "../src/lib/notification.vala"
		_tmp31_ = g_strdup_printf ("%s.desktop", _tmp30_);
#line 115 "../src/lib/notification.vala"
		_tmp32_ = _tmp31_;
#line 115 "../src/lib/notification.vala"
		_tmp33_ = g_desktop_app_info_new (_tmp32_);
#line 115 "../src/lib/notification.vala"
		_tmp34_ = _tmp33_;
#line 115 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, _tmp34_);
#line 115 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp34_);
#line 115 "../src/lib/notification.vala"
		_g_free0 (_tmp32_);
#line 1457 "notification.c"
	}
#line 118 "../src/lib/notification.vala"
	image_found = FALSE;
#line 122 "../src/lib/notification.vala"
	_tmp36_ = self->priv->_hints;
#line 122 "../src/lib/notification.vala"
	_tmp37_ = g_hash_table_lookup (_tmp36_, "image-data");
#line 122 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp37_;
#line 122 "../src/lib/notification.vala"
	_tmp38_ = variant;
#line 122 "../src/lib/notification.vala"
	if (_tmp38_ != NULL) {
#line 122 "../src/lib/notification.vala"
		_tmp35_ = TRUE;
#line 1473 "notification.c"
	} else {
		GHashTable* _tmp39_;
		gconstpointer _tmp40_;
		GVariant* _tmp41_;
#line 123 "../src/lib/notification.vala"
		_tmp39_ = self->priv->_hints;
#line 123 "../src/lib/notification.vala"
		_tmp40_ = g_hash_table_lookup (_tmp39_, "image_data");
#line 123 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp40_;
#line 123 "../src/lib/notification.vala"
		_tmp41_ = variant;
#line 123 "../src/lib/notification.vala"
		_tmp35_ = _tmp41_ != NULL;
#line 1488 "notification.c"
	}
#line 121 "../src/lib/notification.vala"
	if (_tmp35_) {
#line 1492 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp42_;
		GdkPixbuf* _tmp43_;
		GdkPixbuf* _tmp44_;
#line 125 "../src/lib/notification.vala"
		_tmp42_ = variant;
#line 125 "../src/lib/notification.vala"
		_tmp43_ = budgie_notification_decode_image (self, _tmp42_);
#line 125 "../src/lib/notification.vala"
		pixbuf = _tmp43_;
#line 126 "../src/lib/notification.vala"
		_tmp44_ = pixbuf;
#line 126 "../src/lib/notification.vala"
		if (_tmp44_ != NULL) {
#line 1507 "notification.c"
			GdkPixbuf* _tmp45_;
			GtkImage* _tmp46_;
			GtkImage* _tmp47_;
#line 127 "../src/lib/notification.vala"
			_tmp45_ = pixbuf;
#line 127 "../src/lib/notification.vala"
			_tmp46_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp45_);
#line 127 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp46_);
#line 127 "../src/lib/notification.vala"
			_tmp47_ = _tmp46_;
#line 127 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp47_);
#line 127 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp47_);
#line 128 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1525 "notification.c"
		}
#line 121 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 1529 "notification.c"
	}
#line 133 "../src/lib/notification.vala"
	if (!image_found) {
#line 1533 "notification.c"
		gboolean _tmp48_ = FALSE;
		GHashTable* _tmp49_;
		gconstpointer _tmp50_;
		GVariant* _tmp51_;
#line 135 "../src/lib/notification.vala"
		_tmp49_ = self->priv->_hints;
#line 135 "../src/lib/notification.vala"
		_tmp50_ = g_hash_table_lookup (_tmp49_, "image-path");
#line 135 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp50_;
#line 135 "../src/lib/notification.vala"
		_tmp51_ = variant;
#line 135 "../src/lib/notification.vala"
		if (_tmp51_ != NULL) {
#line 135 "../src/lib/notification.vala"
			_tmp48_ = TRUE;
#line 1550 "notification.c"
		} else {
			GHashTable* _tmp52_;
			gconstpointer _tmp53_;
			GVariant* _tmp54_;
#line 136 "../src/lib/notification.vala"
			_tmp52_ = self->priv->_hints;
#line 136 "../src/lib/notification.vala"
			_tmp53_ = g_hash_table_lookup (_tmp52_, "image_path");
#line 136 "../src/lib/notification.vala"
			variant = (GVariant*) _tmp53_;
#line 136 "../src/lib/notification.vala"
			_tmp54_ = variant;
#line 136 "../src/lib/notification.vala"
			_tmp48_ = _tmp54_ != NULL;
#line 1565 "notification.c"
		}
#line 134 "../src/lib/notification.vala"
		if (_tmp48_) {
#line 1569 "notification.c"
			gchar* path = NULL;
			GVariant* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gboolean _tmp58_ = FALSE;
			GtkIconTheme* _tmp59_;
			const gchar* _tmp60_;
#line 138 "../src/lib/notification.vala"
			_tmp55_ = variant;
#line 138 "../src/lib/notification.vala"
			_tmp56_ = g_variant_get_string (_tmp55_, NULL);
#line 138 "../src/lib/notification.vala"
			_tmp57_ = g_strdup (_tmp56_);
#line 138 "../src/lib/notification.vala"
			path = _tmp57_;
#line 140 "../src/lib/notification.vala"
			_tmp59_ = gtk_icon_theme_get_default ();
#line 140 "../src/lib/notification.vala"
			_tmp60_ = path;
#line 140 "../src/lib/notification.vala"
			if (gtk_icon_theme_has_icon (_tmp59_, _tmp60_)) {
#line 1591 "notification.c"
				const gchar* _tmp61_;
				const gchar* _tmp62_;
#line 140 "../src/lib/notification.vala"
				_tmp61_ = path;
#line 140 "../src/lib/notification.vala"
				_tmp62_ = self->priv->_app_icon;
#line 140 "../src/lib/notification.vala"
				_tmp58_ = g_strcmp0 (_tmp61_, _tmp62_) != 0;
#line 1600 "notification.c"
			} else {
#line 140 "../src/lib/notification.vala"
				_tmp58_ = FALSE;
#line 1604 "notification.c"
			}
#line 140 "../src/lib/notification.vala"
			if (_tmp58_) {
#line 1608 "notification.c"
				GThemedIcon* icon = NULL;
				const gchar* _tmp63_;
				GThemedIcon* _tmp64_;
				GThemedIcon* _tmp65_;
				GtkImage* _tmp66_;
				GtkImage* _tmp67_;
#line 141 "../src/lib/notification.vala"
				_tmp63_ = path;
#line 141 "../src/lib/notification.vala"
				_tmp64_ = (GThemedIcon*) g_themed_icon_new (_tmp63_);
#line 141 "../src/lib/notification.vala"
				icon = _tmp64_;
#line 142 "../src/lib/notification.vala"
				_tmp65_ = icon;
#line 142 "../src/lib/notification.vala"
				_tmp66_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp65_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 142 "../src/lib/notification.vala"
				g_object_ref_sink (_tmp66_);
#line 142 "../src/lib/notification.vala"
				_tmp67_ = _tmp66_;
#line 142 "../src/lib/notification.vala"
				budgie_notification_set_image (self, _tmp67_);
#line 142 "../src/lib/notification.vala"
				_g_object_unref0 (_tmp67_);
#line 143 "../src/lib/notification.vala"
				image_found = TRUE;
#line 140 "../src/lib/notification.vala"
				_g_object_unref0 (icon);
#line 1637 "notification.c"
			} else {
				gboolean _tmp68_ = FALSE;
				const gchar* _tmp69_;
#line 144 "../src/lib/notification.vala"
				_tmp69_ = path;
#line 144 "../src/lib/notification.vala"
				if (g_str_has_prefix (_tmp69_, "/")) {
#line 144 "../src/lib/notification.vala"
					_tmp68_ = TRUE;
#line 1647 "notification.c"
				} else {
					const gchar* _tmp70_;
#line 144 "../src/lib/notification.vala"
					_tmp70_ = path;
#line 144 "../src/lib/notification.vala"
					_tmp68_ = g_str_has_prefix (_tmp70_, "file://");
#line 1654 "notification.c"
				}
#line 144 "../src/lib/notification.vala"
				if (_tmp68_) {
#line 1658 "notification.c"
					{
						GdkPixbuf* pixbuf = NULL;
						const gchar* _tmp71_;
						GdkPixbuf* _tmp72_;
						GdkPixbuf* _tmp73_;
						GtkImage* _tmp74_;
						GtkImage* _tmp75_;
#line 146 "../src/lib/notification.vala"
						_tmp71_ = path;
#line 146 "../src/lib/notification.vala"
						_tmp72_ = gdk_pixbuf_new_from_file_at_size (_tmp71_, 48, 48, &_inner_error0_);
#line 146 "../src/lib/notification.vala"
						pixbuf = _tmp72_;
#line 146 "../src/lib/notification.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1674 "notification.c"
							goto __catch0_g_error;
						}
#line 147 "../src/lib/notification.vala"
						_tmp73_ = pixbuf;
#line 147 "../src/lib/notification.vala"
						_tmp74_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp73_);
#line 147 "../src/lib/notification.vala"
						g_object_ref_sink (_tmp74_);
#line 147 "../src/lib/notification.vala"
						_tmp75_ = _tmp74_;
#line 147 "../src/lib/notification.vala"
						budgie_notification_set_image (self, _tmp75_);
#line 147 "../src/lib/notification.vala"
						_g_object_unref0 (_tmp75_);
#line 148 "../src/lib/notification.vala"
						image_found = TRUE;
#line 145 "../src/lib/notification.vala"
						_g_object_unref0 (pixbuf);
#line 1693 "notification.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp76_;
						const gchar* _tmp77_;
#line 145 "../src/lib/notification.vala"
						e = _inner_error0_;
#line 145 "../src/lib/notification.vala"
						_inner_error0_ = NULL;
#line 150 "../src/lib/notification.vala"
						_tmp76_ = e;
#line 150 "../src/lib/notification.vala"
						_tmp77_ = _tmp76_->message;
#line 150 "../src/lib/notification.vala"
						g_critical ("notification.vala:150: Unable to get pixbuf from path: %s", _tmp77_);
#line 145 "../src/lib/notification.vala"
						_g_error_free0 (e);
#line 1713 "notification.c"
					}
					__finally0:
#line 145 "../src/lib/notification.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "../src/lib/notification.vala"
						_g_free0 (path);
#line 145 "../src/lib/notification.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../src/lib/notification.vala"
						g_clear_error (&_inner_error0_);
#line 1724 "notification.c"
					}
				}
			}
#line 134 "../src/lib/notification.vala"
			_g_free0 (path);
#line 1730 "notification.c"
		}
	}
#line 157 "../src/lib/notification.vala"
	if (!image_found) {
#line 1735 "notification.c"
		gboolean _tmp78_ = FALSE;
		const gchar* _tmp79_;
#line 158 "../src/lib/notification.vala"
		_tmp79_ = self->priv->_app_icon;
#line 158 "../src/lib/notification.vala"
		if (g_strcmp0 (_tmp79_, "") != 0) {
#line 1742 "notification.c"
			const gchar* _tmp80_;
#line 158 "../src/lib/notification.vala"
			_tmp80_ = self->priv->_app_icon;
#line 158 "../src/lib/notification.vala"
			_tmp78_ = !string_contains (_tmp80_, "/");
#line 1748 "notification.c"
		} else {
#line 158 "../src/lib/notification.vala"
			_tmp78_ = FALSE;
#line 1752 "notification.c"
		}
#line 158 "../src/lib/notification.vala"
		if (_tmp78_) {
#line 1756 "notification.c"
			const gchar* _tmp81_;
			GtkImage* _tmp82_;
			GtkImage* _tmp83_;
#line 159 "../src/lib/notification.vala"
			_tmp81_ = self->priv->_app_icon;
#line 159 "../src/lib/notification.vala"
			_tmp82_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp81_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 159 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp82_);
#line 159 "../src/lib/notification.vala"
			_tmp83_ = _tmp82_;
#line 159 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp83_);
#line 159 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp83_);
#line 160 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1774 "notification.c"
		} else {
			gboolean _tmp84_ = FALSE;
			const gchar* _tmp85_;
#line 161 "../src/lib/notification.vala"
			_tmp85_ = self->priv->_app_icon;
#line 161 "../src/lib/notification.vala"
			if (g_strcmp0 (_tmp85_, "") == 0) {
#line 1782 "notification.c"
				GDesktopAppInfo* _tmp86_;
#line 161 "../src/lib/notification.vala"
				_tmp86_ = self->priv->_app_info;
#line 161 "../src/lib/notification.vala"
				_tmp84_ = _tmp86_ != NULL;
#line 1788 "notification.c"
			} else {
#line 161 "../src/lib/notification.vala"
				_tmp84_ = FALSE;
#line 1792 "notification.c"
			}
#line 161 "../src/lib/notification.vala"
			if (_tmp84_) {
#line 1796 "notification.c"
				GDesktopAppInfo* _tmp87_;
				GIcon* _tmp88_;
				GtkImage* _tmp89_;
				GtkImage* _tmp90_;
#line 162 "../src/lib/notification.vala"
				_tmp87_ = self->priv->_app_info;
#line 162 "../src/lib/notification.vala"
				_tmp88_ = g_app_info_get_icon ((GAppInfo*) _tmp87_);
#line 162 "../src/lib/notification.vala"
				_tmp89_ = (GtkImage*) gtk_image_new_from_gicon (_tmp88_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 162 "../src/lib/notification.vala"
				g_object_ref_sink (_tmp89_);
#line 162 "../src/lib/notification.vala"
				_tmp90_ = _tmp89_;
#line 162 "../src/lib/notification.vala"
				budgie_notification_set_image (self, _tmp90_);
#line 162 "../src/lib/notification.vala"
				_g_object_unref0 (_tmp90_);
#line 163 "../src/lib/notification.vala"
				image_found = TRUE;
#line 1817 "notification.c"
			} else {
				const gchar* _tmp91_;
#line 164 "../src/lib/notification.vala"
				_tmp91_ = self->priv->_app_icon;
#line 164 "../src/lib/notification.vala"
				if (string_contains (_tmp91_, "/")) {
#line 1824 "notification.c"
					GFile* file = NULL;
					const gchar* _tmp92_;
					GFile* _tmp93_;
					GFile* _tmp94_;
#line 165 "../src/lib/notification.vala"
					_tmp92_ = self->priv->_app_icon;
#line 165 "../src/lib/notification.vala"
					_tmp93_ = g_file_new_for_uri (_tmp92_);
#line 165 "../src/lib/notification.vala"
					file = _tmp93_;
#line 166 "../src/lib/notification.vala"
					_tmp94_ = file;
#line 166 "../src/lib/notification.vala"
					if (g_file_query_exists (_tmp94_, NULL)) {
#line 1839 "notification.c"
						GFileIcon* icon = NULL;
						GFile* _tmp95_;
						GFileIcon* _tmp96_;
						GFileIcon* _tmp97_;
						GtkImage* _tmp98_;
						GtkImage* _tmp99_;
#line 167 "../src/lib/notification.vala"
						_tmp95_ = file;
#line 167 "../src/lib/notification.vala"
						_tmp96_ = (GFileIcon*) g_file_icon_new (_tmp95_);
#line 167 "../src/lib/notification.vala"
						icon = _tmp96_;
#line 168 "../src/lib/notification.vala"
						_tmp97_ = icon;
#line 168 "../src/lib/notification.vala"
						_tmp98_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp97_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 168 "../src/lib/notification.vala"
						g_object_ref_sink (_tmp98_);
#line 168 "../src/lib/notification.vala"
						_tmp99_ = _tmp98_;
#line 168 "../src/lib/notification.vala"
						budgie_notification_set_image (self, _tmp99_);
#line 168 "../src/lib/notification.vala"
						_g_object_unref0 (_tmp99_);
#line 169 "../src/lib/notification.vala"
						image_found = TRUE;
#line 166 "../src/lib/notification.vala"
						_g_object_unref0 (icon);
#line 1868 "notification.c"
					}
#line 164 "../src/lib/notification.vala"
					_g_object_unref0 (file);
#line 1872 "notification.c"
				}
			}
		}
	}
#line 175 "../src/lib/notification.vala"
	if (!image_found) {
#line 1879 "notification.c"
		GHashTable* _tmp101_;
		gconstpointer _tmp102_;
		GVariant* _tmp103_;
#line 175 "../src/lib/notification.vala"
		_tmp101_ = self->priv->_hints;
#line 175 "../src/lib/notification.vala"
		_tmp102_ = g_hash_table_lookup (_tmp101_, "icon_data");
#line 175 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp102_;
#line 175 "../src/lib/notification.vala"
		_tmp103_ = variant;
#line 175 "../src/lib/notification.vala"
		_tmp100_ = _tmp103_ != NULL;
#line 1893 "notification.c"
	} else {
#line 175 "../src/lib/notification.vala"
		_tmp100_ = FALSE;
#line 1897 "notification.c"
	}
#line 175 "../src/lib/notification.vala"
	if (_tmp100_) {
#line 1901 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp104_;
		GdkPixbuf* _tmp105_;
		GdkPixbuf* _tmp106_;
#line 176 "../src/lib/notification.vala"
		_tmp104_ = variant;
#line 176 "../src/lib/notification.vala"
		_tmp105_ = budgie_notification_decode_image (self, _tmp104_);
#line 176 "../src/lib/notification.vala"
		pixbuf = _tmp105_;
#line 177 "../src/lib/notification.vala"
		_tmp106_ = pixbuf;
#line 177 "../src/lib/notification.vala"
		if (_tmp106_ != NULL) {
#line 1916 "notification.c"
			GdkPixbuf* _tmp107_;
			GtkImage* _tmp108_;
			GtkImage* _tmp109_;
#line 178 "../src/lib/notification.vala"
			_tmp107_ = pixbuf;
#line 178 "../src/lib/notification.vala"
			_tmp108_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp107_);
#line 178 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp108_);
#line 178 "../src/lib/notification.vala"
			_tmp109_ = _tmp108_;
#line 178 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp109_);
#line 178 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp109_);
#line 179 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1934 "notification.c"
		}
#line 175 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 1938 "notification.c"
	}
#line 184 "../src/lib/notification.vala"
	if (!image_found) {
#line 1942 "notification.c"
		GtkImage* _tmp110_;
		GtkImage* _tmp111_;
#line 185 "../src/lib/notification.vala"
		_tmp110_ = (GtkImage*) gtk_image_new_from_icon_name ("mail-unread-symbolic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 185 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp110_);
#line 185 "../src/lib/notification.vala"
		_tmp111_ = _tmp110_;
#line 185 "../src/lib/notification.vala"
		budgie_notification_set_image (self, _tmp111_);
#line 185 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp111_);
#line 1955 "notification.c"
	}
#line 190 "../src/lib/notification.vala"
	_tmp112_ = self->priv->_body;
#line 190 "../src/lib/notification.vala"
	if (g_strcmp0 (_tmp112_, "") == 0) {
#line 1961 "notification.c"
		const gchar* _tmp113_;
		gchar* _tmp114_;
		gchar* _tmp115_;
		const gchar* _tmp116_;
#line 191 "../src/lib/notification.vala"
		_tmp113_ = self->priv->_summary;
#line 191 "../src/lib/notification.vala"
		_tmp114_ = budgie_notification_fix_markup (self, _tmp113_);
#line 191 "../src/lib/notification.vala"
		_tmp115_ = _tmp114_;
#line 191 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp115_);
#line 191 "../src/lib/notification.vala"
		_g_free0 (_tmp115_);
#line 192 "../src/lib/notification.vala"
		_tmp116_ = self->priv->_app_name;
#line 192 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp116_);
#line 1980 "notification.c"
	} else {
		const gchar* _tmp117_;
		gchar* _tmp118_;
		gchar* _tmp119_;
		const gchar* _tmp120_;
		gchar* _tmp121_;
		gchar* _tmp122_;
#line 194 "../src/lib/notification.vala"
		_tmp117_ = self->priv->_body;
#line 194 "../src/lib/notification.vala"
		_tmp118_ = budgie_notification_fix_markup (self, _tmp117_);
#line 194 "../src/lib/notification.vala"
		_tmp119_ = _tmp118_;
#line 194 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp119_);
#line 194 "../src/lib/notification.vala"
		_g_free0 (_tmp119_);
#line 195 "../src/lib/notification.vala"
		_tmp120_ = self->priv->_summary;
#line 195 "../src/lib/notification.vala"
		_tmp121_ = budgie_notification_fix_markup (self, _tmp120_);
#line 195 "../src/lib/notification.vala"
		_tmp122_ = _tmp121_;
#line 195 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp122_);
#line 195 "../src/lib/notification.vala"
		_g_free0 (_tmp122_);
#line 2008 "notification.c"
	}
#line 97 "../src/lib/notification.vala"
	return obj;
#line 2012 "notification.c"
}

static void
budgie_notification_class_init (BudgieNotificationClass * klass,
                                gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 41 "../src/lib/notification.vala"
	budgie_notification_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/lib/notification.vala"
	g_type_class_adjust_private_offset (klass, &BudgieNotification_private_offset);
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_notification_get_property;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_notification_set_property;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_notification_constructor;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_notification_finalize;
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_INFO_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_URGENCY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY] = g_param_spec_enum ("urgency", "urgency", "urgency", g_notification_priority_get_type (), G_NOTIFICATION_PRIORITY_NORMAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_NAME_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_HINTS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY] = g_param_spec_boxed ("hints", "hints", "hints", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ACTIONS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY] = g_param_spec_boxed ("actions", "actions", "actions", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_ICON_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ICON_PROPERTY] = g_param_spec_string ("app-icon", "app-icon", "app-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_BODY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_SUMMARY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY] = g_param_spec_string ("summary", "summary", "summary", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY] = g_param_spec_uint ("expire-timeout", "expire-timeout", "expire-timeout", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_CATEGORY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY] = g_param_spec_int64 ("timestamp", "timestamp", "timestamp", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_IMAGE_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY] = g_param_spec_object ("image", "image", "image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2060 "notification.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
#line 90 "../src/lib/notification.vala"
		_tmp1_ = g_regex_new ("&(?!amp;|quot;|apos;|lt;|gt;|#39;|nbsp;)", 0, 0, &_inner_error0_);
#line 90 "../src/lib/notification.vala"
		_tmp0_ = _tmp1_;
#line 90 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2074 "notification.c"
			goto __catch0_g_error;
		}
#line 90 "../src/lib/notification.vala"
		_tmp2_ = _tmp0_;
#line 90 "../src/lib/notification.vala"
		_tmp0_ = NULL;
#line 90 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_entity_regex);
#line 90 "../src/lib/notification.vala"
		budgie_notification_entity_regex = _tmp2_;
#line 91 "../src/lib/notification.vala"
		_tmp4_ = g_regex_new ("<(?!\\/?[biu]>)", 0, 0, &_inner_error0_);
#line 91 "../src/lib/notification.vala"
		_tmp3_ = _tmp4_;
#line 91 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/lib/notification.vala"
			_g_regex_unref0 (_tmp0_);
#line 2093 "notification.c"
			goto __catch0_g_error;
		}
#line 91 "../src/lib/notification.vala"
		_tmp5_ = _tmp3_;
#line 91 "../src/lib/notification.vala"
		_tmp3_ = NULL;
#line 91 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_tag_regex);
#line 91 "../src/lib/notification.vala"
		budgie_notification_tag_regex = _tmp5_;
#line 89 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp3_);
#line 89 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp0_);
#line 2108 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 89 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 89 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 93 "../src/lib/notification.vala"
		_tmp6_ = e;
#line 93 "../src/lib/notification.vala"
		_tmp7_ = _tmp6_->message;
#line 93 "../src/lib/notification.vala"
		g_warning ("notification.vala:93: Invalid notificiation regex: %s", _tmp7_);
#line 89 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 2128 "notification.c"
	}
	__finally0:
#line 89 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 2137 "notification.c"
	}
}

static void
budgie_notification_instance_init (BudgieNotification * self,
                                   gpointer klass)
{
#line 41 "../src/lib/notification.vala"
	self->priv = budgie_notification_get_instance_private (self);
#line 42 "../src/lib/notification.vala"
	self->priv->_app_info = NULL;
#line 44 "../src/lib/notification.vala"
	self->priv->_urgency = G_NOTIFICATION_PRIORITY_NORMAL;
#line 61 "../src/lib/notification.vala"
	self->priv->_image = NULL;
#line 2153 "notification.c"
}

static void
budgie_notification_finalize (GObject * obj)
{
	BudgieNotification * self;
#line 41 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 42 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 43 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_id);
#line 49 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_name);
#line 50 "../src/lib/notification.vala"
	_g_hash_table_unref0 (self->priv->_hints);
#line 51 "../src/lib/notification.vala"
	self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 52 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_icon);
#line 53 "../src/lib/notification.vala"
	_g_free0 (self->priv->_body);
#line 54 "../src/lib/notification.vala"
	_g_free0 (self->priv->_summary);
#line 57 "../src/lib/notification.vala"
	_g_free0 (self->priv->_category);
#line 61 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_image);
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (budgie_notification_parent_class)->finalize (obj);
#line 2184 "notification.c"
}

/**
 * This is our wrapper class for a FreeDesktop notification.
 */
static GType
budgie_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotification), 0, (GInstanceInitFunc) budgie_notification_instance_init, NULL };
	GType budgie_notification_type_id;
	budgie_notification_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieNotification", &g_define_type_info, 0);
	BudgieNotification_private_offset = g_type_add_instance_private (budgie_notification_type_id, sizeof (BudgieNotificationPrivate));
	return budgie_notification_type_id;
}

GType
budgie_notification_get_type (void)
{
	static volatile gsize budgie_notification_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_type_id__once)) {
		GType budgie_notification_type_id;
		budgie_notification_type_id = budgie_notification_get_type_once ();
		g_once_init_leave (&budgie_notification_type_id__once, budgie_notification_type_id);
	}
	return budgie_notification_type_id__once;
}

static void
_vala_budgie_notification_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 41 "../src/lib/notification.vala"
	switch (property_id) {
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_app_info (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_id (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_enum (value, budgie_notification_get_urgency (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_id (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_name (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_boxed (value, budgie_notification_get_hints (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2260 "notification.c"
		{
			int length;
#line 41 "../src/lib/notification.vala"
			g_value_set_boxed (value, budgie_notification_get_actions (self, &length));
#line 2265 "notification.c"
		}
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ICON_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_icon (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_body (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_summary (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_expire_timeout (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_category (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_int64 (value, budgie_notification_get_timestamp (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_image (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 2311 "notification.c"
		default:
#line 41 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/lib/notification.vala"
		break;
#line 2317 "notification.c"
	}
}

static void
_vala_budgie_notification_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 41 "../src/lib/notification.vala"
	switch (property_id) {
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, g_value_get_enum (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_id (self, g_value_get_uint (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_name (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_hints (self, g_value_get_boxed (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2369 "notification.c"
		{
			gpointer boxed;
#line 41 "../src/lib/notification.vala"
			boxed = g_value_get_boxed (value);
#line 41 "../src/lib/notification.vala"
			budgie_notification_set_actions (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2376 "notification.c"
		}
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ICON_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_icon (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_body (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_expire_timeout (self, g_value_get_uint (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_category (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_timestamp (self, g_value_get_int64 (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_image (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 2422 "notification.c"
		default:
#line 41 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/lib/notification.vala"
		break;
#line 2428 "notification.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

