/* notifications_group.c generated by valac 0.56.12, the Vala compiler
 * generated from notifications_group.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "raven.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include "budgie-private.h"
#include <pango/pango.h>

enum  {
	BUDGIE_NOTIFICATION_GROUP_0_PROPERTY,
	BUDGIE_NOTIFICATION_GROUP_APP_NAME_PROPERTY,
	BUDGIE_NOTIFICATION_GROUP_APP_ICON_PROPERTY,
	BUDGIE_NOTIFICATION_GROUP_TOKEEP_PROPERTY,
	BUDGIE_NOTIFICATION_GROUP_NOTI_SORT_MODE_PROPERTY,
	BUDGIE_NOTIFICATION_GROUP_NOTI_COUNT_PROPERTY,
	BUDGIE_NOTIFICATION_GROUP_NUM_PROPERTIES
};
static GParamSpec* budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
enum  {
	BUDGIE_NOTIFICATION_GROUP_DISMISSED_GROUP_SIGNAL,
	BUDGIE_NOTIFICATION_GROUP_DISMISSED_NOTIFICATION_SIGNAL,
	BUDGIE_NOTIFICATION_GROUP_NUM_SIGNALS
};
static guint budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_NUM_SIGNALS] = {0};

struct _BudgieNotificationGroupPrivate {
	GHashTable* notifications;
	GtkLabel* name_label;
	GtkButton* dismiss_button;
	GtkListBox* noti_box;
	gchar* _app_name;
	gchar* _app_icon;
	guint _tokeep;
	BudgieNotificationSort _noti_sort_mode;
	gint _noti_count;
};

struct _Block2Data {
	int _ref_count_;
	BudgieNotificationGroup* self;
	BudgieNotification* notification;
};

static gint BudgieNotificationGroup_private_offset;
static gpointer budgie_notification_group_parent_class = NULL;

static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void budgie_notification_group_update_count (BudgieNotificationGroup* self);
static void __lambda9_ (Block2Data* _data2_);
static void ___lambda9__notification_widget_closed_individually (NotificationWidget* _sender,
                                                          gpointer self);
static gboolean __lambda10_ (BudgieNotificationGroup* self,
                      guint32 id,
                      NotificationWidget* widget);
static gboolean ___lambda10__ghr_func (gconstpointer key,
                                gconstpointer value,
                                gpointer self);
static gint __lambda8_ (guint32 a,
                 guint32 b);
static gint ___lambda8__gcompare_func (gconstpointer a,
                                gconstpointer b);
static void budgie_notification_group_set_noti_count (BudgieNotificationGroup* self,
                                               gint value);
static gint budgie_notification_group_sort_notifications (BudgieNotificationGroup* self,
                                                   GtkListBoxRow* a,
                                                   GtkListBoxRow* b);
static GObject * budgie_notification_group_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static gint _budgie_notification_group_sort_notifications_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                           GtkListBoxRow* row2,
                                                                           gpointer self);
static void _budgie_notification_group_dismiss_all_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void budgie_notification_group_finalize (GObject * obj);
static GType budgie_notification_group_get_type_once (void);
static void _vala_budgie_notification_group_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_budgie_notification_group_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
budgie_notification_group_get_instance_private (BudgieNotificationGroup* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieNotificationGroup_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 131 "notifications_group.c"
}

BudgieNotificationGroup*
budgie_notification_group_construct (GType object_type,
                                     const gchar* c_app_icon,
                                     const gchar* c_app_name,
                                     BudgieNotificationSort sort_mode,
                                     guint keep)
{
	BudgieNotificationGroup * self = NULL;
	gchar* name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
#line 88 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (c_app_icon != NULL, NULL);
#line 88 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (c_app_name != NULL, NULL);
#line 89 "../src/raven/notifications_group.vala"
	_tmp0_ = g_strdup (c_app_name);
#line 89 "../src/raven/notifications_group.vala"
	name = _tmp0_;
#line 91 "../src/raven/notifications_group.vala"
	_tmp2_ = name;
#line 91 "../src/raven/notifications_group.vala"
	if (string_contains (_tmp2_, "budgie")) {
#line 91 "../src/raven/notifications_group.vala"
		_tmp1_ = string_contains (c_app_icon, "caffeine");
#line 161 "notifications_group.c"
	} else {
#line 91 "../src/raven/notifications_group.vala"
		_tmp1_ = FALSE;
#line 165 "notifications_group.c"
	}
#line 91 "../src/raven/notifications_group.vala"
	if (_tmp1_) {
#line 169 "notifications_group.c"
		gchar* _tmp3_;
#line 92 "../src/raven/notifications_group.vala"
		_tmp3_ = g_strdup (_ ("Caffeine Mode"));
#line 92 "../src/raven/notifications_group.vala"
		_g_free0 (name);
#line 92 "../src/raven/notifications_group.vala"
		name = _tmp3_;
#line 177 "notifications_group.c"
	}
#line 95 "../src/raven/notifications_group.vala"
	_tmp4_ = name;
#line 95 "../src/raven/notifications_group.vala"
	self = (BudgieNotificationGroup*) g_object_new (object_type, "app-name", _tmp4_, "app-icon", c_app_icon, "tokeep", keep, "noti-sort-mode", sort_mode, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 4, NULL);
#line 88 "../src/raven/notifications_group.vala"
	_g_free0 (name);
#line 88 "../src/raven/notifications_group.vala"
	return self;
#line 187 "notifications_group.c"
}

BudgieNotificationGroup*
budgie_notification_group_new (const gchar* c_app_icon,
                               const gchar* c_app_name,
                               BudgieNotificationSort sort_mode,
                               guint keep)
{
#line 88 "../src/raven/notifications_group.vala"
	return budgie_notification_group_construct (BUDGIE_TYPE_NOTIFICATION_GROUP, c_app_icon, c_app_name, sort_mode, keep);
#line 198 "notifications_group.c"
}

/**
 * add_notification is responsible for adding a notification (if it doesn't exist) and updating our counter
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 108 "../src/raven/notifications_group.vala"
	return self ? g_object_ref (self) : NULL;
#line 209 "notifications_group.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 108 "../src/raven/notifications_group.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 108 "../src/raven/notifications_group.vala"
	return _data2_;
#line 219 "notifications_group.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 108 "../src/raven/notifications_group.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 229 "notifications_group.c"
		BudgieNotificationGroup* self;
#line 108 "../src/raven/notifications_group.vala"
		self = _data2_->self;
#line 108 "../src/raven/notifications_group.vala"
		_g_object_unref0 (_data2_->notification);
#line 108 "../src/raven/notifications_group.vala"
		_g_object_unref0 (self);
#line 108 "../src/raven/notifications_group.vala"
		g_slice_free (Block2Data, _data2_);
#line 239 "notifications_group.c"
	}
}

static void
__lambda9_ (Block2Data* _data2_)
{
	BudgieNotificationGroup* self;
	guint n_id = 0U;
	guint32 _tmp0_;
	guint32 _tmp1_;
#line 120 "../src/raven/notifications_group.vala"
	self = _data2_->self;
#line 121 "../src/raven/notifications_group.vala"
	_tmp0_ = budgie_notification_get_id (_data2_->notification);
#line 121 "../src/raven/notifications_group.vala"
	_tmp1_ = _tmp0_;
#line 121 "../src/raven/notifications_group.vala"
	n_id = (guint) _tmp1_;
#line 122 "../src/raven/notifications_group.vala"
	budgie_notification_group_remove_notification (self, (guint32) n_id);
#line 123 "../src/raven/notifications_group.vala"
	g_signal_emit (self, budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_NOTIFICATION_SIGNAL], 0, (guint32) n_id);
#line 262 "notifications_group.c"
}

static void
___lambda9__notification_widget_closed_individually (NotificationWidget* _sender,
                                                     gpointer self)
{
#line 120 "../src/raven/notifications_group.vala"
	__lambda9_ (self);
#line 271 "notifications_group.c"
}

void
budgie_notification_group_add_notification (BudgieNotificationGroup* self,
                                            guint32 id,
                                            BudgieNotification* notification)
{
	Block2Data* _data2_;
	BudgieNotification* _tmp0_;
	GHashTable* _tmp1_;
	NotificationWidget* widget = NULL;
	NotificationWidget* _tmp2_;
	GHashTable* _tmp3_;
	NotificationWidget* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
#line 108 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/raven/notifications_group.vala"
	g_return_if_fail (notification != NULL);
#line 108 "../src/raven/notifications_group.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 108 "../src/raven/notifications_group.vala"
	_data2_->_ref_count_ = 1;
#line 108 "../src/raven/notifications_group.vala"
	_data2_->self = g_object_ref (self);
#line 108 "../src/raven/notifications_group.vala"
	_tmp0_ = _g_object_ref0 (notification);
#line 108 "../src/raven/notifications_group.vala"
	_g_object_unref0 (_data2_->notification);
#line 108 "../src/raven/notifications_group.vala"
	_data2_->notification = _tmp0_;
#line 109 "../src/raven/notifications_group.vala"
	_tmp1_ = self->priv->notifications;
#line 109 "../src/raven/notifications_group.vala"
	if (g_hash_table_contains (_tmp1_, (gpointer) ((guintptr) id))) {
#line 110 "../src/raven/notifications_group.vala"
		budgie_notification_group_remove_notification (self, id);
#line 310 "notifications_group.c"
	}
#line 113 "../src/raven/notifications_group.vala"
	_tmp2_ = notification_widget_new (_data2_->notification);
#line 113 "../src/raven/notifications_group.vala"
	g_object_ref_sink (_tmp2_);
#line 113 "../src/raven/notifications_group.vala"
	widget = _tmp2_;
#line 114 "../src/raven/notifications_group.vala"
	_tmp3_ = self->priv->notifications;
#line 114 "../src/raven/notifications_group.vala"
	_tmp4_ = _g_object_ref0 (widget);
#line 114 "../src/raven/notifications_group.vala"
	g_hash_table_insert (_tmp3_, (gpointer) ((guintptr) id), _tmp4_);
#line 115 "../src/raven/notifications_group.vala"
	_tmp5_ = self->priv->noti_box;
#line 115 "../src/raven/notifications_group.vala"
	gtk_list_box_prepend (_tmp5_, (GtkWidget*) widget);
#line 117 "../src/raven/notifications_group.vala"
	_tmp6_ = self->priv->noti_box;
#line 117 "../src/raven/notifications_group.vala"
	gtk_list_box_invalidate_sort (_tmp6_);
#line 118 "../src/raven/notifications_group.vala"
	budgie_notification_group_update_count (self);
#line 120 "../src/raven/notifications_group.vala"
	g_signal_connect_data (widget, "closed-individually", (GCallback) ___lambda9__notification_widget_closed_individually, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 108 "../src/raven/notifications_group.vala"
	_g_object_unref0 (widget);
#line 108 "../src/raven/notifications_group.vala"
	block2_data_unref (_data2_);
#line 108 "../src/raven/notifications_group.vala"
	_data2_ = NULL;
#line 342 "notifications_group.c"
}

/**
 * dismiss_all is responsible for dismissing all notifications
 */
static gboolean
__lambda10_ (BudgieNotificationGroup* self,
             guint32 id,
             NotificationWidget* widget)
{
	gboolean result;
#line 131 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 132 "../src/raven/notifications_group.vala"
	gtk_widget_destroy ((GtkWidget*) widget);
#line 133 "../src/raven/notifications_group.vala"
	g_signal_emit (self, budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_NOTIFICATION_SIGNAL], 0, id);
#line 134 "../src/raven/notifications_group.vala"
	result = TRUE;
#line 134 "../src/raven/notifications_group.vala"
	return result;
#line 364 "notifications_group.c"
}

static gboolean
___lambda10__ghr_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
	gboolean result;
	result = __lambda10_ ((BudgieNotificationGroup*) self, (guint32) ((guintptr) key), (NotificationWidget*) value);
#line 131 "../src/raven/notifications_group.vala"
	return result;
#line 376 "notifications_group.c"
}

void
budgie_notification_group_dismiss_all (BudgieNotificationGroup* self)
{
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
#line 130 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->notifications;
#line 131 "../src/raven/notifications_group.vala"
	g_hash_table_foreach_remove (_tmp0_, ___lambda10__ghr_func, self);
#line 137 "../src/raven/notifications_group.vala"
	budgie_notification_group_update_count (self);
#line 138 "../src/raven/notifications_group.vala"
	_tmp1_ = self->priv->_app_name;
#line 138 "../src/raven/notifications_group.vala"
	g_signal_emit (self, budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_GROUP_SIGNAL], 0, _tmp1_);
#line 396 "notifications_group.c"
}

/**
 * remove_notification is responsible for removing a notification (if it exists) and updating our counter
 */
void
budgie_notification_group_remove_notification (BudgieNotificationGroup* self,
                                               guint32 id)
{
	NotificationWidget* widget = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	NotificationWidget* _tmp2_;
	NotificationWidget* _tmp3_;
#line 144 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->notifications;
#line 145 "../src/raven/notifications_group.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((guintptr) id));
#line 145 "../src/raven/notifications_group.vala"
	_tmp2_ = _g_object_ref0 ((NotificationWidget*) _tmp1_);
#line 145 "../src/raven/notifications_group.vala"
	widget = _tmp2_;
#line 147 "../src/raven/notifications_group.vala"
	_tmp3_ = widget;
#line 147 "../src/raven/notifications_group.vala"
	if (_tmp3_ != NULL) {
#line 425 "notifications_group.c"
		GHashTable* _tmp4_;
		NotificationWidget* _tmp5_;
		GtkListBox* _tmp6_;
		gint _tmp7_;
#line 148 "../src/raven/notifications_group.vala"
		_tmp4_ = self->priv->notifications;
#line 148 "../src/raven/notifications_group.vala"
		g_hash_table_remove (_tmp4_, (gpointer) ((guintptr) id));
#line 150 "../src/raven/notifications_group.vala"
		_tmp5_ = widget;
#line 150 "../src/raven/notifications_group.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 152 "../src/raven/notifications_group.vala"
		_tmp6_ = self->priv->noti_box;
#line 152 "../src/raven/notifications_group.vala"
		gtk_list_box_invalidate_sort (_tmp6_);
#line 153 "../src/raven/notifications_group.vala"
		budgie_notification_group_update_count (self);
#line 154 "../src/raven/notifications_group.vala"
		g_signal_emit (self, budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_NOTIFICATION_SIGNAL], 0, id);
#line 156 "../src/raven/notifications_group.vala"
		_tmp7_ = self->priv->_noti_count;
#line 156 "../src/raven/notifications_group.vala"
		if (_tmp7_ == 0) {
#line 450 "notifications_group.c"
			const gchar* _tmp8_;
#line 157 "../src/raven/notifications_group.vala"
			_tmp8_ = self->priv->_app_name;
#line 157 "../src/raven/notifications_group.vala"
			g_signal_emit (self, budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_GROUP_SIGNAL], 0, _tmp8_);
#line 456 "notifications_group.c"
		}
	}
#line 144 "../src/raven/notifications_group.vala"
	_g_object_unref0 (widget);
#line 461 "notifications_group.c"
}

/**
 * too many notifications will choke raven and the desktop, so let's set a limit;
 * keep the latest n-notifications of current group, delete older ones
 */
static gint
__lambda8_ (guint32 a,
            guint32 b)
{
	gint result;
#line 170 "../src/raven/notifications_group.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 170 "../src/raven/notifications_group.vala"
	return result;
#line 477 "notifications_group.c"
}

static gint
___lambda8__gcompare_func (gconstpointer a,
                           gconstpointer b)
{
	gint result;
	result = __lambda8_ ((guint32) ((guintptr) a), (guint32) ((guintptr) b));
#line 169 "../src/raven/notifications_group.vala"
	return result;
#line 488 "notifications_group.c"
}

void
budgie_notification_group_limit_notifications (BudgieNotificationGroup* self)
{
	GList* currnotifs = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	guint n_currnotifs = 0U;
	GList* _tmp2_;
	guint _tmp3_;
	guint n_remove = 0U;
	guint _tmp4_;
	gint count = 0;
	GList* _tmp5_;
#line 166 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->notifications;
#line 167 "../src/raven/notifications_group.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 167 "../src/raven/notifications_group.vala"
	currnotifs = _tmp1_;
#line 169 "../src/raven/notifications_group.vala"
	currnotifs = g_list_sort (currnotifs, ___lambda8__gcompare_func);
#line 173 "../src/raven/notifications_group.vala"
	_tmp2_ = currnotifs;
#line 173 "../src/raven/notifications_group.vala"
	n_currnotifs = g_list_length (_tmp2_);
#line 179 "../src/raven/notifications_group.vala"
	_tmp3_ = self->priv->_tokeep;
#line 179 "../src/raven/notifications_group.vala"
	if (n_currnotifs <= _tmp3_) {
#line 179 "../src/raven/notifications_group.vala"
		(currnotifs == NULL) ? NULL : (currnotifs = (g_list_free (currnotifs), NULL));
#line 179 "../src/raven/notifications_group.vala"
		return;
#line 526 "notifications_group.c"
	}
#line 180 "../src/raven/notifications_group.vala"
	_tmp4_ = self->priv->_tokeep;
#line 180 "../src/raven/notifications_group.vala"
	n_remove = n_currnotifs - _tmp4_;
#line 181 "../src/raven/notifications_group.vala"
	count = 0;
#line 183 "../src/raven/notifications_group.vala"
	_tmp5_ = currnotifs;
#line 536 "notifications_group.c"
	{
		GList* n_collection = NULL;
		GList* n_it = NULL;
#line 183 "../src/raven/notifications_group.vala"
		n_collection = _tmp5_;
#line 183 "../src/raven/notifications_group.vala"
		for (n_it = n_collection; n_it != NULL; n_it = n_it->next) {
#line 544 "notifications_group.c"
			guint n = 0U;
#line 183 "../src/raven/notifications_group.vala"
			n = (guint) ((guint32) ((guintptr) n_it->data));
#line 548 "notifications_group.c"
			{
				gint _tmp6_;
#line 184 "../src/raven/notifications_group.vala"
				if (((guint) count) >= n_remove) {
#line 185 "../src/raven/notifications_group.vala"
					break;
#line 555 "notifications_group.c"
				}
#line 188 "../src/raven/notifications_group.vala"
				budgie_notification_group_remove_notification (self, (guint32) n);
#line 189 "../src/raven/notifications_group.vala"
				_tmp6_ = count;
#line 189 "../src/raven/notifications_group.vala"
				count = _tmp6_ + 1;
#line 563 "notifications_group.c"
			}
		}
	}
#line 166 "../src/raven/notifications_group.vala"
	(currnotifs == NULL) ? NULL : (currnotifs = (g_list_free (currnotifs), NULL));
#line 569 "notifications_group.c"
}

/**
 * if the total number of notifications exceeds threshold, NotificationsView will
 * update the max number per group ('tokeep')
 */
void
budgie_notification_group_set_group_max_notifications (BudgieNotificationGroup* self,
                                                       guint keep)
{
#line 197 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/raven/notifications_group.vala"
	budgie_notification_group_set_tokeep (self, keep);
#line 584 "notifications_group.c"
}

/**
 * update_count updates our notifications count for this group
 */
static void
budgie_notification_group_update_count (BudgieNotificationGroup* self)
{
	GHashTable* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	gint _tmp3_;
	guint _tmp4_;
	GtkLabel* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 204 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->notifications;
#line 205 "../src/raven/notifications_group.vala"
	_tmp1_ = g_hash_table_size (_tmp0_);
#line 205 "../src/raven/notifications_group.vala"
	_tmp2_ = _tmp1_;
#line 205 "../src/raven/notifications_group.vala"
	budgie_notification_group_set_noti_count (self, (gint) _tmp2_);
#line 207 "../src/raven/notifications_group.vala"
	_tmp3_ = self->priv->_noti_count;
#line 207 "../src/raven/notifications_group.vala"
	_tmp4_ = self->priv->_tokeep;
#line 207 "../src/raven/notifications_group.vala"
	if (((guint) _tmp3_) > _tmp4_) {
#line 208 "../src/raven/notifications_group.vala"
		budgie_notification_group_limit_notifications (self);
#line 621 "notifications_group.c"
	}
#line 211 "../src/raven/notifications_group.vala"
	_tmp5_ = self->priv->name_label;
#line 211 "../src/raven/notifications_group.vala"
	_tmp6_ = self->priv->_app_name;
#line 211 "../src/raven/notifications_group.vala"
	_tmp7_ = self->priv->_noti_count;
#line 211 "../src/raven/notifications_group.vala"
	_tmp8_ = g_strdup_printf ("<b>%s (%i)</b>", _tmp6_, _tmp7_);
#line 211 "../src/raven/notifications_group.vala"
	_tmp9_ = _tmp8_;
#line 211 "../src/raven/notifications_group.vala"
	gtk_label_set_markup (_tmp5_, _tmp9_);
#line 211 "../src/raven/notifications_group.vala"
	_g_free0 (_tmp9_);
#line 637 "notifications_group.c"
}

static gint
budgie_notification_group_sort_notifications (BudgieNotificationGroup* self,
                                              GtkListBoxRow* a,
                                              GtkListBoxRow* b)
{
	NotificationWidget* noti_a = NULL;
	NotificationWidget* _tmp0_;
	NotificationWidget* noti_b = NULL;
	NotificationWidget* _tmp1_;
	BudgieNotificationSort _tmp2_;
	gint result;
#line 214 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 214 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 215 "../src/raven/notifications_group.vala"
	_tmp0_ = _g_object_ref0 (IS_NOTIFICATION_WIDGET (a) ? ((NotificationWidget*) a) : NULL);
#line 215 "../src/raven/notifications_group.vala"
	noti_a = _tmp0_;
#line 216 "../src/raven/notifications_group.vala"
	_tmp1_ = _g_object_ref0 (IS_NOTIFICATION_WIDGET (b) ? ((NotificationWidget*) b) : NULL);
#line 216 "../src/raven/notifications_group.vala"
	noti_b = _tmp1_;
#line 218 "../src/raven/notifications_group.vala"
	_tmp2_ = self->priv->_noti_sort_mode;
#line 218 "../src/raven/notifications_group.vala"
	switch (_tmp2_) {
#line 218 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_SORT_NEW_OLD:
#line 671 "notifications_group.c"
		{
			NotificationWidget* _tmp3_;
			BudgieNotification* _tmp4_;
			BudgieNotification* _tmp5_;
			gint64 _tmp6_;
			gint64 _tmp7_;
			NotificationWidget* _tmp8_;
			BudgieNotification* _tmp9_;
			BudgieNotification* _tmp10_;
			gint64 _tmp11_;
			gint64 _tmp12_;
#line 220 "../src/raven/notifications_group.vala"
			_tmp3_ = noti_b;
#line 220 "../src/raven/notifications_group.vala"
			_tmp4_ = notification_widget_get_notification (_tmp3_);
#line 220 "../src/raven/notifications_group.vala"
			_tmp5_ = _tmp4_;
#line 220 "../src/raven/notifications_group.vala"
			_tmp6_ = budgie_notification_get_timestamp (_tmp5_);
#line 220 "../src/raven/notifications_group.vala"
			_tmp7_ = _tmp6_;
#line 220 "../src/raven/notifications_group.vala"
			_tmp8_ = noti_a;
#line 220 "../src/raven/notifications_group.vala"
			_tmp9_ = notification_widget_get_notification (_tmp8_);
#line 220 "../src/raven/notifications_group.vala"
			_tmp10_ = _tmp9_;
#line 220 "../src/raven/notifications_group.vala"
			_tmp11_ = budgie_notification_get_timestamp (_tmp10_);
#line 220 "../src/raven/notifications_group.vala"
			_tmp12_ = _tmp11_;
#line 220 "../src/raven/notifications_group.vala"
			result = (gint) (_tmp7_ - _tmp12_);
#line 220 "../src/raven/notifications_group.vala"
			_g_object_unref0 (noti_b);
#line 220 "../src/raven/notifications_group.vala"
			_g_object_unref0 (noti_a);
#line 220 "../src/raven/notifications_group.vala"
			return result;
#line 711 "notifications_group.c"
		}
#line 218 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_SORT_OLD_NEW:
#line 715 "notifications_group.c"
		{
			NotificationWidget* _tmp13_;
			BudgieNotification* _tmp14_;
			BudgieNotification* _tmp15_;
			gint64 _tmp16_;
			gint64 _tmp17_;
			NotificationWidget* _tmp18_;
			BudgieNotification* _tmp19_;
			BudgieNotification* _tmp20_;
			gint64 _tmp21_;
			gint64 _tmp22_;
#line 222 "../src/raven/notifications_group.vala"
			_tmp13_ = noti_a;
#line 222 "../src/raven/notifications_group.vala"
			_tmp14_ = notification_widget_get_notification (_tmp13_);
#line 222 "../src/raven/notifications_group.vala"
			_tmp15_ = _tmp14_;
#line 222 "../src/raven/notifications_group.vala"
			_tmp16_ = budgie_notification_get_timestamp (_tmp15_);
#line 222 "../src/raven/notifications_group.vala"
			_tmp17_ = _tmp16_;
#line 222 "../src/raven/notifications_group.vala"
			_tmp18_ = noti_b;
#line 222 "../src/raven/notifications_group.vala"
			_tmp19_ = notification_widget_get_notification (_tmp18_);
#line 222 "../src/raven/notifications_group.vala"
			_tmp20_ = _tmp19_;
#line 222 "../src/raven/notifications_group.vala"
			_tmp21_ = budgie_notification_get_timestamp (_tmp20_);
#line 222 "../src/raven/notifications_group.vala"
			_tmp22_ = _tmp21_;
#line 222 "../src/raven/notifications_group.vala"
			result = (gint) (_tmp17_ - _tmp22_);
#line 222 "../src/raven/notifications_group.vala"
			_g_object_unref0 (noti_b);
#line 222 "../src/raven/notifications_group.vala"
			_g_object_unref0 (noti_a);
#line 222 "../src/raven/notifications_group.vala"
			return result;
#line 755 "notifications_group.c"
		}
		default:
#line 218 "../src/raven/notifications_group.vala"
		break;
#line 760 "notifications_group.c"
	}
#line 225 "../src/raven/notifications_group.vala"
	result = 0;
#line 225 "../src/raven/notifications_group.vala"
	_g_object_unref0 (noti_b);
#line 225 "../src/raven/notifications_group.vala"
	_g_object_unref0 (noti_a);
#line 225 "../src/raven/notifications_group.vala"
	return result;
#line 770 "notifications_group.c"
}

/**
 * Set the sort mode for this notification group.
 */
void
budgie_notification_group_set_sort_mode (BudgieNotificationGroup* self,
                                         BudgieNotificationSort sort_mode)
{
	GtkListBox* _tmp0_;
#line 231 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/raven/notifications_group.vala"
	budgie_notification_group_set_noti_sort_mode (self, sort_mode);
#line 233 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->noti_box;
#line 233 "../src/raven/notifications_group.vala"
	gtk_list_box_invalidate_sort (_tmp0_);
#line 789 "notifications_group.c"
}

const gchar*
budgie_notification_group_get_app_name (BudgieNotificationGroup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->_app_name;
#line 23 "../src/raven/notifications_group.vala"
	result = _tmp0_;
#line 23 "../src/raven/notifications_group.vala"
	return result;
#line 805 "notifications_group.c"
}

static void
budgie_notification_group_set_app_name (BudgieNotificationGroup* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 23 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/raven/notifications_group.vala"
	old_value = budgie_notification_group_get_app_name (self);
#line 23 "../src/raven/notifications_group.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 819 "notifications_group.c"
		gchar* _tmp0_;
#line 23 "../src/raven/notifications_group.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/raven/notifications_group.vala"
		_g_free0 (self->priv->_app_name);
#line 23 "../src/raven/notifications_group.vala"
		self->priv->_app_name = _tmp0_;
#line 23 "../src/raven/notifications_group.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_APP_NAME_PROPERTY]);
#line 829 "notifications_group.c"
	}
}

const gchar*
budgie_notification_group_get_app_icon (BudgieNotificationGroup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/raven/notifications_group.vala"
	_tmp0_ = self->priv->_app_icon;
#line 24 "../src/raven/notifications_group.vala"
	result = _tmp0_;
#line 24 "../src/raven/notifications_group.vala"
	return result;
#line 846 "notifications_group.c"
}

static void
budgie_notification_group_set_app_icon (BudgieNotificationGroup* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 24 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/raven/notifications_group.vala"
	old_value = budgie_notification_group_get_app_icon (self);
#line 24 "../src/raven/notifications_group.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 860 "notifications_group.c"
		gchar* _tmp0_;
#line 24 "../src/raven/notifications_group.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/raven/notifications_group.vala"
		_g_free0 (self->priv->_app_icon);
#line 24 "../src/raven/notifications_group.vala"
		self->priv->_app_icon = _tmp0_;
#line 24 "../src/raven/notifications_group.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_APP_ICON_PROPERTY]);
#line 870 "notifications_group.c"
	}
}

guint
budgie_notification_group_get_tokeep (BudgieNotificationGroup* self)
{
	guint result;
#line 25 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 25 "../src/raven/notifications_group.vala"
	result = self->priv->_tokeep;
#line 25 "../src/raven/notifications_group.vala"
	return result;
#line 884 "notifications_group.c"
}

void
budgie_notification_group_set_tokeep (BudgieNotificationGroup* self,
                                      guint value)
{
	guint old_value;
#line 25 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/raven/notifications_group.vala"
	old_value = budgie_notification_group_get_tokeep (self);
#line 25 "../src/raven/notifications_group.vala"
	if (old_value != value) {
#line 25 "../src/raven/notifications_group.vala"
		self->priv->_tokeep = value;
#line 25 "../src/raven/notifications_group.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_TOKEEP_PROPERTY]);
#line 902 "notifications_group.c"
	}
}

BudgieNotificationSort
budgie_notification_group_get_noti_sort_mode (BudgieNotificationGroup* self)
{
	BudgieNotificationSort result;
#line 26 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "../src/raven/notifications_group.vala"
	result = self->priv->_noti_sort_mode;
#line 26 "../src/raven/notifications_group.vala"
	return result;
#line 916 "notifications_group.c"
}

void
budgie_notification_group_set_noti_sort_mode (BudgieNotificationGroup* self,
                                              BudgieNotificationSort value)
{
	BudgieNotificationSort old_value;
#line 26 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/raven/notifications_group.vala"
	old_value = budgie_notification_group_get_noti_sort_mode (self);
#line 26 "../src/raven/notifications_group.vala"
	if (old_value != value) {
#line 26 "../src/raven/notifications_group.vala"
		self->priv->_noti_sort_mode = value;
#line 26 "../src/raven/notifications_group.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_NOTI_SORT_MODE_PROPERTY]);
#line 934 "notifications_group.c"
	}
}

gint
budgie_notification_group_get_noti_count (BudgieNotificationGroup* self)
{
	gint result;
#line 27 "../src/raven/notifications_group.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/raven/notifications_group.vala"
	result = self->priv->_noti_count;
#line 27 "../src/raven/notifications_group.vala"
	return result;
#line 948 "notifications_group.c"
}

static void
budgie_notification_group_set_noti_count (BudgieNotificationGroup* self,
                                          gint value)
{
	gint old_value;
#line 27 "../src/raven/notifications_group.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/raven/notifications_group.vala"
	old_value = budgie_notification_group_get_noti_count (self);
#line 27 "../src/raven/notifications_group.vala"
	if (old_value != value) {
#line 27 "../src/raven/notifications_group.vala"
		self->priv->_noti_count = value;
#line 27 "../src/raven/notifications_group.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_NOTI_COUNT_PROPERTY]);
#line 966 "notifications_group.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 43 "../src/raven/notifications_group.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 975 "notifications_group.c"
}

static gint
_budgie_notification_group_sort_notifications_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                      GtkListBoxRow* row2,
                                                                      gpointer self)
{
	gint result;
	result = budgie_notification_group_sort_notifications ((BudgieNotificationGroup*) self, row1, row2);
#line 50 "../src/raven/notifications_group.vala"
	return result;
#line 987 "notifications_group.c"
}

static void
_budgie_notification_group_dismiss_all_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 78 "../src/raven/notifications_group.vala"
	budgie_notification_group_dismiss_all ((BudgieNotificationGroup*) self);
#line 996 "notifications_group.c"
}

static GObject *
budgie_notification_group_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieNotificationGroup * self;
	GtkStyleContext* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GtkListBox* _tmp4_ = NULL;
	GtkListBox* _tmp5_;
	GtkBox* header = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkImage* app_image = NULL;
	const gchar* _tmp9_;
	GtkImage* _tmp10_ = NULL;
	const gchar* _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkButton* _tmp13_ = NULL;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkButton* _tmp18_;
	GtkBox* _tmp19_;
	GtkImage* _tmp20_;
	GtkBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkBox* _tmp23_;
	GtkButton* _tmp24_;
	GtkBox* _tmp25_;
	GtkListBox* _tmp26_;
#line 34 "../src/raven/notifications_group.vala"
	parent_class = G_OBJECT_CLASS (budgie_notification_group_parent_class);
#line 34 "../src/raven/notifications_group.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/raven/notifications_group.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION_GROUP, BudgieNotificationGroup);
#line 35 "../src/raven/notifications_group.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
#line 36 "../src/raven/notifications_group.vala"
	gtk_widget_set_focus_on_click ((GtkWidget*) self, FALSE);
#line 38 "../src/raven/notifications_group.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 38 "../src/raven/notifications_group.vala"
	gtk_style_context_add_class (_tmp0_, "raven-notifications-group");
#line 41 "../src/raven/notifications_group.vala"
	g_object_set ((GtkWidget*) self, "margin", 4, NULL);
#line 43 "../src/raven/notifications_group.vala"
	_tmp1_ = g_direct_hash;
#line 43 "../src/raven/notifications_group.vala"
	_tmp2_ = g_direct_equal;
#line 43 "../src/raven/notifications_group.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, NULL, _g_object_unref0_);
#line 43 "../src/raven/notifications_group.vala"
	_g_hash_table_unref0 (self->priv->notifications);
#line 43 "../src/raven/notifications_group.vala"
	self->priv->notifications = _tmp3_;
#line 45 "../src/raven/notifications_group.vala"
	_tmp4_ = (GtkListBox*) gtk_list_box_new ();
#line 45 "../src/raven/notifications_group.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp4_, FALSE);
#line 45 "../src/raven/notifications_group.vala"
	gtk_widget_set_focus_on_click ((GtkWidget*) _tmp4_, FALSE);
#line 45 "../src/raven/notifications_group.vala"
	gtk_list_box_set_selection_mode (_tmp4_, GTK_SELECTION_NONE);
#line 45 "../src/raven/notifications_group.vala"
	g_object_ref_sink (_tmp4_);
#line 45 "../src/raven/notifications_group.vala"
	_g_object_unref0 (self->priv->noti_box);
#line 45 "../src/raven/notifications_group.vala"
	self->priv->noti_box = _tmp4_;
#line 50 "../src/raven/notifications_group.vala"
	_tmp5_ = self->priv->noti_box;
#line 50 "../src/raven/notifications_group.vala"
	gtk_list_box_set_sort_func (_tmp5_, _budgie_notification_group_sort_notifications_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 55 "../src/raven/notifications_group.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 55 "../src/raven/notifications_group.vala"
	g_object_ref_sink (_tmp6_);
#line 55 "../src/raven/notifications_group.vala"
	header = _tmp6_;
#line 56 "../src/raven/notifications_group.vala"
	_tmp7_ = header;
#line 56 "../src/raven/notifications_group.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 56 "../src/raven/notifications_group.vala"
	gtk_style_context_add_class (_tmp8_, "raven-notifications-group-header");
#line 58 "../src/raven/notifications_group.vala"
	_tmp9_ = self->priv->_app_icon;
#line 58 "../src/raven/notifications_group.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp9_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 58 "../src/raven/notifications_group.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 58 "../src/raven/notifications_group.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp10_, 5);
#line 58 "../src/raven/notifications_group.vala"
	gtk_image_set_pixel_size (_tmp10_, 32);
#line 58 "../src/raven/notifications_group.vala"
	g_object_ref_sink (_tmp10_);
#line 58 "../src/raven/notifications_group.vala"
	app_image = _tmp10_;
#line 64 "../src/raven/notifications_group.vala"
	_tmp11_ = self->priv->_app_name;
#line 64 "../src/raven/notifications_group.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new (_tmp11_);
#line 64 "../src/raven/notifications_group.vala"
	gtk_label_set_ellipsize (_tmp12_, PANGO_ELLIPSIZE_END);
#line 64 "../src/raven/notifications_group.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
#line 64 "../src/raven/notifications_group.vala"
	gtk_label_set_justify (_tmp12_, GTK_JUSTIFY_LEFT);
#line 64 "../src/raven/notifications_group.vala"
	gtk_label_set_use_markup (_tmp12_, TRUE);
#line 64 "../src/raven/notifications_group.vala"
	g_object_ref_sink (_tmp12_);
#line 64 "../src/raven/notifications_group.vala"
	_g_object_unref0 (self->priv->name_label);
#line 64 "../src/raven/notifications_group.vala"
	self->priv->name_label = _tmp12_;
#line 71 "../src/raven/notifications_group.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-all-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 71 "../src/raven/notifications_group.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
#line 71 "../src/raven/notifications_group.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_END);
#line 71 "../src/raven/notifications_group.vala"
	g_object_ref_sink (_tmp13_);
#line 71 "../src/raven/notifications_group.vala"
	_g_object_unref0 (self->priv->dismiss_button);
#line 71 "../src/raven/notifications_group.vala"
	self->priv->dismiss_button = _tmp13_;
#line 75 "../src/raven/notifications_group.vala"
	_tmp14_ = self->priv->dismiss_button;
#line 75 "../src/raven/notifications_group.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 75 "../src/raven/notifications_group.vala"
	gtk_style_context_add_class (_tmp15_, "flat");
#line 76 "../src/raven/notifications_group.vala"
	_tmp16_ = self->priv->dismiss_button;
#line 76 "../src/raven/notifications_group.vala"
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 76 "../src/raven/notifications_group.vala"
	gtk_style_context_add_class (_tmp17_, "image-button");
#line 78 "../src/raven/notifications_group.vala"
	_tmp18_ = self->priv->dismiss_button;
#line 78 "../src/raven/notifications_group.vala"
	g_signal_connect_object (_tmp18_, "clicked", (GCallback) _budgie_notification_group_dismiss_all_gtk_button_clicked, self, 0);
#line 80 "../src/raven/notifications_group.vala"
	_tmp19_ = header;
#line 80 "../src/raven/notifications_group.vala"
	_tmp20_ = app_image;
#line 80 "../src/raven/notifications_group.vala"
	gtk_box_pack_start (_tmp19_, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
#line 81 "../src/raven/notifications_group.vala"
	_tmp21_ = header;
#line 81 "../src/raven/notifications_group.vala"
	_tmp22_ = self->priv->name_label;
#line 81 "../src/raven/notifications_group.vala"
	gtk_box_pack_start (_tmp21_, (GtkWidget*) _tmp22_, FALSE, FALSE, (guint) 0);
#line 82 "../src/raven/notifications_group.vala"
	_tmp23_ = header;
#line 82 "../src/raven/notifications_group.vala"
	_tmp24_ = self->priv->dismiss_button;
#line 82 "../src/raven/notifications_group.vala"
	gtk_box_pack_end (_tmp23_, (GtkWidget*) _tmp24_, FALSE, FALSE, (guint) 0);
#line 84 "../src/raven/notifications_group.vala"
	_tmp25_ = header;
#line 84 "../src/raven/notifications_group.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp25_, TRUE, TRUE, (guint) 0);
#line 85 "../src/raven/notifications_group.vala"
	_tmp26_ = self->priv->noti_box;
#line 85 "../src/raven/notifications_group.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp26_, TRUE, TRUE, (guint) 0);
#line 34 "../src/raven/notifications_group.vala"
	_g_object_unref0 (app_image);
#line 34 "../src/raven/notifications_group.vala"
	_g_object_unref0 (header);
#line 34 "../src/raven/notifications_group.vala"
	return obj;
#line 1184 "notifications_group.c"
}

static void
budgie_notification_group_class_init (BudgieNotificationGroupClass * klass,
                                      gpointer klass_data)
{
#line 16 "../src/raven/notifications_group.vala"
	budgie_notification_group_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/raven/notifications_group.vala"
	g_type_class_adjust_private_offset (klass, &BudgieNotificationGroup_private_offset);
#line 16 "../src/raven/notifications_group.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_notification_group_get_property;
#line 16 "../src/raven/notifications_group.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_notification_group_set_property;
#line 16 "../src/raven/notifications_group.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_notification_group_constructor;
#line 16 "../src/raven/notifications_group.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_notification_group_finalize;
#line 16 "../src/raven/notifications_group.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_GROUP_APP_NAME_PROPERTY, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 16 "../src/raven/notifications_group.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_GROUP_APP_ICON_PROPERTY, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_APP_ICON_PROPERTY] = g_param_spec_string ("app-icon", "app-icon", "app-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 16 "../src/raven/notifications_group.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_GROUP_TOKEEP_PROPERTY, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_TOKEEP_PROPERTY] = g_param_spec_uint ("tokeep", "tokeep", "tokeep", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 16 "../src/raven/notifications_group.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_GROUP_NOTI_SORT_MODE_PROPERTY, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_NOTI_SORT_MODE_PROPERTY] = g_param_spec_enum ("noti-sort-mode", "noti-sort-mode", "noti-sort-mode", BUDGIE_TYPE_NOTIFICATION_SORT, BUDGIE_NOTIFICATION_SORT_NEW_OLD, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 16 "../src/raven/notifications_group.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_GROUP_NOTI_COUNT_PROPERTY, budgie_notification_group_properties[BUDGIE_NOTIFICATION_GROUP_NOTI_COUNT_PROPERTY] = g_param_spec_int ("noti-count", "noti-count", "noti-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 16 "../src/raven/notifications_group.vala"
	budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_GROUP_SIGNAL] = g_signal_new ("dismissed-group", BUDGIE_TYPE_NOTIFICATION_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 16 "../src/raven/notifications_group.vala"
	budgie_notification_group_signals[BUDGIE_NOTIFICATION_GROUP_DISMISSED_NOTIFICATION_SIGNAL] = g_signal_new ("dismissed-notification", BUDGIE_TYPE_NOTIFICATION_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 1217 "notifications_group.c"
}

static void
budgie_notification_group_instance_init (BudgieNotificationGroup * self,
                                         gpointer klass)
{
#line 16 "../src/raven/notifications_group.vala"
	self->priv = budgie_notification_group_get_instance_private (self);
#line 26 "../src/raven/notifications_group.vala"
	self->priv->_noti_sort_mode = BUDGIE_NOTIFICATION_SORT_NEW_OLD;
#line 27 "../src/raven/notifications_group.vala"
	self->priv->_noti_count = 0;
#line 1230 "notifications_group.c"
}

static void
budgie_notification_group_finalize (GObject * obj)
{
	BudgieNotificationGroup * self;
#line 16 "../src/raven/notifications_group.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION_GROUP, BudgieNotificationGroup);
#line 17 "../src/raven/notifications_group.vala"
	_g_hash_table_unref0 (self->priv->notifications);
#line 19 "../src/raven/notifications_group.vala"
	_g_object_unref0 (self->priv->name_label);
#line 20 "../src/raven/notifications_group.vala"
	_g_object_unref0 (self->priv->dismiss_button);
#line 21 "../src/raven/notifications_group.vala"
	_g_object_unref0 (self->priv->noti_box);
#line 23 "../src/raven/notifications_group.vala"
	_g_free0 (self->priv->_app_name);
#line 24 "../src/raven/notifications_group.vala"
	_g_free0 (self->priv->_app_icon);
#line 16 "../src/raven/notifications_group.vala"
	G_OBJECT_CLASS (budgie_notification_group_parent_class)->finalize (obj);
#line 1253 "notifications_group.c"
}

/**
 * NotificationGroup is a group of notifications.
 */
static GType
budgie_notification_group_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notification_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotificationGroup), 0, (GInstanceInitFunc) budgie_notification_group_instance_init, NULL };
	GType budgie_notification_group_type_id;
	budgie_notification_group_type_id = g_type_register_static (gtk_box_get_type (), "BudgieNotificationGroup", &g_define_type_info, 0);
	BudgieNotificationGroup_private_offset = g_type_add_instance_private (budgie_notification_group_type_id, sizeof (BudgieNotificationGroupPrivate));
	return budgie_notification_group_type_id;
}

GType
budgie_notification_group_get_type (void)
{
	static volatile gsize budgie_notification_group_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_group_type_id__once)) {
		GType budgie_notification_group_type_id;
		budgie_notification_group_type_id = budgie_notification_group_get_type_once ();
		g_once_init_leave (&budgie_notification_group_type_id__once, budgie_notification_group_type_id);
	}
	return budgie_notification_group_type_id__once;
}

static void
_vala_budgie_notification_group_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	BudgieNotificationGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION_GROUP, BudgieNotificationGroup);
#line 16 "../src/raven/notifications_group.vala"
	switch (property_id) {
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_APP_NAME_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		g_value_set_string (value, budgie_notification_group_get_app_name (self));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_APP_ICON_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		g_value_set_string (value, budgie_notification_group_get_app_icon (self));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_TOKEEP_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		g_value_set_uint (value, budgie_notification_group_get_tokeep (self));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_NOTI_SORT_MODE_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		g_value_set_enum (value, budgie_notification_group_get_noti_sort_mode (self));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_NOTI_COUNT_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		g_value_set_int (value, budgie_notification_group_get_noti_count (self));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 1321 "notifications_group.c"
		default:
#line 16 "../src/raven/notifications_group.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 1327 "notifications_group.c"
	}
}

static void
_vala_budgie_notification_group_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	BudgieNotificationGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION_GROUP, BudgieNotificationGroup);
#line 16 "../src/raven/notifications_group.vala"
	switch (property_id) {
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_APP_NAME_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		budgie_notification_group_set_app_name (self, g_value_get_string (value));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_APP_ICON_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		budgie_notification_group_set_app_icon (self, g_value_get_string (value));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_TOKEEP_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		budgie_notification_group_set_tokeep (self, g_value_get_uint (value));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_NOTI_SORT_MODE_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		budgie_notification_group_set_noti_sort_mode (self, g_value_get_enum (value));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 16 "../src/raven/notifications_group.vala"
		case BUDGIE_NOTIFICATION_GROUP_NOTI_COUNT_PROPERTY:
#line 16 "../src/raven/notifications_group.vala"
		budgie_notification_group_set_noti_count (self, g_value_get_int (value));
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 1371 "notifications_group.c"
		default:
#line 16 "../src/raven/notifications_group.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/raven/notifications_group.vala"
		break;
#line 1377 "notifications_group.c"
	}
}

