/* notifications_view.c generated by valac 0.56.12, the Vala compiler
 * generated from notifications_view.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 * Copyright 2014 Josh Klar <j@iv597.com> (original Budgie work, prior to Budgie 10)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "raven.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include "budgie-private.h"
#include <gio/gdesktopappinfo.h>
#include <float.h>
#include <math.h>

#define BUDGIE_NOTIFICATIONS_VIEW_BUDGIE_PANEL_SCHEMA "com.solus-project.budgie-panel"
#define BUDGIE_NOTIFICATIONS_VIEW_BUDGIE_RAVEN_SCHEMA "com.solus-project.budgie-raven"
#define BUDGIE_NOTIFICATIONS_VIEW_APPLICATION_SCHEMA "org.gnome.desktop.notifications.application"
#define BUDGIE_NOTIFICATIONS_VIEW_APPLICATION_PREFIX "/org/gnome/desktop/notifications/application"
#define BUDGIE_NOTIFICATIONS_VIEW_TOTAL_MAX_NOTIFICATIONS ((guint) 500)
#define BUDGIE_NOTIFICATIONS_VIEW_DEFAULT_MAX_PERGROUP ((guint) 25)

enum  {
	BUDGIE_NOTIFICATION_PLACEHOLDER_0_PROPERTY,
	BUDGIE_NOTIFICATION_PLACEHOLDER_NUM_PROPERTIES
};
static GParamSpec* budgie_notification_placeholder_properties[BUDGIE_NOTIFICATION_PLACEHOLDER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BUDGIE_DISPATCHER_NOTIFICATION_ADDED_SIGNAL,
	BUDGIE_DISPATCHER_NOTIFICATION_CLOSED_SIGNAL,
	BUDGIE_DISPATCHER_NUM_SIGNALS
};
static guint budgie_dispatcher_signals[BUDGIE_DISPATCHER_NUM_SIGNALS] = {0};
typedef GDBusProxy BudgieDispatcherProxy;
typedef GDBusProxyClass BudgieDispatcherProxyClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	BUDGIE_RAVEN_INTERFACE_CLEAR_ALL_NOTIFICATIONS_SIGNAL,
	BUDGIE_RAVEN_INTERFACE_NUM_SIGNALS
};
static guint budgie_raven_interface_signals[BUDGIE_RAVEN_INTERFACE_NUM_SIGNALS] = {0};
typedef GDBusProxy BudgieRavenInterfaceProxy;
typedef GDBusProxyClass BudgieRavenInterfaceProxyClass;
enum  {
	BUDGIE_NOTIFICATIONS_VIEW_0_PROPERTY,
	BUDGIE_NOTIFICATIONS_VIEW_NUM_PROPERTIES
};
static GParamSpec* budgie_notifications_view_properties[BUDGIE_NOTIFICATIONS_VIEW_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

struct _BudgieNotificationsViewPrivate {
	guint max_per_group;
	BudgieHeaderWidget* header;
	GtkButton* button_mute;
	GtkButton* clear_notifications_button;
	GtkListBox* listbox;
	GtkImage* image_notifications_disabled;
	GtkImage* image_notifications_enabled;
	gboolean _do_not_disturb;
	gboolean _performing_clear_all;
	BudgieNotificationSort _sort_mode;
	BudgieDispatcher* dispatcher;
	GHashTable* notifications;
	GHashTable* notification_groups;
	GSettings* budgie_settings;
	GSettings* raven_settings;
	BudgieRavenInterface* raven;
};

struct _Block3Data {
	int _ref_count_;
	BudgieNotificationsView* self;
	BudgieNotificationGroup* group;
};

struct _Block4Data {
	int _ref_count_;
	BudgieNotificationsView* self;
	gboolean trim;
};

struct _Block5Data {
	int _ref_count_;
	BudgieNotificationsView* self;
	guint len;
};

static gpointer budgie_notification_placeholder_parent_class = NULL;
static gint BudgieNotificationsView_private_offset;
static gpointer budgie_notifications_view_parent_class = NULL;

static GType budgie_notification_placeholder_get_type_once (void);
static void g_cclosure_user_marshal_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_INT_BOXED_INT (GClosure * closure,
                                                                                         GValue * return_value,
                                                                                         guint n_param_values,
                                                                                         const GValue * param_values,
                                                                                         gpointer invocation_hint,
                                                                                         gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT_STRING_ENUM (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GType budgie_dispatcher_get_type_once (void);
static void budgie_dispatcher_proxy_g_signal (GDBusProxy* proxy,
                                       const gchar* sender_name,
                                       const gchar* signal_name,
                                       GVariant* parameters);
static void _dbus_handle_budgie_dispatcher_notification_added (BudgieDispatcher* self,
                                                        GVariant* parameters);
static void _dbus_handle_budgie_dispatcher_notification_closed (BudgieDispatcher* self,
                                                         GVariant* parameters);
static gboolean budgie_dispatcher_proxy_get_do_not_disturb (BudgieDispatcher* self,
                                                     GError** error);
static void budgie_dispatcher_proxy_toggle_do_not_disturb (BudgieDispatcher* self,
                                                    GError** error);
static gboolean budgie_dispatcher_dbus_proxy_get_notifications_paused (BudgieDispatcher* self);
static void budgie_dispatcher_dbus_proxy_set_notifications_paused (BudgieDispatcher* self,
                                                            gboolean value);
static void budgie_dispatcher_proxy_budgie_dispatcher_interface_init (BudgieDispatcherIface* iface);
static void _dbus_budgie_dispatcher_get_do_not_disturb (BudgieDispatcher* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _dbus_budgie_dispatcher_toggle_do_not_disturb (BudgieDispatcher* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void budgie_dispatcher_dbus_interface_method_call (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* method_name,
                                                   GVariant* parameters,
                                                   GDBusMethodInvocation* invocation,
                                                   gpointer user_data);
static GVariant* budgie_dispatcher_dbus_interface_get_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GError** error,
                                                         gpointer user_data);
static GVariant* _dbus_budgie_dispatcher_get_notifications_paused (BudgieDispatcher* self);
static gboolean budgie_dispatcher_dbus_interface_set_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GVariant* value,
                                                        GError** error,
                                                        gpointer user_data);
static void _dbus_budgie_dispatcher_set_notifications_paused (BudgieDispatcher* self,
                                                       GVariant* _value);
static void _dbus_budgie_dispatcher_notification_added (GObject* _sender,
                                                 const gchar* app_name,
                                                 guint32 id,
                                                 const gchar* app_icon,
                                                 const gchar* summary,
                                                 const gchar* body,
                                                 gchar** actions,
                                                 gint actions_length1,
                                                 GHashTable* hints,
                                                 gint32 expire_timeout,
                                                 gpointer* _data);
static void _dbus_budgie_dispatcher_notification_closed (GObject* _sender,
                                                  guint32 id,
                                                  const gchar* app_name,
                                                  BudgieNotificationCloseReason reason,
                                                  gpointer* _data);
static void _budgie_dispatcher_unregister_object (gpointer user_data);
static GType budgie_raven_interface_get_type_once (void);
static void budgie_raven_interface_proxy_g_signal (GDBusProxy* proxy,
                                            const gchar* sender_name,
                                            const gchar* signal_name,
                                            GVariant* parameters);
static void _dbus_handle_budgie_raven_interface_clear_all_notifications (BudgieRavenInterface* self,
                                                                  GVariant* parameters);
static void budgie_raven_interface_proxy_budgie_raven_interface_interface_init (BudgieRavenInterfaceIface* iface);
static void budgie_raven_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* method_name,
                                                        GVariant* parameters,
                                                        GDBusMethodInvocation* invocation,
                                                        gpointer user_data);
static GVariant* budgie_raven_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                              const gchar* sender,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              const gchar* property_name,
                                                              GError** error,
                                                              gpointer user_data);
static gboolean budgie_raven_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GVariant* value,
                                                             GError** error,
                                                             gpointer user_data);
static void _dbus_budgie_raven_interface_clear_all_notifications (GObject* _sender,
                                                           gpointer* _data);
static void _budgie_raven_interface_unregister_object (gpointer user_data);
static void budgie_notifications_view_on_dbus_get (BudgieNotificationsView* self,
                                            GObject* o,
                                            GAsyncResult* res);
static void budgie_notifications_view_on_notification_added (BudgieNotificationsView* self,
                                                      const gchar* app_name,
                                                      guint32 id,
                                                      const gchar* app_icon,
                                                      const gchar* summary,
                                                      const gchar* body,
                                                      gchar** actions,
                                                      gint actions_length1,
                                                      GHashTable* hints,
                                                      gint32 expire_timeout);
static void _budgie_notifications_view_on_notification_added_budgie_dispatcher_notification_added (BudgieDispatcher* _sender,
                                                                                            const gchar* app_name,
                                                                                            guint32 id,
                                                                                            const gchar* app_icon,
                                                                                            const gchar* summary,
                                                                                            const gchar* body,
                                                                                            gchar** actions,
                                                                                            gint actions_length1,
                                                                                            GHashTable* hints,
                                                                                            gint32 expire_timeout,
                                                                                            gpointer self);
static void budgie_notifications_view_on_notification_closed (BudgieNotificationsView* self,
                                                       guint32 id,
                                                       const gchar* app_name,
                                                       BudgieNotificationCloseReason reason);
static void _budgie_notifications_view_on_notification_closed_budgie_dispatcher_notification_closed (BudgieDispatcher* _sender,
                                                                                              guint32 id,
                                                                                              const gchar* app_name,
                                                                                              BudgieNotificationCloseReason reason,
                                                                                              gpointer self);
static void budgie_notifications_view_set_do_not_disturb (BudgieNotificationsView* self,
                                                   gboolean value);
static gboolean budgie_notifications_view_get_do_not_disturb (BudgieNotificationsView* self);
static void budgie_notifications_view_on_raven_get (BudgieNotificationsView* self,
                                             GObject* o,
                                             GAsyncResult* res);
static void budgie_notifications_view_clear_all (BudgieNotificationsView* self);
static void _budgie_notifications_view_clear_all_budgie_raven_interface_clear_all_notifications (BudgieRavenInterface* _sender,
                                                                                          gpointer self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static BudgieNotificationSort budgie_notifications_view_get_sort_mode (BudgieNotificationsView* self);
static void _____lambda11_ (Block3Data* _data3_,
                     const gchar* name);
static gboolean budgie_notifications_view_get_performing_clear_all (BudgieNotificationsView* self);
static void budgie_notifications_view_update_child_count (BudgieNotificationsView* self);
static void ______lambda11__budgie_notification_group_dismissed_group (BudgieNotificationGroup* _sender,
                                                                const gchar* app_name,
                                                                gpointer self);
static void _____lambda22_ (BudgieNotificationsView* self,
                     guint32 id);
static void ______lambda22__budgie_notification_group_dismissed_notification (BudgieNotificationGroup* _sender,
                                                                       guint32 id,
                                                                       gpointer self);
static void budgie_notifications_view_adjust_max_per_group (BudgieNotificationsView* self,
                                                     guint newmax,
                                                     gboolean trim);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda21_ (Block4Data* _data4_,
                  const gchar* app_name,
                  BudgieNotificationGroup* notification_group);
static void ___lambda21__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void budgie_notifications_view_check_notification_allocation (BudgieNotificationsView* self,
                                                              guint len);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda12_ (Block5Data* _data5_,
                   const gchar* app_name,
                   BudgieNotificationGroup* notification_group);
static void ____lambda12__gh_func (gconstpointer key,
                            gconstpointer value,
                            gpointer self);
static void budgie_notifications_view_set_performing_clear_all (BudgieNotificationsView* self,
                                                         gboolean value);
static void __lambda23_ (BudgieNotificationsView* self,
                  const gchar* app_name,
                  BudgieNotificationGroup* notification_group);
static void ___lambda23__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void budgie_notifications_view_do_not_disturb_toggle (BudgieNotificationsView* self);
static void budgie_notifications_view_set_sort_mode (BudgieNotificationsView* self,
                                              BudgieNotificationSort value);
static GObject * budgie_notifications_view_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _budgie_notifications_view_clear_all_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void _budgie_notifications_view_do_not_disturb_toggle_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self);
static void _g_object_unref0_ (gpointer var);
static void _g_free0_ (gpointer var);
static void _budgie_notifications_view___lambda24_ (BudgieNotificationsView* self,
                                             const gchar* key);
static void __lambda25_ (BudgieNotificationsView* self,
                  GtkWidget* row);
static void ___lambda25__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void __budgie_notifications_view___lambda24__g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self);
static void _budgie_notifications_view_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self);
static void _budgie_notifications_view_on_raven_get_gasync_ready_callback (GObject* source_object,
                                                                    GAsyncResult* res,
                                                                    gpointer self);
static void budgie_notifications_view_finalize (GObject * obj);
static GType budgie_notifications_view_get_type_once (void);
static void _vala_budgie_notifications_view_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_budgie_notifications_view_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_get_do_not_disturb_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _budgie_dispatcher_dbus_arg_info_get_do_not_disturb_in[] = {NULL};
static const GDBusArgInfo * const _budgie_dispatcher_dbus_arg_info_get_do_not_disturb_out[] = {&_budgie_dispatcher_dbus_arg_info_get_do_not_disturb_result, NULL};
static const GDBusMethodInfo _budgie_dispatcher_dbus_method_info_get_do_not_disturb = {-1, "GetDoNotDisturb", (GDBusArgInfo **) (&_budgie_dispatcher_dbus_arg_info_get_do_not_disturb_in), (GDBusArgInfo **) (&_budgie_dispatcher_dbus_arg_info_get_do_not_disturb_out), NULL};
static const GDBusArgInfo * const _budgie_dispatcher_dbus_arg_info_toggle_do_not_disturb_in[] = {NULL};
static const GDBusArgInfo * const _budgie_dispatcher_dbus_arg_info_toggle_do_not_disturb_out[] = {NULL};
static const GDBusMethodInfo _budgie_dispatcher_dbus_method_info_toggle_do_not_disturb = {-1, "ToggleDoNotDisturb", (GDBusArgInfo **) (&_budgie_dispatcher_dbus_arg_info_toggle_do_not_disturb_in), (GDBusArgInfo **) (&_budgie_dispatcher_dbus_arg_info_toggle_do_not_disturb_out), NULL};
static const GDBusMethodInfo * const _budgie_dispatcher_dbus_method_info[] = {&_budgie_dispatcher_dbus_method_info_get_do_not_disturb, &_budgie_dispatcher_dbus_method_info_toggle_do_not_disturb, NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_app_name = {-1, "app_name", "s", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_id = {-1, "id", "u", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_app_icon = {-1, "app_icon", "s", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_summary = {-1, "summary", "s", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_body = {-1, "body", "s", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_actions = {-1, "actions", "as", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_hints = {-1, "hints", "a{sv}", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_added_expire_timeout = {-1, "expire_timeout", "i", NULL};
static const GDBusArgInfo * const _budgie_dispatcher_dbus_arg_info_notification_added[] = {&_budgie_dispatcher_dbus_arg_info_notification_added_app_name, &_budgie_dispatcher_dbus_arg_info_notification_added_id, &_budgie_dispatcher_dbus_arg_info_notification_added_app_icon, &_budgie_dispatcher_dbus_arg_info_notification_added_summary, &_budgie_dispatcher_dbus_arg_info_notification_added_body, &_budgie_dispatcher_dbus_arg_info_notification_added_actions, &_budgie_dispatcher_dbus_arg_info_notification_added_hints, &_budgie_dispatcher_dbus_arg_info_notification_added_expire_timeout, NULL};
static const GDBusSignalInfo _budgie_dispatcher_dbus_signal_info_notification_added = {-1, "NotificationAdded", (GDBusArgInfo **) (&_budgie_dispatcher_dbus_arg_info_notification_added), NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_closed_id = {-1, "id", "u", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_closed_app_name = {-1, "app_name", "s", NULL};
static const GDBusArgInfo _budgie_dispatcher_dbus_arg_info_notification_closed_reason = {-1, "reason", "i", NULL};
static const GDBusArgInfo * const _budgie_dispatcher_dbus_arg_info_notification_closed[] = {&_budgie_dispatcher_dbus_arg_info_notification_closed_id, &_budgie_dispatcher_dbus_arg_info_notification_closed_app_name, &_budgie_dispatcher_dbus_arg_info_notification_closed_reason, NULL};
static const GDBusSignalInfo _budgie_dispatcher_dbus_signal_info_notification_closed = {-1, "NotificationClosed", (GDBusArgInfo **) (&_budgie_dispatcher_dbus_arg_info_notification_closed), NULL};
static const GDBusSignalInfo * const _budgie_dispatcher_dbus_signal_info[] = {&_budgie_dispatcher_dbus_signal_info_notification_added, &_budgie_dispatcher_dbus_signal_info_notification_closed, NULL};
static const GDBusPropertyInfo _budgie_dispatcher_dbus_property_info_notifications_paused = {-1, "NotificationsPaused", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _budgie_dispatcher_dbus_property_info[] = {&_budgie_dispatcher_dbus_property_info_notifications_paused, NULL};
static const GDBusInterfaceInfo _budgie_dispatcher_dbus_interface_info = {-1, "org.buddiesofbudgie.budgie.Dispatcher", (GDBusMethodInfo **) (&_budgie_dispatcher_dbus_method_info), (GDBusSignalInfo **) (&_budgie_dispatcher_dbus_signal_info), (GDBusPropertyInfo **) (&_budgie_dispatcher_dbus_property_info), NULL};
static const GDBusInterfaceVTable _budgie_dispatcher_dbus_interface_vtable = {budgie_dispatcher_dbus_interface_method_call, budgie_dispatcher_dbus_interface_get_property, budgie_dispatcher_dbus_interface_set_property};
static const GDBusMethodInfo * const _budgie_raven_interface_dbus_method_info[] = {NULL};
static const GDBusArgInfo * const _budgie_raven_interface_dbus_arg_info_clear_all_notifications[] = {NULL};
static const GDBusSignalInfo _budgie_raven_interface_dbus_signal_info_clear_all_notifications = {-1, "ClearAllNotifications", (GDBusArgInfo **) (&_budgie_raven_interface_dbus_arg_info_clear_all_notifications), NULL};
static const GDBusSignalInfo * const _budgie_raven_interface_dbus_signal_info[] = {&_budgie_raven_interface_dbus_signal_info_clear_all_notifications, NULL};
static const GDBusPropertyInfo * const _budgie_raven_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _budgie_raven_interface_dbus_interface_info = {-1, "org.budgie_desktop.Raven", (GDBusMethodInfo **) (&_budgie_raven_interface_dbus_method_info), (GDBusSignalInfo **) (&_budgie_raven_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_budgie_raven_interface_dbus_property_info), NULL};
static const GDBusInterfaceVTable _budgie_raven_interface_dbus_interface_vtable = {budgie_raven_interface_dbus_interface_method_call, budgie_raven_interface_dbus_interface_get_property, budgie_raven_interface_dbus_interface_set_property};

BudgieNotificationPlaceholder*
budgie_notification_placeholder_construct (GType object_type)
{
	BudgieNotificationPlaceholder * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkImage* image = NULL;
	GtkImage* _tmp1_;
	GtkLabel* label = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
#line 25 "../src/raven/notifications_view.vala"
	self = (BudgieNotificationPlaceholder*) g_object_new (object_type, "spacing", 6, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
#line 27 "../src/raven/notifications_view.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 27 "../src/raven/notifications_view.vala"
	gtk_style_context_add_class (_tmp0_, "dim-label");
#line 28 "../src/raven/notifications_view.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("notification-alert-symbolic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 28 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp1_);
#line 28 "../src/raven/notifications_view.vala"
	image = _tmp1_;
#line 29 "../src/raven/notifications_view.vala"
	gtk_image_set_pixel_size (image, 64);
#line 30 "../src/raven/notifications_view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) image, FALSE, FALSE, (guint) 6);
#line 31 "../src/raven/notifications_view.vala"
	_tmp2_ = g_strdup_printf ("<big>%s</big>", _ ("Nothing to see here"));
#line 31 "../src/raven/notifications_view.vala"
	_tmp3_ = _tmp2_;
#line 31 "../src/raven/notifications_view.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
#line 31 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp4_);
#line 31 "../src/raven/notifications_view.vala"
	_tmp5_ = _tmp4_;
#line 31 "../src/raven/notifications_view.vala"
	_g_free0 (_tmp3_);
#line 31 "../src/raven/notifications_view.vala"
	label = _tmp5_;
#line 32 "../src/raven/notifications_view.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 33 "../src/raven/notifications_view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) label, FALSE, FALSE, (guint) 0);
#line 35 "../src/raven/notifications_view.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 36 "../src/raven/notifications_view.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 38 "../src/raven/notifications_view.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 24 "../src/raven/notifications_view.vala"
	_g_object_unref0 (label);
#line 24 "../src/raven/notifications_view.vala"
	_g_object_unref0 (image);
#line 24 "../src/raven/notifications_view.vala"
	return self;
#line 454 "notifications_view.c"
}

BudgieNotificationPlaceholder*
budgie_notification_placeholder_new (void)
{
#line 24 "../src/raven/notifications_view.vala"
	return budgie_notification_placeholder_construct (BUDGIE_TYPE_NOTIFICATION_PLACEHOLDER);
#line 462 "notifications_view.c"
}

static void
budgie_notification_placeholder_class_init (BudgieNotificationPlaceholderClass * klass,
                                            gpointer klass_data)
{
#line 23 "../src/raven/notifications_view.vala"
	budgie_notification_placeholder_parent_class = g_type_class_peek_parent (klass);
#line 471 "notifications_view.c"
}

static void
budgie_notification_placeholder_instance_init (BudgieNotificationPlaceholder * self,
                                               gpointer klass)
{
}

/**
* Simple placeholder to use when there are no notifications
*/
static GType
budgie_notification_placeholder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationPlaceholderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notification_placeholder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotificationPlaceholder), 0, (GInstanceInitFunc) budgie_notification_placeholder_instance_init, NULL };
	GType budgie_notification_placeholder_type_id;
	budgie_notification_placeholder_type_id = g_type_register_static (gtk_box_get_type (), "BudgieNotificationPlaceholder", &g_define_type_info, 0);
	return budgie_notification_placeholder_type_id;
}

GType
budgie_notification_placeholder_get_type (void)
{
	static volatile gsize budgie_notification_placeholder_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_placeholder_type_id__once)) {
		GType budgie_notification_placeholder_type_id;
		budgie_notification_placeholder_type_id = budgie_notification_placeholder_get_type_once ();
		g_once_init_leave (&budgie_notification_placeholder_type_id__once, budgie_notification_placeholder_type_id);
	}
	return budgie_notification_placeholder_type_id__once;
}

gboolean
budgie_dispatcher_get_do_not_disturb (BudgieDispatcher* self,
                                      GError** error)
{
	BudgieDispatcherIface* _iface_;
#line 62 "../src/raven/notifications_view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/raven/notifications_view.vala"
	_iface_ = BUDGIE_DISPATCHER_GET_INTERFACE (self);
#line 62 "../src/raven/notifications_view.vala"
	if (_iface_->get_do_not_disturb) {
#line 62 "../src/raven/notifications_view.vala"
		return _iface_->get_do_not_disturb (self, error);
#line 517 "notifications_view.c"
	}
#line 62 "../src/raven/notifications_view.vala"
	return FALSE;
#line 521 "notifications_view.c"
}

void
budgie_dispatcher_toggle_do_not_disturb (BudgieDispatcher* self,
                                         GError** error)
{
	BudgieDispatcherIface* _iface_;
#line 63 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/raven/notifications_view.vala"
	_iface_ = BUDGIE_DISPATCHER_GET_INTERFACE (self);
#line 63 "../src/raven/notifications_view.vala"
	if (_iface_->toggle_do_not_disturb) {
#line 63 "../src/raven/notifications_view.vala"
		_iface_->toggle_do_not_disturb (self, error);
#line 537 "notifications_view.c"
	}
}

gboolean
budgie_dispatcher_get_notifications_paused (BudgieDispatcher* self)
{
	BudgieDispatcherIface* _iface_;
#line 47 "../src/raven/notifications_view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../src/raven/notifications_view.vala"
	_iface_ = BUDGIE_DISPATCHER_GET_INTERFACE (self);
#line 47 "../src/raven/notifications_view.vala"
	if (_iface_->get_notifications_paused) {
#line 47 "../src/raven/notifications_view.vala"
		return _iface_->get_notifications_paused (self);
#line 553 "notifications_view.c"
	}
#line 47 "../src/raven/notifications_view.vala"
	return FALSE;
#line 557 "notifications_view.c"
}

void
budgie_dispatcher_set_notifications_paused (BudgieDispatcher* self,
                                            gboolean value)
{
	BudgieDispatcherIface* _iface_;
#line 47 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/raven/notifications_view.vala"
	_iface_ = BUDGIE_DISPATCHER_GET_INTERFACE (self);
#line 47 "../src/raven/notifications_view.vala"
	if (_iface_->set_notifications_paused) {
#line 47 "../src/raven/notifications_view.vala"
		_iface_->set_notifications_paused (self, value);
#line 573 "notifications_view.c"
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_INT_BOXED_INT (GClosure * closure,
                                                                                    GValue * return_value,
                                                                                    guint n_param_values,
                                                                                    const GValue * param_values,
                                                                                    gpointer invocation_hint,
                                                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_INT_BOXED_INT) (gpointer data1, const char* arg_1, guint32 arg_2, const char* arg_3, const char* arg_4, const char* arg_5, gpointer arg_6, gint arg_7, gpointer arg_8, gint32 arg_9, gpointer data2);
	register GMarshalFunc_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_INT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 46 "../src/raven/notifications_view.vala"
	g_return_if_fail (n_param_values == 10);
#line 46 "../src/raven/notifications_view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 46 "../src/raven/notifications_view.vala"
		data1 = closure->data;
#line 46 "../src/raven/notifications_view.vala"
		data2 = param_values->data[0].v_pointer;
#line 599 "notifications_view.c"
	} else {
#line 46 "../src/raven/notifications_view.vala"
		data1 = param_values->data[0].v_pointer;
#line 46 "../src/raven/notifications_view.vala"
		data2 = closure->data;
#line 605 "notifications_view.c"
	}
#line 46 "../src/raven/notifications_view.vala"
	callback = (GMarshalFunc_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_INT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 46 "../src/raven/notifications_view.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_uint (param_values + 2), g_value_get_string (param_values + 3), g_value_get_string (param_values + 4), g_value_get_string (param_values + 5), g_value_get_boxed (param_values + 6), g_value_get_int (param_values + 7), g_value_get_boxed (param_values + 8), g_value_get_int (param_values + 9), data2);
#line 611 "notifications_view.c"
}

static void
g_cclosure_user_marshal_VOID__UINT_STRING_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_STRING_ENUM) (gpointer data1, guint32 arg_1, const char* arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__UINT_STRING_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 46 "../src/raven/notifications_view.vala"
	g_return_if_fail (n_param_values == 4);
#line 46 "../src/raven/notifications_view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 46 "../src/raven/notifications_view.vala"
		data1 = closure->data;
#line 46 "../src/raven/notifications_view.vala"
		data2 = param_values->data[0].v_pointer;
#line 636 "notifications_view.c"
	} else {
#line 46 "../src/raven/notifications_view.vala"
		data1 = param_values->data[0].v_pointer;
#line 46 "../src/raven/notifications_view.vala"
		data2 = closure->data;
#line 642 "notifications_view.c"
	}
#line 46 "../src/raven/notifications_view.vala"
	callback = (GMarshalFunc_VOID__UINT_STRING_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 46 "../src/raven/notifications_view.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_string (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 648 "notifications_view.c"
}

static void
budgie_dispatcher_default_init (BudgieDispatcherIface * iface,
                                gpointer iface_data)
{
#line 46 "../src/raven/notifications_view.vala"
	budgie_dispatcher_signals[BUDGIE_DISPATCHER_NOTIFICATION_ADDED_SIGNAL] = g_signal_new ("notification-added", BUDGIE_TYPE_DISPATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_INT_BOXED_INT, G_TYPE_NONE, 9, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRV, G_TYPE_INT, G_TYPE_HASH_TABLE, G_TYPE_INT);
#line 46 "../src/raven/notifications_view.vala"
	budgie_dispatcher_signals[BUDGIE_DISPATCHER_NOTIFICATION_CLOSED_SIGNAL] = g_signal_new ("notification-closed", BUDGIE_TYPE_DISPATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_STRING_ENUM, G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_STRING, BUDGIE_TYPE_NOTIFICATION_CLOSE_REASON);
#line 659 "notifications_view.c"
}

static GType
budgie_dispatcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieDispatcherIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_dispatcher_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType budgie_dispatcher_type_id;
	budgie_dispatcher_type_id = g_type_register_static (G_TYPE_INTERFACE, "BudgieDispatcher", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (budgie_dispatcher_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (budgie_dispatcher_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) budgie_dispatcher_proxy_get_type);
	g_type_set_qdata (budgie_dispatcher_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.buddiesofbudgie.budgie.Dispatcher");
	g_type_set_qdata (budgie_dispatcher_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_budgie_dispatcher_dbus_interface_info));
	g_type_set_qdata (budgie_dispatcher_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) budgie_dispatcher_register_object);
	return budgie_dispatcher_type_id;
}

GType
budgie_dispatcher_get_type (void)
{
	static volatile gsize budgie_dispatcher_type_id__once = 0;
	if (g_once_init_enter (&budgie_dispatcher_type_id__once)) {
		GType budgie_dispatcher_type_id;
		budgie_dispatcher_type_id = budgie_dispatcher_get_type_once ();
		g_once_init_leave (&budgie_dispatcher_type_id__once, budgie_dispatcher_type_id);
	}
	return budgie_dispatcher_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (BudgieDispatcherProxy, budgie_dispatcher_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BUDGIE_TYPE_DISPATCHER, budgie_dispatcher_proxy_budgie_dispatcher_interface_init) )
static void
budgie_dispatcher_proxy_class_init (BudgieDispatcherProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = budgie_dispatcher_proxy_g_signal;
}

static void
_dbus_handle_budgie_dispatcher_notification_added (BudgieDispatcher* self,
                                                   GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* app_name = NULL;
	GVariant* _tmp0_;
	guint32 id = 0U;
	GVariant* _tmp1_;
	gchar* app_icon = NULL;
	GVariant* _tmp2_;
	gchar* summary = NULL;
	GVariant* _tmp3_;
	gchar* body = NULL;
	GVariant* _tmp4_;
	gchar** actions = NULL;
	gint actions_length1;
	GVariant* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length;
	gint _tmp6__size;
	gint _tmp6__length1;
	GVariantIter _tmp7_;
	GVariant* _tmp8_;
	GHashTable* hints = NULL;
	GVariant* _tmp9_;
	GHashTable* _tmp10_;
	GVariantIter _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint32 expire_timeout = 0;
	GVariant* _tmp14_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	app_name = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_get_uint32 (_tmp1_);
	g_variant_unref (_tmp1_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	app_icon = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	summary = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	body = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	actions_length1 = 0;
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp6_ = g_new (gchar*, 5);
	_tmp6__length = 0;
	_tmp6__size = 4;
	_tmp6__length1 = 0;
	g_variant_iter_init (&_tmp7_, _tmp5_);
	for (; (_tmp8_ = g_variant_iter_next_value (&_tmp7_)) != NULL; _tmp6__length1++) {
		if (_tmp6__size == _tmp6__length) {
			_tmp6__size = 2 * _tmp6__size;
			_tmp6_ = g_renew (gchar*, _tmp6_, _tmp6__size + 1);
		}
		_tmp6_[_tmp6__length++] = g_variant_dup_string (_tmp8_, NULL);
		g_variant_unref (_tmp8_);
	}
	actions_length1 = _tmp6__length1;
	_tmp6_[_tmp6__length] = NULL;
	actions = _tmp6_;
	g_variant_unref (_tmp5_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp10_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp11_, _tmp9_);
	while (g_variant_iter_loop (&_tmp11_, "{?*}", &_tmp12_, &_tmp13_)) {
		g_hash_table_insert (_tmp10_, g_variant_dup_string (_tmp12_, NULL), g_variant_get_variant (_tmp13_));
	}
	hints = _tmp10_;
	g_variant_unref (_tmp9_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	expire_timeout = g_variant_get_int32 (_tmp14_);
	g_variant_unref (_tmp14_);
	g_signal_emit_by_name (self, "notification-added", app_name, id, app_icon, summary, body, actions, actions_length1, hints, expire_timeout);
	_g_free0 (app_name);
	_g_free0 (app_icon);
	_g_free0 (summary);
	_g_free0 (body);
	actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_free), NULL);
	_g_hash_table_unref0 (hints);
}

static void
_dbus_handle_budgie_dispatcher_notification_closed (BudgieDispatcher* self,
                                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 id = 0U;
	GVariant* _tmp15_;
	gchar* app_name = NULL;
	GVariant* _tmp16_;
	BudgieNotificationCloseReason reason = 0;
	GVariant* _tmp17_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_get_uint32 (_tmp15_);
	g_variant_unref (_tmp15_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	app_name = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_get_int32 (_tmp17_);
	g_variant_unref (_tmp17_);
	g_signal_emit_by_name (self, "notification-closed", id, app_name, reason);
	_g_free0 (app_name);
}

static void
budgie_dispatcher_proxy_g_signal (GDBusProxy* proxy,
                                  const gchar* sender_name,
                                  const gchar* signal_name,
                                  GVariant* parameters)
{
	if (strcmp (signal_name, "NotificationAdded") == 0) {
		_dbus_handle_budgie_dispatcher_notification_added ((BudgieDispatcher*) proxy, parameters);
	} else if (strcmp (signal_name, "NotificationClosed") == 0) {
		_dbus_handle_budgie_dispatcher_notification_closed ((BudgieDispatcher*) proxy, parameters);
	}
}

static void
budgie_dispatcher_proxy_init (BudgieDispatcherProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_budgie_dispatcher_dbus_interface_info));
}

static gboolean
budgie_dispatcher_proxy_get_do_not_disturb (BudgieDispatcher* self,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp20_;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.buddiesofbudgie.budgie.Dispatcher", "GetDoNotDisturb");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp18_ = FALSE;
		return _tmp18_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp19_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp19_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp20_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp20_);
	g_variant_unref (_tmp20_);
	g_object_unref (_reply_message);
	return _result;
}

static void
budgie_dispatcher_proxy_toggle_do_not_disturb (BudgieDispatcher* self,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.buddiesofbudgie.budgie.Dispatcher", "ToggleDoNotDisturb");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gboolean
budgie_dispatcher_dbus_proxy_get_notifications_paused (BudgieDispatcher* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "NotificationsPaused");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.buddiesofbudgie.budgie.Dispatcher"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("NotificationsPaused"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp21_ = FALSE;
			return _tmp21_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
budgie_dispatcher_dbus_proxy_set_notifications_paused (BudgieDispatcher* self,
                                                       gboolean value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.buddiesofbudgie.budgie.Dispatcher"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("NotificationsPaused"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}

static void
budgie_dispatcher_proxy_budgie_dispatcher_interface_init (BudgieDispatcherIface* iface)
{
	iface->get_do_not_disturb = budgie_dispatcher_proxy_get_do_not_disturb;
	iface->toggle_do_not_disturb = budgie_dispatcher_proxy_toggle_do_not_disturb;
	iface->get_notifications_paused = budgie_dispatcher_dbus_proxy_get_notifications_paused;
	iface->set_notifications_paused = budgie_dispatcher_dbus_proxy_set_notifications_paused;
}

static void
_dbus_budgie_dispatcher_get_do_not_disturb (BudgieDispatcher* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = budgie_dispatcher_get_do_not_disturb (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_budgie_dispatcher_toggle_do_not_disturb (BudgieDispatcher* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	budgie_dispatcher_toggle_do_not_disturb (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
budgie_dispatcher_dbus_interface_method_call (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* method_name,
                                              GVariant* parameters,
                                              GDBusMethodInvocation* invocation,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetDoNotDisturb") == 0) {
		_dbus_budgie_dispatcher_get_do_not_disturb (object, parameters, invocation);
	} else if (strcmp (method_name, "ToggleDoNotDisturb") == 0) {
		_dbus_budgie_dispatcher_toggle_do_not_disturb (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_budgie_dispatcher_get_notifications_paused (BudgieDispatcher* self)
{
	gboolean result;
	GVariant* _reply;
	result = budgie_dispatcher_get_notifications_paused (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
budgie_dispatcher_dbus_interface_get_property (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* property_name,
                                               GError** error,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "NotificationsPaused") == 0) {
		return _dbus_budgie_dispatcher_get_notifications_paused (object);
	}
	return NULL;
}

static void
_dbus_budgie_dispatcher_set_notifications_paused (BudgieDispatcher* self,
                                                  GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	budgie_dispatcher_set_notifications_paused (self, value);
}

static gboolean
budgie_dispatcher_dbus_interface_set_property (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* property_name,
                                               GVariant* value,
                                               GError** error,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "NotificationsPaused") == 0) {
		_dbus_budgie_dispatcher_set_notifications_paused (object, value);
		return TRUE;
	}
	return FALSE;
}

static void
_dbus_budgie_dispatcher_notification_added (GObject* _sender,
                                            const gchar* app_name,
                                            guint32 id,
                                            const gchar* app_icon,
                                            const gchar* summary,
                                            const gchar* body,
                                            gchar** actions,
                                            gint actions_length1,
                                            GHashTable* hints,
                                            gint32 expire_timeout,
                                            gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp22_;
	GVariantBuilder _tmp23_;
	gint _tmp24_;
	GVariantBuilder _tmp25_;
	GHashTableIter _tmp26_;
	gpointer _tmp27_;
	gpointer _tmp28_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_icon));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (summary));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (body));
	_tmp22_ = actions;
	g_variant_builder_init (&_tmp23_, G_VARIANT_TYPE ("as"));
	for (_tmp24_ = 0; _tmp24_ < actions_length1; _tmp24_++) {
		g_variant_builder_add_value (&_tmp23_, g_variant_new_string (*_tmp22_));
		_tmp22_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp23_));
	g_hash_table_iter_init (&_tmp26_, hints);
	g_variant_builder_init (&_tmp25_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp26_, &_tmp27_, &_tmp28_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp27_;
		_value = (GVariant*) _tmp28_;
		g_variant_builder_add (&_tmp25_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp25_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (expire_timeout));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.buddiesofbudgie.budgie.Dispatcher", "NotificationAdded", _arguments, NULL);
}

static void
_dbus_budgie_dispatcher_notification_closed (GObject* _sender,
                                             guint32 id,
                                             const gchar* app_name,
                                             BudgieNotificationCloseReason reason,
                                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (reason));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.buddiesofbudgie.budgie.Dispatcher", "NotificationClosed", _arguments, NULL);
}

guint
budgie_dispatcher_register_object (gpointer object,
                                   GDBusConnection* connection,
                                   const gchar* path,
                                   GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_budgie_dispatcher_dbus_interface_info), &_budgie_dispatcher_dbus_interface_vtable, data, _budgie_dispatcher_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "notification-added", (GCallback) _dbus_budgie_dispatcher_notification_added, data);
	g_signal_connect (object, "notification-closed", (GCallback) _dbus_budgie_dispatcher_notification_closed, data);
	return result;
}

static void
_budgie_dispatcher_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_budgie_dispatcher_notification_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_budgie_dispatcher_notification_closed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
budgie_raven_interface_default_init (BudgieRavenInterfaceIface * iface,
                                     gpointer iface_data)
{
#line 67 "../src/raven/notifications_view.vala"
	budgie_raven_interface_signals[BUDGIE_RAVEN_INTERFACE_CLEAR_ALL_NOTIFICATIONS_SIGNAL] = g_signal_new ("clear-all-notifications", BUDGIE_TYPE_RAVEN_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1196 "notifications_view.c"
}

static GType
budgie_raven_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieRavenInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_raven_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType budgie_raven_interface_type_id;
	budgie_raven_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "BudgieRavenInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (budgie_raven_interface_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (budgie_raven_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) budgie_raven_interface_proxy_get_type);
	g_type_set_qdata (budgie_raven_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.budgie_desktop.Raven");
	g_type_set_qdata (budgie_raven_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_budgie_raven_interface_dbus_interface_info));
	g_type_set_qdata (budgie_raven_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) budgie_raven_interface_register_object);
	return budgie_raven_interface_type_id;
}

GType
budgie_raven_interface_get_type (void)
{
	static volatile gsize budgie_raven_interface_type_id__once = 0;
	if (g_once_init_enter (&budgie_raven_interface_type_id__once)) {
		GType budgie_raven_interface_type_id;
		budgie_raven_interface_type_id = budgie_raven_interface_get_type_once ();
		g_once_init_leave (&budgie_raven_interface_type_id__once, budgie_raven_interface_type_id);
	}
	return budgie_raven_interface_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (BudgieRavenInterfaceProxy, budgie_raven_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BUDGIE_TYPE_RAVEN_INTERFACE, budgie_raven_interface_proxy_budgie_raven_interface_interface_init) )
static void
budgie_raven_interface_proxy_class_init (BudgieRavenInterfaceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = budgie_raven_interface_proxy_g_signal;
}

static void
_dbus_handle_budgie_raven_interface_clear_all_notifications (BudgieRavenInterface* self,
                                                             GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "clear-all-notifications");
}

static void
budgie_raven_interface_proxy_g_signal (GDBusProxy* proxy,
                                       const gchar* sender_name,
                                       const gchar* signal_name,
                                       GVariant* parameters)
{
	if (strcmp (signal_name, "ClearAllNotifications") == 0) {
		_dbus_handle_budgie_raven_interface_clear_all_notifications ((BudgieRavenInterface*) proxy, parameters);
	}
}

static void
budgie_raven_interface_proxy_init (BudgieRavenInterfaceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_budgie_raven_interface_dbus_interface_info));
}

static void
budgie_raven_interface_proxy_budgie_raven_interface_interface_init (BudgieRavenInterfaceIface* iface)
{
}

static void
budgie_raven_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* method_name,
                                                   GVariant* parameters,
                                                   GDBusMethodInvocation* invocation,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
budgie_raven_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GError** error,
                                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
budgie_raven_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_budgie_raven_interface_clear_all_notifications (GObject* _sender,
                                                      gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.budgie_desktop.Raven", "ClearAllNotifications", _arguments, NULL);
}

guint
budgie_raven_interface_register_object (gpointer object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_budgie_raven_interface_dbus_interface_info), &_budgie_raven_interface_dbus_interface_vtable, data, _budgie_raven_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "clear-all-notifications", (GCallback) _dbus_budgie_raven_interface_clear_all_notifications, data);
	return result;
}

static void
_budgie_raven_interface_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_budgie_raven_interface_clear_all_notifications, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
budgie_notifications_view_get_instance_private (BudgieNotificationsView* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieNotificationsView_private_offset);
}

static void
_budgie_notifications_view_on_notification_added_budgie_dispatcher_notification_added (BudgieDispatcher* _sender,
                                                                                       const gchar* app_name,
                                                                                       guint32 id,
                                                                                       const gchar* app_icon,
                                                                                       const gchar* summary,
                                                                                       const gchar* body,
                                                                                       gchar** actions,
                                                                                       gint actions_length1,
                                                                                       GHashTable* hints,
                                                                                       gint32 expire_timeout,
                                                                                       gpointer self)
{
#line 181 "../src/raven/notifications_view.vala"
	budgie_notifications_view_on_notification_added ((BudgieNotificationsView*) self, app_name, id, app_icon, summary, body, actions, actions_length1, hints, expire_timeout);
#line 1381 "notifications_view.c"
}

static void
_budgie_notifications_view_on_notification_closed_budgie_dispatcher_notification_closed (BudgieDispatcher* _sender,
                                                                                         guint32 id,
                                                                                         const gchar* app_name,
                                                                                         BudgieNotificationCloseReason reason,
                                                                                         gpointer self)
{
#line 182 "../src/raven/notifications_view.vala"
	budgie_notifications_view_on_notification_closed ((BudgieNotificationsView*) self, id, app_name, reason);
#line 1393 "notifications_view.c"
}

static void
budgie_notifications_view_on_dbus_get (BudgieNotificationsView* self,
                                       GObject* o,
                                       GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 178 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 1404 "notifications_view.c"
	{
		BudgieDispatcher* _tmp0_ = NULL;
		BudgieDispatcher* _tmp1_;
		BudgieDispatcher* _tmp2_;
		BudgieDispatcher* _tmp3_;
		BudgieDispatcher* _tmp4_;
		BudgieDispatcher* _tmp5_;
		gboolean _tmp6_ = FALSE;
		BudgieDispatcher* _tmp7_;
		GtkImage* _tmp8_ = NULL;
		gboolean _tmp9_;
		GtkButton* _tmp12_;
#line 180 "../src/raven/notifications_view.vala"
		_tmp1_ = g_async_result_get_source_object (res);
#line 180 "../src/raven/notifications_view.vala"
		_tmp2_ = (BudgieDispatcher*) g_async_initable_new_finish ((GAsyncInitable *) _tmp1_, res, &_inner_error0_);
#line 180 "../src/raven/notifications_view.vala"
		g_object_unref (_tmp1_);
#line 180 "../src/raven/notifications_view.vala"
		_tmp0_ = (BudgieDispatcher*) _tmp2_;
#line 180 "../src/raven/notifications_view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1427 "notifications_view.c"
			goto __catch0_g_error;
		}
#line 180 "../src/raven/notifications_view.vala"
		_tmp3_ = _tmp0_;
#line 180 "../src/raven/notifications_view.vala"
		_tmp0_ = NULL;
#line 180 "../src/raven/notifications_view.vala"
		_g_object_unref0 (self->priv->dispatcher);
#line 180 "../src/raven/notifications_view.vala"
		self->priv->dispatcher = _tmp3_;
#line 181 "../src/raven/notifications_view.vala"
		_tmp4_ = self->priv->dispatcher;
#line 181 "../src/raven/notifications_view.vala"
		g_signal_connect_object (_tmp4_, "notification-added", (GCallback) _budgie_notifications_view_on_notification_added_budgie_dispatcher_notification_added, self, 0);
#line 182 "../src/raven/notifications_view.vala"
		_tmp5_ = self->priv->dispatcher;
#line 182 "../src/raven/notifications_view.vala"
		g_signal_connect_object (_tmp5_, "notification-closed", (GCallback) _budgie_notifications_view_on_notification_closed_budgie_dispatcher_notification_closed, self, 0);
#line 184 "../src/raven/notifications_view.vala"
		_tmp7_ = self->priv->dispatcher;
#line 184 "../src/raven/notifications_view.vala"
		_tmp6_ = budgie_dispatcher_get_do_not_disturb (_tmp7_, &_inner_error0_);
#line 184 "../src/raven/notifications_view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../src/raven/notifications_view.vala"
			_g_object_unref0 (_tmp0_);
#line 1454 "notifications_view.c"
			goto __catch0_g_error;
		}
#line 184 "../src/raven/notifications_view.vala"
		budgie_notifications_view_set_do_not_disturb (self, _tmp6_);
#line 185 "../src/raven/notifications_view.vala"
		_tmp9_ = self->priv->_do_not_disturb;
#line 185 "../src/raven/notifications_view.vala"
		if (_tmp9_) {
#line 1463 "notifications_view.c"
			GtkImage* _tmp10_;
#line 185 "../src/raven/notifications_view.vala"
			_tmp10_ = self->priv->image_notifications_disabled;
#line 185 "../src/raven/notifications_view.vala"
			_tmp8_ = _tmp10_;
#line 1469 "notifications_view.c"
		} else {
			GtkImage* _tmp11_;
#line 185 "../src/raven/notifications_view.vala"
			_tmp11_ = self->priv->image_notifications_enabled;
#line 185 "../src/raven/notifications_view.vala"
			_tmp8_ = _tmp11_;
#line 1476 "notifications_view.c"
		}
#line 185 "../src/raven/notifications_view.vala"
		_tmp12_ = self->priv->button_mute;
#line 185 "../src/raven/notifications_view.vala"
		gtk_button_set_image (_tmp12_, (GtkWidget*) _tmp8_);
#line 179 "../src/raven/notifications_view.vala"
		_g_object_unref0 (_tmp0_);
#line 1484 "notifications_view.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 179 "../src/raven/notifications_view.vala"
		e = _inner_error0_;
#line 179 "../src/raven/notifications_view.vala"
		_inner_error0_ = NULL;
#line 187 "../src/raven/notifications_view.vala"
		_tmp13_ = e;
#line 187 "../src/raven/notifications_view.vala"
		_tmp14_ = _tmp13_->message;
#line 187 "../src/raven/notifications_view.vala"
		g_critical ("notifications_view.vala:187: Unable to connect to notifications dispat" \
"cher: %s", _tmp14_);
#line 179 "../src/raven/notifications_view.vala"
		_g_error_free0 (e);
#line 1504 "notifications_view.c"
	}
	__finally0:
#line 179 "../src/raven/notifications_view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "../src/raven/notifications_view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "../src/raven/notifications_view.vala"
		g_clear_error (&_inner_error0_);
#line 179 "../src/raven/notifications_view.vala"
		return;
#line 1515 "notifications_view.c"
	}
}

static void
_budgie_notifications_view_clear_all_budgie_raven_interface_clear_all_notifications (BudgieRavenInterface* _sender,
                                                                                     gpointer self)
{
#line 194 "../src/raven/notifications_view.vala"
	budgie_notifications_view_clear_all ((BudgieNotificationsView*) self);
#line 1525 "notifications_view.c"
}

static void
budgie_notifications_view_on_raven_get (BudgieNotificationsView* self,
                                        GObject* o,
                                        GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 191 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 1536 "notifications_view.c"
	{
		BudgieRavenInterface* _tmp0_ = NULL;
		BudgieRavenInterface* _tmp1_;
		BudgieRavenInterface* _tmp2_;
		BudgieRavenInterface* _tmp3_;
		BudgieRavenInterface* _tmp4_;
#line 193 "../src/raven/notifications_view.vala"
		_tmp1_ = g_async_result_get_source_object (res);
#line 193 "../src/raven/notifications_view.vala"
		_tmp2_ = (BudgieRavenInterface*) g_async_initable_new_finish ((GAsyncInitable *) _tmp1_, res, &_inner_error0_);
#line 193 "../src/raven/notifications_view.vala"
		g_object_unref (_tmp1_);
#line 193 "../src/raven/notifications_view.vala"
		_tmp0_ = (BudgieRavenInterface*) _tmp2_;
#line 193 "../src/raven/notifications_view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1553 "notifications_view.c"
			goto __catch0_g_error;
		}
#line 193 "../src/raven/notifications_view.vala"
		_tmp3_ = _tmp0_;
#line 193 "../src/raven/notifications_view.vala"
		_tmp0_ = NULL;
#line 193 "../src/raven/notifications_view.vala"
		_g_object_unref0 (self->priv->raven);
#line 193 "../src/raven/notifications_view.vala"
		self->priv->raven = _tmp3_;
#line 194 "../src/raven/notifications_view.vala"
		_tmp4_ = self->priv->raven;
#line 194 "../src/raven/notifications_view.vala"
		g_signal_connect_object (_tmp4_, "clear-all-notifications", (GCallback) _budgie_notifications_view_clear_all_budgie_raven_interface_clear_all_notifications, self, 0);
#line 192 "../src/raven/notifications_view.vala"
		_g_object_unref0 (_tmp0_);
#line 1570 "notifications_view.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 192 "../src/raven/notifications_view.vala"
		e = _inner_error0_;
#line 192 "../src/raven/notifications_view.vala"
		_inner_error0_ = NULL;
#line 196 "../src/raven/notifications_view.vala"
		_tmp5_ = e;
#line 196 "../src/raven/notifications_view.vala"
		_tmp6_ = _tmp5_->message;
#line 196 "../src/raven/notifications_view.vala"
		g_critical ("notifications_view.vala:196: Unable to connect to Raven via DBUS: %s", _tmp6_);
#line 192 "../src/raven/notifications_view.vala"
		_g_error_free0 (e);
#line 1590 "notifications_view.c"
	}
	__finally0:
#line 192 "../src/raven/notifications_view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/raven/notifications_view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/raven/notifications_view.vala"
		g_clear_error (&_inner_error0_);
#line 192 "../src/raven/notifications_view.vala"
		return;
#line 1601 "notifications_view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 221 "../src/raven/notifications_view.vala"
	return self ? g_object_ref (self) : NULL;
#line 1610 "notifications_view.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1632 "notifications_view.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1636 "notifications_view.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1642 "notifications_view.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1646 "notifications_view.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1650 "notifications_view.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1658 "notifications_view.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1686 "notifications_view.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1695 "notifications_view.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1709 "notifications_view.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1718 "notifications_view.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1732 "notifications_view.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1741 "notifications_view.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1750 "notifications_view.c"
}

static void
budgie_notifications_view_on_notification_added (BudgieNotificationsView* self,
                                                 const gchar* app_name,
                                                 guint32 id,
                                                 const gchar* app_icon,
                                                 const gchar* summary,
                                                 const gchar* body,
                                                 gchar** actions,
                                                 gint actions_length1,
                                                 GHashTable* hints,
                                                 gint32 expire_timeout)
{
	BudgieNotification* notification = NULL;
	BudgieNotification* _tmp0_;
	GHashTable* _tmp1_;
	BudgieNotification* _tmp2_;
	BudgieNotification* _tmp3_;
	gchar* settings_app_name = NULL;
	gchar* _tmp4_;
	GSettings* application_settings = NULL;
	GSettingsSchemaSource* _tmp10_;
	GSettingsSchema* _tmp11_;
	GSettingsSchema* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean no_popup = FALSE;
#line 200 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/raven/notifications_view.vala"
	g_return_if_fail (app_name != NULL);
#line 200 "../src/raven/notifications_view.vala"
	g_return_if_fail (app_icon != NULL);
#line 200 "../src/raven/notifications_view.vala"
	g_return_if_fail (summary != NULL);
#line 200 "../src/raven/notifications_view.vala"
	g_return_if_fail (body != NULL);
#line 200 "../src/raven/notifications_view.vala"
	g_return_if_fail (hints != NULL);
#line 210 "../src/raven/notifications_view.vala"
	_tmp0_ = budgie_notification_new (id, app_name, app_icon, summary, body, actions, actions_length1, hints, (guint) expire_timeout);
#line 210 "../src/raven/notifications_view.vala"
	notification = _tmp0_;
#line 221 "../src/raven/notifications_view.vala"
	_tmp1_ = self->priv->notifications;
#line 221 "../src/raven/notifications_view.vala"
	_tmp2_ = notification;
#line 221 "../src/raven/notifications_view.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 221 "../src/raven/notifications_view.vala"
	g_hash_table_insert (_tmp1_, (gpointer) ((guintptr) id), _tmp3_);
#line 223 "../src/raven/notifications_view.vala"
	_tmp4_ = g_strdup (app_name);
#line 223 "../src/raven/notifications_view.vala"
	settings_app_name = _tmp4_;
#line 227 "../src/raven/notifications_view.vala"
	if (g_hash_table_contains (hints, "desktop-entry")) {
#line 1815 "notifications_view.c"
		gconstpointer _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 228 "../src/raven/notifications_view.vala"
		_tmp5_ = g_hash_table_lookup (hints, "desktop-entry");
#line 228 "../src/raven/notifications_view.vala"
		_tmp6_ = g_variant_get_string ((GVariant*) _tmp5_, NULL);
#line 228 "../src/raven/notifications_view.vala"
		_tmp7_ = string_replace (_tmp6_, ".", "-");
#line 228 "../src/raven/notifications_view.vala"
		_tmp8_ = _tmp7_;
#line 228 "../src/raven/notifications_view.vala"
		_tmp9_ = g_utf8_strdown (_tmp8_, (gssize) -1);
#line 228 "../src/raven/notifications_view.vala"
		_g_free0 (settings_app_name);
#line 228 "../src/raven/notifications_view.vala"
		settings_app_name = _tmp9_;
#line 228 "../src/raven/notifications_view.vala"
		_g_free0 (_tmp8_);
#line 1837 "notifications_view.c"
	}
#line 231 "../src/raven/notifications_view.vala"
	_tmp10_ = g_settings_schema_source_get_default ();
#line 231 "../src/raven/notifications_view.vala"
	_tmp11_ = g_settings_schema_source_lookup (_tmp10_, BUDGIE_NOTIFICATIONS_VIEW_APPLICATION_SCHEMA, TRUE);
#line 231 "../src/raven/notifications_view.vala"
	_tmp12_ = _tmp11_;
#line 231 "../src/raven/notifications_view.vala"
	_tmp13_ = settings_app_name;
#line 231 "../src/raven/notifications_view.vala"
	_tmp14_ = g_strdup_printf ("%s/%s/", BUDGIE_NOTIFICATIONS_VIEW_APPLICATION_PREFIX, _tmp13_);
#line 231 "../src/raven/notifications_view.vala"
	_tmp15_ = _tmp14_;
#line 231 "../src/raven/notifications_view.vala"
	_tmp16_ = g_settings_new_full (_tmp12_, NULL, _tmp15_);
#line 231 "../src/raven/notifications_view.vala"
	_tmp17_ = _tmp16_;
#line 231 "../src/raven/notifications_view.vala"
	_g_free0 (_tmp15_);
#line 231 "../src/raven/notifications_view.vala"
	_g_settings_schema_unref0 (_tmp12_);
#line 231 "../src/raven/notifications_view.vala"
	application_settings = _tmp17_;
#line 239 "../src/raven/notifications_view.vala"
	_tmp20_ = self->priv->_do_not_disturb;
#line 239 "../src/raven/notifications_view.vala"
	if (_tmp20_) {
#line 239 "../src/raven/notifications_view.vala"
		_tmp19_ = TRUE;
#line 1867 "notifications_view.c"
	} else {
		BudgieDispatcher* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
#line 240 "../src/raven/notifications_view.vala"
		_tmp21_ = self->priv->dispatcher;
#line 240 "../src/raven/notifications_view.vala"
		_tmp22_ = budgie_dispatcher_get_notifications_paused (_tmp21_);
#line 240 "../src/raven/notifications_view.vala"
		_tmp23_ = _tmp22_;
#line 240 "../src/raven/notifications_view.vala"
		_tmp19_ = _tmp23_;
#line 1880 "notifications_view.c"
	}
#line 239 "../src/raven/notifications_view.vala"
	if (_tmp19_) {
#line 239 "../src/raven/notifications_view.vala"
		_tmp18_ = TRUE;
#line 1886 "notifications_view.c"
	} else {
		GSettings* _tmp24_;
#line 241 "../src/raven/notifications_view.vala"
		_tmp24_ = application_settings;
#line 241 "../src/raven/notifications_view.vala"
		_tmp18_ = !g_settings_get_boolean (_tmp24_, "show-banners");
#line 1893 "notifications_view.c"
	}
#line 239 "../src/raven/notifications_view.vala"
	no_popup = _tmp18_;
#line 243 "../src/raven/notifications_view.vala"
	if (no_popup) {
#line 244 "../src/raven/notifications_view.vala"
		budgie_notifications_view_on_notification_closed (self, id, app_name, BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED);
#line 1901 "notifications_view.c"
	}
#line 200 "../src/raven/notifications_view.vala"
	_g_object_unref0 (application_settings);
#line 200 "../src/raven/notifications_view.vala"
	_g_free0 (settings_app_name);
#line 200 "../src/raven/notifications_view.vala"
	_g_object_unref0 (notification);
#line 1909 "notifications_view.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 262 "../src/raven/notifications_view.vala"
	for (i = 0; i < stack_length; i++) {
#line 262 "../src/raven/notifications_view.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 262 "../src/raven/notifications_view.vala"
			return TRUE;
#line 1924 "notifications_view.c"
		}
	}
#line 262 "../src/raven/notifications_view.vala"
	return FALSE;
#line 1929 "notifications_view.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 264 "../src/raven/notifications_view.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 264 "../src/raven/notifications_view.vala"
	return _data3_;
#line 1939 "notifications_view.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 264 "../src/raven/notifications_view.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1949 "notifications_view.c"
		BudgieNotificationsView* self;
#line 264 "../src/raven/notifications_view.vala"
		self = _data3_->self;
#line 264 "../src/raven/notifications_view.vala"
		_g_object_unref0 (_data3_->group);
#line 264 "../src/raven/notifications_view.vala"
		_g_object_unref0 (self);
#line 264 "../src/raven/notifications_view.vala"
		g_slice_free (Block3Data, _data3_);
#line 1959 "notifications_view.c"
	}
}

static void
_____lambda11_ (Block3Data* _data3_,
                const gchar* name)
{
	BudgieNotificationsView* self;
	GtkContainer* parent = NULL;
	BudgieNotificationGroup* _tmp0_;
	GtkContainer* _tmp1_;
	GtkContainer* _tmp2_;
	GtkListBox* _tmp3_;
	GtkContainer* _tmp4_;
	GtkContainer* _tmp5_;
	gboolean _tmp6_;
	BudgieRaven* _tmp8_;
#line 294 "../src/raven/notifications_view.vala"
	self = _data3_->self;
#line 294 "../src/raven/notifications_view.vala"
	g_return_if_fail (name != NULL);
#line 295 "../src/raven/notifications_view.vala"
	_tmp0_ = _data3_->group;
#line 295 "../src/raven/notifications_view.vala"
	_tmp1_ = gtk_widget_get_parent ((GtkWidget*) _tmp0_);
#line 295 "../src/raven/notifications_view.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 295 "../src/raven/notifications_view.vala"
	parent = _tmp2_;
#line 296 "../src/raven/notifications_view.vala"
	_tmp3_ = self->priv->listbox;
#line 296 "../src/raven/notifications_view.vala"
	_tmp4_ = parent;
#line 296 "../src/raven/notifications_view.vala"
	gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 297 "../src/raven/notifications_view.vala"
	_tmp5_ = parent;
#line 297 "../src/raven/notifications_view.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 303 "../src/raven/notifications_view.vala"
	_tmp6_ = self->priv->_performing_clear_all;
#line 303 "../src/raven/notifications_view.vala"
	if (!_tmp6_) {
#line 2003 "notifications_view.c"
		GHashTable* _tmp7_;
#line 304 "../src/raven/notifications_view.vala"
		_tmp7_ = self->priv->notification_groups;
#line 304 "../src/raven/notifications_view.vala"
		g_hash_table_remove (_tmp7_, name);
#line 305 "../src/raven/notifications_view.vala"
		budgie_notifications_view_update_child_count (self);
#line 2011 "notifications_view.c"
	}
#line 308 "../src/raven/notifications_view.vala"
	_tmp8_ = budgie_raven_get_instance ();
#line 308 "../src/raven/notifications_view.vala"
	budgie_raven_ReadNotifications (_tmp8_);
#line 294 "../src/raven/notifications_view.vala"
	_g_object_unref0 (parent);
#line 2019 "notifications_view.c"
}

static void
______lambda11__budgie_notification_group_dismissed_group (BudgieNotificationGroup* _sender,
                                                           const gchar* app_name,
                                                           gpointer self)
{
#line 294 "../src/raven/notifications_view.vala"
	_____lambda11_ (self, app_name);
#line 2029 "notifications_view.c"
}

static void
_____lambda22_ (BudgieNotificationsView* self,
                guint32 id)
{
	BudgieRaven* _tmp0_;
#line 312 "../src/raven/notifications_view.vala"
	budgie_notifications_view_update_child_count (self);
#line 313 "../src/raven/notifications_view.vala"
	_tmp0_ = budgie_raven_get_instance ();
#line 313 "../src/raven/notifications_view.vala"
	budgie_raven_ReadNotifications (_tmp0_);
#line 2043 "notifications_view.c"
}

static void
______lambda22__budgie_notification_group_dismissed_notification (BudgieNotificationGroup* _sender,
                                                                  guint32 id,
                                                                  gpointer self)
{
#line 311 "../src/raven/notifications_view.vala"
	_____lambda22_ ((BudgieNotificationsView*) self, id);
#line 2053 "notifications_view.c"
}

static void
budgie_notifications_view_on_notification_closed (BudgieNotificationsView* self,
                                                  guint32 id,
                                                  const gchar* app_name,
                                                  BudgieNotificationCloseReason reason)
{
	BudgieNotification* notification = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	BudgieNotification* _tmp2_;
	BudgieNotification* _tmp3_;
	GHashTable* _tmp97_;
#line 248 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/raven/notifications_view.vala"
	g_return_if_fail (app_name != NULL);
#line 249 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->notifications;
#line 249 "../src/raven/notifications_view.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((guintptr) id));
#line 249 "../src/raven/notifications_view.vala"
	_tmp2_ = _g_object_ref0 ((BudgieNotification*) _tmp1_);
#line 249 "../src/raven/notifications_view.vala"
	notification = _tmp2_;
#line 250 "../src/raven/notifications_view.vala"
	_tmp3_ = notification;
#line 250 "../src/raven/notifications_view.vala"
	if (_tmp3_ == NULL) {
#line 2084 "notifications_view.c"
		GHashTable* _tmp4_;
#line 251 "../src/raven/notifications_view.vala"
		_tmp4_ = self->priv->notifications;
#line 251 "../src/raven/notifications_view.vala"
		g_hash_table_remove (_tmp4_, (gpointer) ((guintptr) id));
#line 252 "../src/raven/notifications_view.vala"
		_g_object_unref0 (notification);
#line 252 "../src/raven/notifications_view.vala"
		return;
#line 2094 "notifications_view.c"
	}
#line 257 "../src/raven/notifications_view.vala"
	if (reason == BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED) {
#line 2098 "notifications_view.c"
		gchar** spam_apps = NULL;
		GSettings* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint spam_apps_length1;
		gint _spam_apps_size_;
		gchar** spam_categories = NULL;
		GSettings* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gint spam_categories_length1;
		gint _spam_categories_size_;
		const gchar* _tmp11_ = NULL;
		BudgieNotification* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* app_id = NULL;
		gchar* _tmp18_;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		BudgieNotification* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gboolean should_store = FALSE;
#line 258 "../src/raven/notifications_view.vala"
		_tmp5_ = self->priv->budgie_settings;
#line 258 "../src/raven/notifications_view.vala"
		_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, BUDGIE_ROOT_KEY_SPAM_APPS);
#line 258 "../src/raven/notifications_view.vala"
		spam_apps = _tmp7_;
#line 258 "../src/raven/notifications_view.vala"
		spam_apps_length1 = _vala_array_length (_tmp6_);
#line 258 "../src/raven/notifications_view.vala"
		_spam_apps_size_ = spam_apps_length1;
#line 259 "../src/raven/notifications_view.vala"
		_tmp8_ = self->priv->budgie_settings;
#line 259 "../src/raven/notifications_view.vala"
		_tmp10_ = _tmp9_ = g_settings_get_strv (_tmp8_, BUDGIE_ROOT_KEY_SPAM_CATEGORIES);
#line 259 "../src/raven/notifications_view.vala"
		spam_categories = _tmp10_;
#line 259 "../src/raven/notifications_view.vala"
		spam_categories_length1 = _vala_array_length (_tmp9_);
#line 259 "../src/raven/notifications_view.vala"
		_spam_categories_size_ = spam_categories_length1;
#line 261 "../src/raven/notifications_view.vala"
		_tmp12_ = notification;
#line 261 "../src/raven/notifications_view.vala"
		_tmp13_ = budgie_notification_get_app_id (_tmp12_);
#line 261 "../src/raven/notifications_view.vala"
		_tmp14_ = _tmp13_;
#line 261 "../src/raven/notifications_view.vala"
		if (_tmp14_ != NULL) {
#line 2151 "notifications_view.c"
			BudgieNotification* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 261 "../src/raven/notifications_view.vala"
			_tmp15_ = notification;
#line 261 "../src/raven/notifications_view.vala"
			_tmp16_ = budgie_notification_get_app_id (_tmp15_);
#line 261 "../src/raven/notifications_view.vala"
			_tmp17_ = _tmp16_;
#line 261 "../src/raven/notifications_view.vala"
			_tmp11_ = _tmp17_;
#line 2163 "notifications_view.c"
		} else {
#line 261 "../src/raven/notifications_view.vala"
			_tmp11_ = app_name;
#line 2167 "notifications_view.c"
		}
#line 261 "../src/raven/notifications_view.vala"
		_tmp18_ = g_strdup (_tmp11_);
#line 261 "../src/raven/notifications_view.vala"
		app_id = _tmp18_;
#line 262 "../src/raven/notifications_view.vala"
		_tmp21_ = notification;
#line 262 "../src/raven/notifications_view.vala"
		_tmp22_ = budgie_notification_get_category (_tmp21_);
#line 262 "../src/raven/notifications_view.vala"
		_tmp23_ = _tmp22_;
#line 262 "../src/raven/notifications_view.vala"
		if (_tmp23_ != NULL) {
#line 2181 "notifications_view.c"
			BudgieNotification* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar** _tmp27_;
			gint _tmp27__length1;
#line 262 "../src/raven/notifications_view.vala"
			_tmp24_ = notification;
#line 262 "../src/raven/notifications_view.vala"
			_tmp25_ = budgie_notification_get_category (_tmp24_);
#line 262 "../src/raven/notifications_view.vala"
			_tmp26_ = _tmp25_;
#line 262 "../src/raven/notifications_view.vala"
			_tmp27_ = spam_categories;
#line 262 "../src/raven/notifications_view.vala"
			_tmp27__length1 = spam_categories_length1;
#line 262 "../src/raven/notifications_view.vala"
			_tmp20_ = _vala_string_array_contains (_tmp27_, _tmp27__length1, _tmp26_);
#line 2199 "notifications_view.c"
		} else {
#line 262 "../src/raven/notifications_view.vala"
			_tmp20_ = FALSE;
#line 2203 "notifications_view.c"
		}
#line 262 "../src/raven/notifications_view.vala"
		if (!_tmp20_) {
#line 2207 "notifications_view.c"
			gboolean _tmp28_ = FALSE;
			const gchar* _tmp29_;
#line 263 "../src/raven/notifications_view.vala"
			_tmp29_ = app_id;
#line 263 "../src/raven/notifications_view.vala"
			if (_tmp29_ != NULL) {
#line 2214 "notifications_view.c"
				const gchar* _tmp30_;
				gchar** _tmp31_;
				gint _tmp31__length1;
#line 263 "../src/raven/notifications_view.vala"
				_tmp30_ = app_id;
#line 263 "../src/raven/notifications_view.vala"
				_tmp31_ = spam_apps;
#line 263 "../src/raven/notifications_view.vala"
				_tmp31__length1 = spam_apps_length1;
#line 263 "../src/raven/notifications_view.vala"
				_tmp28_ = _vala_string_array_contains (_tmp31_, _tmp31__length1, _tmp30_);
#line 2226 "notifications_view.c"
			} else {
#line 263 "../src/raven/notifications_view.vala"
				_tmp28_ = FALSE;
#line 2230 "notifications_view.c"
			}
#line 263 "../src/raven/notifications_view.vala"
			_tmp19_ = !_tmp28_;
#line 2234 "notifications_view.c"
		} else {
#line 262 "../src/raven/notifications_view.vala"
			_tmp19_ = FALSE;
#line 2238 "notifications_view.c"
		}
#line 262 "../src/raven/notifications_view.vala"
		should_store = _tmp19_;
#line 264 "../src/raven/notifications_view.vala"
		if (should_store) {
#line 2244 "notifications_view.c"
			Block3Data* _data3_;
			const gchar* _tmp32_ = NULL;
			gboolean _tmp33_ = FALSE;
			gchar* app_icon = NULL;
			gchar* _tmp34_;
			gboolean _tmp35_ = FALSE;
			BudgieNotification* _tmp36_;
			GtkImage* _tmp37_;
			GtkImage* _tmp38_;
			const gchar* _tmp50_;
			gchar* _tmp51_;
			const gchar* _tmp52_;
			gchar* name = NULL;
			BudgieNotification* _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			BudgieNotification* _tmp58_;
			GDesktopAppInfo* _tmp59_;
			GDesktopAppInfo* _tmp60_;
			GHashTable* _tmp75_;
			const gchar* _tmp76_;
			gconstpointer _tmp77_;
			BudgieNotificationGroup* _tmp78_;
			BudgieNotificationGroup* _tmp79_;
			BudgieNotificationGroup* _tmp93_;
			BudgieNotification* _tmp94_;
			BudgieNotificationGroup* _tmp95_;
			BudgieRaven* _tmp96_;
#line 264 "../src/raven/notifications_view.vala"
			_data3_ = g_slice_new0 (Block3Data);
#line 264 "../src/raven/notifications_view.vala"
			_data3_->_ref_count_ = 1;
#line 264 "../src/raven/notifications_view.vala"
			_data3_->self = g_object_ref (self);
#line 266 "../src/raven/notifications_view.vala"
			if (g_strcmp0 (app_name, "") != 0) {
#line 266 "../src/raven/notifications_view.vala"
				_tmp33_ = app_name != NULL;
#line 2284 "notifications_view.c"
			} else {
#line 266 "../src/raven/notifications_view.vala"
				_tmp33_ = FALSE;
#line 2288 "notifications_view.c"
			}
#line 266 "../src/raven/notifications_view.vala"
			if (_tmp33_) {
#line 266 "../src/raven/notifications_view.vala"
				_tmp32_ = app_name;
#line 2294 "notifications_view.c"
			} else {
#line 266 "../src/raven/notifications_view.vala"
				_tmp32_ = "applications-internet";
#line 2298 "notifications_view.c"
			}
#line 266 "../src/raven/notifications_view.vala"
			_tmp34_ = g_strdup (_tmp32_);
#line 266 "../src/raven/notifications_view.vala"
			app_icon = _tmp34_;
#line 268 "../src/raven/notifications_view.vala"
			_tmp36_ = notification;
#line 268 "../src/raven/notifications_view.vala"
			_tmp37_ = budgie_notification_get_image (_tmp36_);
#line 268 "../src/raven/notifications_view.vala"
			_tmp38_ = _tmp37_;
#line 268 "../src/raven/notifications_view.vala"
			if (_tmp38_ != NULL) {
#line 2312 "notifications_view.c"
				BudgieNotification* _tmp39_;
				GtkImage* _tmp40_;
				GtkImage* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 268 "../src/raven/notifications_view.vala"
				_tmp39_ = notification;
#line 268 "../src/raven/notifications_view.vala"
				_tmp40_ = budgie_notification_get_image (_tmp39_);
#line 268 "../src/raven/notifications_view.vala"
				_tmp41_ = _tmp40_;
#line 268 "../src/raven/notifications_view.vala"
				g_object_get (_tmp41_, "icon-name", &_tmp42_, NULL);
#line 268 "../src/raven/notifications_view.vala"
				_tmp43_ = _tmp42_;
#line 268 "../src/raven/notifications_view.vala"
				_tmp44_ = _tmp43_;
#line 268 "../src/raven/notifications_view.vala"
				_tmp35_ = _tmp44_ != NULL;
#line 268 "../src/raven/notifications_view.vala"
				_g_free0 (_tmp44_);
#line 2335 "notifications_view.c"
			} else {
#line 268 "../src/raven/notifications_view.vala"
				_tmp35_ = FALSE;
#line 2339 "notifications_view.c"
			}
#line 268 "../src/raven/notifications_view.vala"
			if (_tmp35_) {
#line 2343 "notifications_view.c"
				BudgieNotification* _tmp45_;
				GtkImage* _tmp46_;
				GtkImage* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
#line 269 "../src/raven/notifications_view.vala"
				_tmp45_ = notification;
#line 269 "../src/raven/notifications_view.vala"
				_tmp46_ = budgie_notification_get_image (_tmp45_);
#line 269 "../src/raven/notifications_view.vala"
				_tmp47_ = _tmp46_;
#line 269 "../src/raven/notifications_view.vala"
				g_object_get (_tmp47_, "icon-name", &_tmp48_, NULL);
#line 269 "../src/raven/notifications_view.vala"
				_tmp49_ = _tmp48_;
#line 269 "../src/raven/notifications_view.vala"
				_g_free0 (app_icon);
#line 269 "../src/raven/notifications_view.vala"
				app_icon = _tmp49_;
#line 2363 "notifications_view.c"
			}
#line 272 "../src/raven/notifications_view.vala"
			_tmp50_ = app_icon;
#line 272 "../src/raven/notifications_view.vala"
			_tmp51_ = g_utf8_strdown (_tmp50_, (gssize) -1);
#line 272 "../src/raven/notifications_view.vala"
			_g_free0 (app_icon);
#line 272 "../src/raven/notifications_view.vala"
			app_icon = _tmp51_;
#line 274 "../src/raven/notifications_view.vala"
			_tmp52_ = app_icon;
#line 274 "../src/raven/notifications_view.vala"
			if (g_strcmp0 (_tmp52_, "image-invalid") == 0) {
#line 2377 "notifications_view.c"
				gchar* _tmp53_;
#line 275 "../src/raven/notifications_view.vala"
				_tmp53_ = g_strdup ("applications-internet");
#line 275 "../src/raven/notifications_view.vala"
				_g_free0 (app_icon);
#line 275 "../src/raven/notifications_view.vala"
				app_icon = _tmp53_;
#line 2385 "notifications_view.c"
			}
#line 278 "../src/raven/notifications_view.vala"
			_tmp54_ = notification;
#line 278 "../src/raven/notifications_view.vala"
			_tmp55_ = budgie_notification_get_app_name (_tmp54_);
#line 278 "../src/raven/notifications_view.vala"
			_tmp56_ = _tmp55_;
#line 278 "../src/raven/notifications_view.vala"
			_tmp57_ = g_strdup (_tmp56_);
#line 278 "../src/raven/notifications_view.vala"
			name = _tmp57_;
#line 279 "../src/raven/notifications_view.vala"
			_tmp58_ = notification;
#line 279 "../src/raven/notifications_view.vala"
			_tmp59_ = budgie_notification_get_app_info (_tmp58_);
#line 279 "../src/raven/notifications_view.vala"
			_tmp60_ = _tmp59_;
#line 279 "../src/raven/notifications_view.vala"
			if (_tmp60_ != NULL) {
#line 2405 "notifications_view.c"
				BudgieNotification* _tmp61_;
				GDesktopAppInfo* _tmp62_;
				GDesktopAppInfo* _tmp63_;
				BudgieNotification* _tmp68_;
				GDesktopAppInfo* _tmp69_;
				GDesktopAppInfo* _tmp70_;
#line 280 "../src/raven/notifications_view.vala"
				_tmp61_ = notification;
#line 280 "../src/raven/notifications_view.vala"
				_tmp62_ = budgie_notification_get_app_info (_tmp61_);
#line 280 "../src/raven/notifications_view.vala"
				_tmp63_ = _tmp62_;
#line 280 "../src/raven/notifications_view.vala"
				if (g_desktop_app_info_has_key (_tmp63_, "Icon")) {
#line 2420 "notifications_view.c"
					BudgieNotification* _tmp64_;
					GDesktopAppInfo* _tmp65_;
					GDesktopAppInfo* _tmp66_;
					gchar* _tmp67_;
#line 281 "../src/raven/notifications_view.vala"
					_tmp64_ = notification;
#line 281 "../src/raven/notifications_view.vala"
					_tmp65_ = budgie_notification_get_app_info (_tmp64_);
#line 281 "../src/raven/notifications_view.vala"
					_tmp66_ = _tmp65_;
#line 281 "../src/raven/notifications_view.vala"
					_tmp67_ = g_desktop_app_info_get_string (_tmp66_, "Icon");
#line 281 "../src/raven/notifications_view.vala"
					_g_free0 (app_icon);
#line 281 "../src/raven/notifications_view.vala"
					app_icon = _tmp67_;
#line 2437 "notifications_view.c"
				}
#line 283 "../src/raven/notifications_view.vala"
				_tmp68_ = notification;
#line 283 "../src/raven/notifications_view.vala"
				_tmp69_ = budgie_notification_get_app_info (_tmp68_);
#line 283 "../src/raven/notifications_view.vala"
				_tmp70_ = _tmp69_;
#line 283 "../src/raven/notifications_view.vala"
				if (g_desktop_app_info_has_key (_tmp70_, "Name")) {
#line 2447 "notifications_view.c"
					BudgieNotification* _tmp71_;
					GDesktopAppInfo* _tmp72_;
					GDesktopAppInfo* _tmp73_;
					gchar* _tmp74_;
#line 284 "../src/raven/notifications_view.vala"
					_tmp71_ = notification;
#line 284 "../src/raven/notifications_view.vala"
					_tmp72_ = budgie_notification_get_app_info (_tmp71_);
#line 284 "../src/raven/notifications_view.vala"
					_tmp73_ = _tmp72_;
#line 284 "../src/raven/notifications_view.vala"
					_tmp74_ = g_desktop_app_info_get_string (_tmp73_, "Name");
#line 284 "../src/raven/notifications_view.vala"
					_g_free0 (name);
#line 284 "../src/raven/notifications_view.vala"
					name = _tmp74_;
#line 2464 "notifications_view.c"
				}
			}
#line 289 "../src/raven/notifications_view.vala"
			_tmp75_ = self->priv->notification_groups;
#line 289 "../src/raven/notifications_view.vala"
			_tmp76_ = name;
#line 289 "../src/raven/notifications_view.vala"
			_tmp77_ = g_hash_table_lookup (_tmp75_, _tmp76_);
#line 289 "../src/raven/notifications_view.vala"
			_tmp78_ = _g_object_ref0 ((BudgieNotificationGroup*) _tmp77_);
#line 289 "../src/raven/notifications_view.vala"
			_data3_->group = _tmp78_;
#line 290 "../src/raven/notifications_view.vala"
			_tmp79_ = _data3_->group;
#line 290 "../src/raven/notifications_view.vala"
			if (_tmp79_ == NULL) {
#line 2481 "notifications_view.c"
				const gchar* _tmp80_;
				const gchar* _tmp81_;
				BudgieNotificationSort _tmp82_;
				BudgieNotificationGroup* _tmp83_;
				GtkListBox* _tmp84_;
				BudgieNotificationGroup* _tmp85_;
				BudgieNotificationGroup* _tmp86_;
				BudgieNotificationGroup* _tmp87_;
				GHashTable* _tmp88_;
				const gchar* _tmp89_;
				gchar* _tmp90_;
				BudgieNotificationGroup* _tmp91_;
				BudgieNotificationGroup* _tmp92_;
#line 291 "../src/raven/notifications_view.vala"
				_tmp80_ = app_icon;
#line 291 "../src/raven/notifications_view.vala"
				_tmp81_ = name;
#line 291 "../src/raven/notifications_view.vala"
				_tmp82_ = self->priv->_sort_mode;
#line 291 "../src/raven/notifications_view.vala"
				_tmp83_ = budgie_notification_group_new (_tmp80_, _tmp81_, _tmp82_, self->priv->max_per_group);
#line 291 "../src/raven/notifications_view.vala"
				g_object_ref_sink (_tmp83_);
#line 291 "../src/raven/notifications_view.vala"
				_g_object_unref0 (_data3_->group);
#line 291 "../src/raven/notifications_view.vala"
				_data3_->group = _tmp83_;
#line 292 "../src/raven/notifications_view.vala"
				_tmp84_ = self->priv->listbox;
#line 292 "../src/raven/notifications_view.vala"
				_tmp85_ = _data3_->group;
#line 292 "../src/raven/notifications_view.vala"
				gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp85_);
#line 294 "../src/raven/notifications_view.vala"
				_tmp86_ = _data3_->group;
#line 294 "../src/raven/notifications_view.vala"
				g_signal_connect_data (_tmp86_, "dismissed-group", (GCallback) ______lambda11__budgie_notification_group_dismissed_group, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 311 "../src/raven/notifications_view.vala"
				_tmp87_ = _data3_->group;
#line 311 "../src/raven/notifications_view.vala"
				g_signal_connect_object (_tmp87_, "dismissed-notification", (GCallback) ______lambda22__budgie_notification_group_dismissed_notification, self, 0);
#line 316 "../src/raven/notifications_view.vala"
				_tmp88_ = self->priv->notification_groups;
#line 316 "../src/raven/notifications_view.vala"
				_tmp89_ = name;
#line 316 "../src/raven/notifications_view.vala"
				_tmp90_ = g_strdup (_tmp89_);
#line 316 "../src/raven/notifications_view.vala"
				_tmp91_ = _data3_->group;
#line 316 "../src/raven/notifications_view.vala"
				_tmp92_ = _g_object_ref0 (_tmp91_);
#line 316 "../src/raven/notifications_view.vala"
				g_hash_table_insert (_tmp88_, _tmp90_, _tmp92_);
#line 2535 "notifications_view.c"
			}
#line 320 "../src/raven/notifications_view.vala"
			_tmp93_ = _data3_->group;
#line 320 "../src/raven/notifications_view.vala"
			_tmp94_ = notification;
#line 320 "../src/raven/notifications_view.vala"
			budgie_notification_group_add_notification (_tmp93_, id, _tmp94_);
#line 321 "../src/raven/notifications_view.vala"
			_tmp95_ = _data3_->group;
#line 321 "../src/raven/notifications_view.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp95_);
#line 322 "../src/raven/notifications_view.vala"
			budgie_notifications_view_update_child_count (self);
#line 323 "../src/raven/notifications_view.vala"
			_tmp96_ = budgie_raven_get_instance ();
#line 323 "../src/raven/notifications_view.vala"
			budgie_raven_UnreadNotifications (_tmp96_);
#line 264 "../src/raven/notifications_view.vala"
			_g_free0 (name);
#line 264 "../src/raven/notifications_view.vala"
			_g_free0 (app_icon);
#line 264 "../src/raven/notifications_view.vala"
			block3_data_unref (_data3_);
#line 264 "../src/raven/notifications_view.vala"
			_data3_ = NULL;
#line 2561 "notifications_view.c"
		}
#line 257 "../src/raven/notifications_view.vala"
		_g_free0 (app_id);
#line 257 "../src/raven/notifications_view.vala"
		spam_categories = (_vala_array_free (spam_categories, spam_categories_length1, (GDestroyNotify) g_free), NULL);
#line 257 "../src/raven/notifications_view.vala"
		spam_apps = (_vala_array_free (spam_apps, spam_apps_length1, (GDestroyNotify) g_free), NULL);
#line 2569 "notifications_view.c"
	}
#line 326 "../src/raven/notifications_view.vala"
	_tmp97_ = self->priv->notifications;
#line 326 "../src/raven/notifications_view.vala"
	g_hash_table_remove (_tmp97_, (gpointer) ((guintptr) id));
#line 248 "../src/raven/notifications_view.vala"
	_g_object_unref0 (notification);
#line 2577 "notifications_view.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 329 "../src/raven/notifications_view.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 329 "../src/raven/notifications_view.vala"
	return _data4_;
#line 2587 "notifications_view.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 329 "../src/raven/notifications_view.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2597 "notifications_view.c"
		BudgieNotificationsView* self;
#line 329 "../src/raven/notifications_view.vala"
		self = _data4_->self;
#line 329 "../src/raven/notifications_view.vala"
		_g_object_unref0 (self);
#line 329 "../src/raven/notifications_view.vala"
		g_slice_free (Block4Data, _data4_);
#line 2605 "notifications_view.c"
	}
}

static void
__lambda21_ (Block4Data* _data4_,
             const gchar* app_name,
             BudgieNotificationGroup* notification_group)
{
	BudgieNotificationsView* self;
#line 330 "../src/raven/notifications_view.vala"
	self = _data4_->self;
#line 330 "../src/raven/notifications_view.vala"
	g_return_if_fail (app_name != NULL);
#line 330 "../src/raven/notifications_view.vala"
	g_return_if_fail (notification_group != NULL);
#line 331 "../src/raven/notifications_view.vala"
	budgie_notification_group_set_group_max_notifications (notification_group, self->priv->max_per_group);
#line 332 "../src/raven/notifications_view.vala"
	if (_data4_->trim) {
#line 333 "../src/raven/notifications_view.vala"
		budgie_notification_group_limit_notifications (notification_group);
#line 2627 "notifications_view.c"
	}
}

static void
___lambda21__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 330 "../src/raven/notifications_view.vala"
	__lambda21_ (self, (const gchar*) key, (BudgieNotificationGroup*) value);
#line 2638 "notifications_view.c"
}

static void
budgie_notifications_view_adjust_max_per_group (BudgieNotificationsView* self,
                                                guint newmax,
                                                gboolean trim)
{
	Block4Data* _data4_;
	GHashTable* _tmp0_;
#line 329 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/raven/notifications_view.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 329 "../src/raven/notifications_view.vala"
	_data4_->_ref_count_ = 1;
#line 329 "../src/raven/notifications_view.vala"
	_data4_->self = g_object_ref (self);
#line 329 "../src/raven/notifications_view.vala"
	_data4_->trim = trim;
#line 330 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->notification_groups;
#line 330 "../src/raven/notifications_view.vala"
	g_hash_table_foreach (_tmp0_, ___lambda21__gh_func, _data4_);
#line 329 "../src/raven/notifications_view.vala"
	block4_data_unref (_data4_);
#line 329 "../src/raven/notifications_view.vala"
	_data4_ = NULL;
#line 2666 "notifications_view.c"
}

static void
budgie_notifications_view_check_notification_allocation (BudgieNotificationsView* self,
                                                         guint len)
{
	guint n_groups = 0U;
	GHashTable* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint newmax = 0U;
	gboolean trim = FALSE;
#line 338 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->notification_groups;
#line 339 "../src/raven/notifications_view.vala"
	_tmp1_ = g_hash_table_size (_tmp0_);
#line 339 "../src/raven/notifications_view.vala"
	_tmp2_ = _tmp1_;
#line 339 "../src/raven/notifications_view.vala"
	n_groups = _tmp2_;
#line 340 "../src/raven/notifications_view.vala"
	newmax = self->priv->max_per_group;
#line 341 "../src/raven/notifications_view.vala"
	trim = FALSE;
#line 342 "../src/raven/notifications_view.vala"
	if (n_groups == ((guint) 0)) {
#line 344 "../src/raven/notifications_view.vala"
		newmax = BUDGIE_NOTIFICATIONS_VIEW_DEFAULT_MAX_PERGROUP;
#line 2697 "notifications_view.c"
	} else {
#line 345 "../src/raven/notifications_view.vala"
		if (len > BUDGIE_NOTIFICATIONS_VIEW_TOTAL_MAX_NOTIFICATIONS) {
#line 347 "../src/raven/notifications_view.vala"
			newmax = (guint) (((gfloat) BUDGIE_NOTIFICATIONS_VIEW_TOTAL_MAX_NOTIFICATIONS) / ((gfloat) n_groups));
#line 348 "../src/raven/notifications_view.vala"
			trim = TRUE;
#line 2705 "notifications_view.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 350 "../src/raven/notifications_view.vala"
			if (self->priv->max_per_group < BUDGIE_NOTIFICATIONS_VIEW_DEFAULT_MAX_PERGROUP) {
#line 351 "../src/raven/notifications_view.vala"
				_tmp3_ = (n_groups * (self->priv->max_per_group + 1)) <= BUDGIE_NOTIFICATIONS_VIEW_TOTAL_MAX_NOTIFICATIONS;
#line 2712 "notifications_view.c"
			} else {
#line 350 "../src/raven/notifications_view.vala"
				_tmp3_ = FALSE;
#line 2716 "notifications_view.c"
			}
#line 349 "../src/raven/notifications_view.vala"
			if (_tmp3_) {
#line 354 "../src/raven/notifications_view.vala"
				newmax = (guint) (((gfloat) BUDGIE_NOTIFICATIONS_VIEW_TOTAL_MAX_NOTIFICATIONS) / ((gfloat) n_groups));
#line 2722 "notifications_view.c"
			}
		}
	}
#line 356 "../src/raven/notifications_view.vala"
	if (newmax != self->priv->max_per_group) {
#line 357 "../src/raven/notifications_view.vala"
		self->priv->max_per_group = newmax;
#line 358 "../src/raven/notifications_view.vala"
		budgie_notifications_view_adjust_max_per_group (self, newmax, trim);
#line 2732 "notifications_view.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 362 "../src/raven/notifications_view.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 362 "../src/raven/notifications_view.vala"
	return _data5_;
#line 2743 "notifications_view.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 362 "../src/raven/notifications_view.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2753 "notifications_view.c"
		BudgieNotificationsView* self;
#line 362 "../src/raven/notifications_view.vala"
		self = _data5_->self;
#line 362 "../src/raven/notifications_view.vala"
		_g_object_unref0 (self);
#line 362 "../src/raven/notifications_view.vala"
		g_slice_free (Block5Data, _data5_);
#line 2761 "notifications_view.c"
	}
}

static void
___lambda12_ (Block5Data* _data5_,
              const gchar* app_name,
              BudgieNotificationGroup* notification_group)
{
	BudgieNotificationsView* self;
	gint _tmp0_;
	gint _tmp1_;
#line 366 "../src/raven/notifications_view.vala"
	self = _data5_->self;
#line 366 "../src/raven/notifications_view.vala"
	g_return_if_fail (app_name != NULL);
#line 366 "../src/raven/notifications_view.vala"
	g_return_if_fail (notification_group != NULL);
#line 367 "../src/raven/notifications_view.vala"
	_tmp0_ = budgie_notification_group_get_noti_count (notification_group);
#line 367 "../src/raven/notifications_view.vala"
	_tmp1_ = _tmp0_;
#line 367 "../src/raven/notifications_view.vala"
	_data5_->len += (guint) _tmp1_;
#line 2785 "notifications_view.c"
}

static void
____lambda12__gh_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
#line 366 "../src/raven/notifications_view.vala"
	___lambda12_ (self, (const gchar*) key, (BudgieNotificationGroup*) value);
#line 2795 "notifications_view.c"
}

static void
budgie_notifications_view_update_child_count (BudgieNotificationsView* self)
{
	Block5Data* _data5_;
	GHashTable* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	gchar* text = NULL;
	BudgieRaven* _tmp7_;
	BudgieHeaderWidget* _tmp8_;
	const gchar* _tmp9_;
	GtkButton* _tmp10_;
#line 362 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 362 "../src/raven/notifications_view.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 362 "../src/raven/notifications_view.vala"
	_data5_->_ref_count_ = 1;
#line 362 "../src/raven/notifications_view.vala"
	_data5_->self = g_object_ref (self);
#line 363 "../src/raven/notifications_view.vala"
	_data5_->len = (guint) 0;
#line 365 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->notification_groups;
#line 365 "../src/raven/notifications_view.vala"
	_tmp1_ = g_hash_table_size (_tmp0_);
#line 365 "../src/raven/notifications_view.vala"
	_tmp2_ = _tmp1_;
#line 365 "../src/raven/notifications_view.vala"
	if (_tmp2_ != ((guint) 0)) {
#line 2828 "notifications_view.c"
		GHashTable* _tmp3_;
#line 366 "../src/raven/notifications_view.vala"
		_tmp3_ = self->priv->notification_groups;
#line 366 "../src/raven/notifications_view.vala"
		g_hash_table_foreach (_tmp3_, ____lambda12__gh_func, _data5_);
#line 2834 "notifications_view.c"
	}
#line 371 "../src/raven/notifications_view.vala"
	text = NULL;
#line 372 "../src/raven/notifications_view.vala"
	if (_data5_->len > ((guint) 1)) {
#line 2840 "notifications_view.c"
		gchar* _tmp4_;
#line 373 "../src/raven/notifications_view.vala"
		_tmp4_ = g_strdup_printf (_ ("%u unread notifications"), _data5_->len);
#line 373 "../src/raven/notifications_view.vala"
		_g_free0 (text);
#line 373 "../src/raven/notifications_view.vala"
		text = _tmp4_;
#line 2848 "notifications_view.c"
	} else {
#line 374 "../src/raven/notifications_view.vala"
		if (_data5_->len == ((guint) 1)) {
#line 2852 "notifications_view.c"
			gchar* _tmp5_;
#line 375 "../src/raven/notifications_view.vala"
			_tmp5_ = g_strdup (_ ("1 unread notification"));
#line 375 "../src/raven/notifications_view.vala"
			_g_free0 (text);
#line 375 "../src/raven/notifications_view.vala"
			text = _tmp5_;
#line 2860 "notifications_view.c"
		} else {
			gchar* _tmp6_;
#line 377 "../src/raven/notifications_view.vala"
			_tmp6_ = g_strdup (_ ("No unread notifications"));
#line 377 "../src/raven/notifications_view.vala"
			_g_free0 (text);
#line 377 "../src/raven/notifications_view.vala"
			text = _tmp6_;
#line 2869 "notifications_view.c"
		}
	}
#line 380 "../src/raven/notifications_view.vala"
	_tmp7_ = budgie_raven_get_instance ();
#line 380 "../src/raven/notifications_view.vala"
	budgie_raven_set_notification_count (_tmp7_, _data5_->len);
#line 381 "../src/raven/notifications_view.vala"
	_tmp8_ = self->priv->header;
#line 381 "../src/raven/notifications_view.vala"
	_tmp9_ = text;
#line 381 "../src/raven/notifications_view.vala"
	budgie_header_widget_set_text (_tmp8_, _tmp9_);
#line 382 "../src/raven/notifications_view.vala"
	_tmp10_ = self->priv->clear_notifications_button;
#line 382 "../src/raven/notifications_view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, _data5_->len >= ((guint) 1));
#line 383 "../src/raven/notifications_view.vala"
	budgie_notifications_view_check_notification_allocation (self, _data5_->len);
#line 362 "../src/raven/notifications_view.vala"
	_g_free0 (text);
#line 362 "../src/raven/notifications_view.vala"
	block5_data_unref (_data5_);
#line 362 "../src/raven/notifications_view.vala"
	_data5_ = NULL;
#line 2894 "notifications_view.c"
}

static void
__lambda23_ (BudgieNotificationsView* self,
             const gchar* app_name,
             BudgieNotificationGroup* notification_group)
{
#line 389 "../src/raven/notifications_view.vala"
	g_return_if_fail (app_name != NULL);
#line 389 "../src/raven/notifications_view.vala"
	g_return_if_fail (notification_group != NULL);
#line 390 "../src/raven/notifications_view.vala"
	budgie_notification_group_dismiss_all (notification_group);
#line 2908 "notifications_view.c"
}

static void
___lambda23__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 389 "../src/raven/notifications_view.vala"
	__lambda23_ ((BudgieNotificationsView*) self, (const gchar*) key, (BudgieNotificationGroup*) value);
#line 2918 "notifications_view.c"
}

static void
budgie_notifications_view_clear_all (BudgieNotificationsView* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	BudgieRaven* _tmp2_;
#line 386 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 387 "../src/raven/notifications_view.vala"
	budgie_notifications_view_set_performing_clear_all (self, TRUE);
#line 389 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->notification_groups;
#line 389 "../src/raven/notifications_view.vala"
	g_hash_table_foreach (_tmp0_, ___lambda23__gh_func, self);
#line 393 "../src/raven/notifications_view.vala"
	_tmp1_ = self->priv->notification_groups;
#line 393 "../src/raven/notifications_view.vala"
	g_hash_table_remove_all (_tmp1_);
#line 394 "../src/raven/notifications_view.vala"
	budgie_notifications_view_set_performing_clear_all (self, FALSE);
#line 395 "../src/raven/notifications_view.vala"
	budgie_notifications_view_update_child_count (self);
#line 396 "../src/raven/notifications_view.vala"
	_tmp2_ = budgie_raven_get_instance ();
#line 396 "../src/raven/notifications_view.vala"
	budgie_raven_ReadNotifications (_tmp2_);
#line 2947 "notifications_view.c"
}

static void
budgie_notifications_view_do_not_disturb_toggle (BudgieNotificationsView* self)
{
	gboolean _tmp0_;
	GtkImage* _tmp1_ = NULL;
	gboolean _tmp2_;
	GtkButton* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 399 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->_do_not_disturb;
#line 400 "../src/raven/notifications_view.vala"
	budgie_notifications_view_set_do_not_disturb (self, !_tmp0_);
#line 401 "../src/raven/notifications_view.vala"
	_tmp2_ = self->priv->_do_not_disturb;
#line 401 "../src/raven/notifications_view.vala"
	if (!_tmp2_) {
#line 2968 "notifications_view.c"
		GtkImage* _tmp3_;
#line 401 "../src/raven/notifications_view.vala"
		_tmp3_ = self->priv->image_notifications_enabled;
#line 401 "../src/raven/notifications_view.vala"
		_tmp1_ = _tmp3_;
#line 2974 "notifications_view.c"
	} else {
		GtkImage* _tmp4_;
#line 401 "../src/raven/notifications_view.vala"
		_tmp4_ = self->priv->image_notifications_disabled;
#line 401 "../src/raven/notifications_view.vala"
		_tmp1_ = _tmp4_;
#line 2981 "notifications_view.c"
	}
#line 401 "../src/raven/notifications_view.vala"
	_tmp5_ = self->priv->button_mute;
#line 401 "../src/raven/notifications_view.vala"
	gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp1_);
#line 2987 "notifications_view.c"
	{
		BudgieDispatcher* _tmp6_;
#line 404 "../src/raven/notifications_view.vala"
		_tmp6_ = self->priv->dispatcher;
#line 404 "../src/raven/notifications_view.vala"
		budgie_dispatcher_toggle_do_not_disturb (_tmp6_, &_inner_error0_);
#line 404 "../src/raven/notifications_view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2996 "notifications_view.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 403 "../src/raven/notifications_view.vala"
		e = _inner_error0_;
#line 403 "../src/raven/notifications_view.vala"
		_inner_error0_ = NULL;
#line 406 "../src/raven/notifications_view.vala"
		_tmp7_ = e;
#line 406 "../src/raven/notifications_view.vala"
		_tmp8_ = _tmp7_->message;
#line 406 "../src/raven/notifications_view.vala"
		g_warning ("notifications_view.vala:406: Unable to toggle Do Not Disturb: %s", _tmp8_);
#line 403 "../src/raven/notifications_view.vala"
		_g_error_free0 (e);
#line 3018 "notifications_view.c"
	}
	__finally0:
#line 403 "../src/raven/notifications_view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 403 "../src/raven/notifications_view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 403 "../src/raven/notifications_view.vala"
		g_clear_error (&_inner_error0_);
#line 403 "../src/raven/notifications_view.vala"
		return;
#line 3029 "notifications_view.c"
	}
}

BudgieNotificationsView*
budgie_notifications_view_construct (GType object_type)
{
	BudgieNotificationsView * self = NULL;
#line 71 "../src/raven/notifications_view.vala"
	self = (BudgieNotificationsView*) g_object_new (object_type, NULL);
#line 71 "../src/raven/notifications_view.vala"
	return self;
#line 3041 "notifications_view.c"
}

BudgieNotificationsView*
budgie_notifications_view_new (void)
{
#line 71 "../src/raven/notifications_view.vala"
	return budgie_notifications_view_construct (BUDGIE_TYPE_NOTIFICATIONS_VIEW);
#line 3049 "notifications_view.c"
}

static gboolean
budgie_notifications_view_get_do_not_disturb (BudgieNotificationsView* self)
{
	gboolean result;
#line 87 "../src/raven/notifications_view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../src/raven/notifications_view.vala"
	result = self->priv->_do_not_disturb;
#line 87 "../src/raven/notifications_view.vala"
	return result;
#line 3062 "notifications_view.c"
}

static void
budgie_notifications_view_set_do_not_disturb (BudgieNotificationsView* self,
                                              gboolean value)
{
#line 87 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/raven/notifications_view.vala"
	self->priv->_do_not_disturb = value;
#line 3073 "notifications_view.c"
}

static gboolean
budgie_notifications_view_get_performing_clear_all (BudgieNotificationsView* self)
{
	gboolean result;
#line 88 "../src/raven/notifications_view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../src/raven/notifications_view.vala"
	result = self->priv->_performing_clear_all;
#line 88 "../src/raven/notifications_view.vala"
	return result;
#line 3086 "notifications_view.c"
}

static void
budgie_notifications_view_set_performing_clear_all (BudgieNotificationsView* self,
                                                    gboolean value)
{
#line 88 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/raven/notifications_view.vala"
	self->priv->_performing_clear_all = value;
#line 3097 "notifications_view.c"
}

static BudgieNotificationSort
budgie_notifications_view_get_sort_mode (BudgieNotificationsView* self)
{
	BudgieNotificationSort result;
#line 89 "../src/raven/notifications_view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 89 "../src/raven/notifications_view.vala"
	result = self->priv->_sort_mode;
#line 89 "../src/raven/notifications_view.vala"
	return result;
#line 3110 "notifications_view.c"
}

static void
budgie_notifications_view_set_sort_mode (BudgieNotificationsView* self,
                                         BudgieNotificationSort value)
{
#line 89 "../src/raven/notifications_view.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/raven/notifications_view.vala"
	self->priv->_sort_mode = value;
#line 3121 "notifications_view.c"
}

static void
_budgie_notifications_view_clear_all_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 127 "../src/raven/notifications_view.vala"
	budgie_notifications_view_clear_all ((BudgieNotificationsView*) self);
#line 3130 "notifications_view.c"
}

static void
_budgie_notifications_view_do_not_disturb_toggle_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self)
{
#line 128 "../src/raven/notifications_view.vala"
	budgie_notifications_view_do_not_disturb_toggle ((BudgieNotificationsView*) self);
#line 3139 "notifications_view.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 132 "../src/raven/notifications_view.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3147 "notifications_view.c"
}

static void
_g_free0_ (gpointer var)
{
#line 133 "../src/raven/notifications_view.vala"
	var = (g_free (var), NULL);
#line 3155 "notifications_view.c"
}

static void
__lambda25_ (BudgieNotificationsView* self,
             GtkWidget* row)
{
	BudgieNotificationGroup* group = NULL;
	GtkWidget* _tmp0_;
	BudgieNotificationGroup* _tmp1_;
	BudgieNotificationGroup* _tmp2_;
	BudgieNotificationSort _tmp3_;
#line 149 "../src/raven/notifications_view.vala"
	g_return_if_fail (row != NULL);
#line 150 "../src/raven/notifications_view.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 150 "../src/raven/notifications_view.vala"
	_tmp1_ = _g_object_ref0 (BUDGIE_IS_NOTIFICATION_GROUP (_tmp0_) ? ((BudgieNotificationGroup*) _tmp0_) : NULL);
#line 150 "../src/raven/notifications_view.vala"
	group = _tmp1_;
#line 151 "../src/raven/notifications_view.vala"
	_tmp2_ = group;
#line 151 "../src/raven/notifications_view.vala"
	_tmp3_ = self->priv->_sort_mode;
#line 151 "../src/raven/notifications_view.vala"
	budgie_notification_group_set_sort_mode (_tmp2_, _tmp3_);
#line 149 "../src/raven/notifications_view.vala"
	_g_object_unref0 (group);
#line 3183 "notifications_view.c"
}

static void
___lambda25__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 149 "../src/raven/notifications_view.vala"
	__lambda25_ ((BudgieNotificationsView*) self, widget);
#line 3192 "notifications_view.c"
}

static void
_budgie_notifications_view___lambda24_ (BudgieNotificationsView* self,
                                        const gchar* key)
{
	GSettings* _tmp0_;
	GtkListBox* _tmp1_;
#line 147 "../src/raven/notifications_view.vala"
	g_return_if_fail (key != NULL);
#line 148 "../src/raven/notifications_view.vala"
	_tmp0_ = self->priv->raven_settings;
#line 148 "../src/raven/notifications_view.vala"
	budgie_notifications_view_set_sort_mode (self, (BudgieNotificationSort) g_settings_get_enum (_tmp0_, key));
#line 149 "../src/raven/notifications_view.vala"
	_tmp1_ = self->priv->listbox;
#line 149 "../src/raven/notifications_view.vala"
	gtk_container_foreach ((GtkContainer*) _tmp1_, ___lambda25__gtk_callback, self);
#line 3211 "notifications_view.c"
}

static void
__budgie_notifications_view___lambda24__g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self)
{
#line 147 "../src/raven/notifications_view.vala"
	_budgie_notifications_view___lambda24_ ((BudgieNotificationsView*) self, key);
#line 3221 "notifications_view.c"
}

static void
_budgie_notifications_view_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                              GAsyncResult* res,
                                                              gpointer self)
{
#line 159 "../src/raven/notifications_view.vala"
	budgie_notifications_view_on_dbus_get ((BudgieNotificationsView*) self, source_object, res);
#line 159 "../src/raven/notifications_view.vala"
	g_object_unref (self);
#line 3233 "notifications_view.c"
}

static void
_budgie_notifications_view_on_raven_get_gasync_ready_callback (GObject* source_object,
                                                               GAsyncResult* res,
                                                               gpointer self)
{
#line 168 "../src/raven/notifications_view.vala"
	budgie_notifications_view_on_raven_get ((BudgieNotificationsView*) self, source_object, res);
#line 168 "../src/raven/notifications_view.vala"
	g_object_unref (self);
#line 3245 "notifications_view.c"
}

static GObject *
budgie_notifications_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieNotificationsView * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkImage* _tmp15_;
	GtkBox* control_buttons = NULL;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	GtkButton* _tmp18_;
	GtkBox* _tmp19_;
	GtkButton* _tmp20_;
	GtkBox* _tmp21_;
	BudgieHeaderWidget* _tmp22_;
	BudgieHeaderWidget* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	BudgieHeaderWidget* _tmp26_;
	GHashFunc _tmp27_;
	GEqualFunc _tmp28_;
	GHashTable* _tmp29_;
	GHashFunc _tmp30_;
	GEqualFunc _tmp31_;
	GHashTable* _tmp32_;
	GtkScrolledWindow* scrolledwindow = NULL;
	GtkScrolledWindow* _tmp33_;
	GtkScrolledWindow* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkScrolledWindow* _tmp36_;
	GtkScrolledWindow* _tmp37_;
	GtkListBox* _tmp38_;
	GtkListBox* _tmp39_;
	BudgieNotificationPlaceholder* placeholder = NULL;
	BudgieNotificationPlaceholder* _tmp40_;
	GtkListBox* _tmp41_;
	BudgieNotificationPlaceholder* _tmp42_;
	GtkScrolledWindow* _tmp43_;
	GtkListBox* _tmp44_;
	GSettings* _tmp45_;
	GSettings* _tmp46_;
	GError* _inner_error0_ = NULL;
#line 100 "../src/raven/notifications_view.vala"
	parent_class = G_OBJECT_CLASS (budgie_notifications_view_parent_class);
#line 100 "../src/raven/notifications_view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 100 "../src/raven/notifications_view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATIONS_VIEW, BudgieNotificationsView);
#line 101 "../src/raven/notifications_view.vala"
	_tmp0_ = g_settings_new (BUDGIE_NOTIFICATIONS_VIEW_BUDGIE_PANEL_SCHEMA);
#line 101 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->budgie_settings);
#line 101 "../src/raven/notifications_view.vala"
	self->priv->budgie_settings = _tmp0_;
#line 102 "../src/raven/notifications_view.vala"
	_tmp1_ = g_settings_new (BUDGIE_NOTIFICATIONS_VIEW_BUDGIE_RAVEN_SCHEMA);
#line 102 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 102 "../src/raven/notifications_view.vala"
	self->priv->raven_settings = _tmp1_;
#line 104 "../src/raven/notifications_view.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 105 "../src/raven/notifications_view.vala"
	gtk_box_set_spacing ((GtkBox*) self, 0);
#line 106 "../src/raven/notifications_view.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 106 "../src/raven/notifications_view.vala"
	gtk_style_context_add_class (_tmp2_, "raven-notifications-view");
#line 108 "../src/raven/notifications_view.vala"
	_tmp3_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-all-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 108 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp3_);
#line 108 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->clear_notifications_button);
#line 108 "../src/raven/notifications_view.vala"
	self->priv->clear_notifications_button = _tmp3_;
#line 109 "../src/raven/notifications_view.vala"
	_tmp4_ = self->priv->clear_notifications_button;
#line 109 "../src/raven/notifications_view.vala"
	gtk_button_set_relief (_tmp4_, GTK_RELIEF_NONE);
#line 110 "../src/raven/notifications_view.vala"
	_tmp5_ = self->priv->clear_notifications_button;
#line 110 "../src/raven/notifications_view.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_CENTER);
#line 111 "../src/raven/notifications_view.vala"
	_tmp6_ = self->priv->clear_notifications_button;
#line 111 "../src/raven/notifications_view.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, TRUE);
#line 112 "../src/raven/notifications_view.vala"
	_tmp7_ = self->priv->clear_notifications_button;
#line 112 "../src/raven/notifications_view.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 112 "../src/raven/notifications_view.vala"
	gtk_style_context_add_class (_tmp8_, "clear-all-notifications");
#line 114 "../src/raven/notifications_view.vala"
	_tmp9_ = (GtkButton*) gtk_button_new ();
#line 114 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp9_);
#line 114 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->button_mute);
#line 114 "../src/raven/notifications_view.vala"
	self->priv->button_mute = _tmp9_;
#line 115 "../src/raven/notifications_view.vala"
	_tmp10_ = self->priv->button_mute;
#line 115 "../src/raven/notifications_view.vala"
	gtk_button_set_relief (_tmp10_, GTK_RELIEF_NONE);
#line 116 "../src/raven/notifications_view.vala"
	_tmp11_ = self->priv->button_mute;
#line 116 "../src/raven/notifications_view.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 117 "../src/raven/notifications_view.vala"
	_tmp12_ = self->priv->button_mute;
#line 117 "../src/raven/notifications_view.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
#line 117 "../src/raven/notifications_view.vala"
	gtk_style_context_add_class (_tmp13_, "do-not-disturb");
#line 118 "../src/raven/notifications_view.vala"
	_tmp14_ = self->priv->button_mute;
#line 118 "../src/raven/notifications_view.vala"
	_tmp15_ = self->priv->image_notifications_enabled;
#line 118 "../src/raven/notifications_view.vala"
	gtk_button_set_image (_tmp14_, (GtkWidget*) _tmp15_);
#line 120 "../src/raven/notifications_view.vala"
	_tmp16_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 120 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp16_);
#line 120 "../src/raven/notifications_view.vala"
	control_buttons = _tmp16_;
#line 121 "../src/raven/notifications_view.vala"
	_tmp17_ = control_buttons;
#line 121 "../src/raven/notifications_view.vala"
	_tmp18_ = self->priv->button_mute;
#line 121 "../src/raven/notifications_view.vala"
	gtk_box_pack_start (_tmp17_, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
#line 122 "../src/raven/notifications_view.vala"
	_tmp19_ = control_buttons;
#line 122 "../src/raven/notifications_view.vala"
	_tmp20_ = self->priv->clear_notifications_button;
#line 122 "../src/raven/notifications_view.vala"
	gtk_box_pack_start (_tmp19_, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
#line 124 "../src/raven/notifications_view.vala"
	_tmp21_ = control_buttons;
#line 124 "../src/raven/notifications_view.vala"
	_tmp22_ = budgie_header_widget_new (_ ("No new notifications"), "notification-alert-symbolic", FALSE, NULL, (GtkWidget*) _tmp21_);
#line 124 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp22_);
#line 124 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->header);
#line 124 "../src/raven/notifications_view.vala"
	self->priv->header = _tmp22_;
#line 125 "../src/raven/notifications_view.vala"
	_tmp23_ = self->priv->header;
#line 125 "../src/raven/notifications_view.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp23_, 6);
#line 127 "../src/raven/notifications_view.vala"
	_tmp24_ = self->priv->clear_notifications_button;
#line 127 "../src/raven/notifications_view.vala"
	g_signal_connect_object (_tmp24_, "clicked", (GCallback) _budgie_notifications_view_clear_all_gtk_button_clicked, self, 0);
#line 128 "../src/raven/notifications_view.vala"
	_tmp25_ = self->priv->button_mute;
#line 128 "../src/raven/notifications_view.vala"
	g_signal_connect_object (_tmp25_, "clicked", (GCallback) _budgie_notifications_view_do_not_disturb_toggle_gtk_button_clicked, self, 0);
#line 130 "../src/raven/notifications_view.vala"
	_tmp26_ = self->priv->header;
#line 130 "../src/raven/notifications_view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp26_, FALSE, FALSE, (guint) 0);
#line 132 "../src/raven/notifications_view.vala"
	_tmp27_ = g_direct_hash;
#line 132 "../src/raven/notifications_view.vala"
	_tmp28_ = g_direct_equal;
#line 132 "../src/raven/notifications_view.vala"
	_tmp29_ = g_hash_table_new_full (_tmp27_, _tmp28_, NULL, _g_object_unref0_);
#line 132 "../src/raven/notifications_view.vala"
	_g_hash_table_unref0 (self->priv->notifications);
#line 132 "../src/raven/notifications_view.vala"
	self->priv->notifications = _tmp29_;
#line 133 "../src/raven/notifications_view.vala"
	_tmp30_ = g_str_hash;
#line 133 "../src/raven/notifications_view.vala"
	_tmp31_ = g_str_equal;
#line 133 "../src/raven/notifications_view.vala"
	_tmp32_ = g_hash_table_new_full (_tmp30_, _tmp31_, _g_free0_, _g_object_unref0_);
#line 133 "../src/raven/notifications_view.vala"
	_g_hash_table_unref0 (self->priv->notification_groups);
#line 133 "../src/raven/notifications_view.vala"
	self->priv->notification_groups = _tmp32_;
#line 135 "../src/raven/notifications_view.vala"
	_tmp33_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 135 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp33_);
#line 135 "../src/raven/notifications_view.vala"
	scrolledwindow = _tmp33_;
#line 136 "../src/raven/notifications_view.vala"
	_tmp34_ = scrolledwindow;
#line 136 "../src/raven/notifications_view.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 136 "../src/raven/notifications_view.vala"
	gtk_style_context_add_class (_tmp35_, "raven-background");
#line 137 "../src/raven/notifications_view.vala"
	_tmp36_ = scrolledwindow;
#line 137 "../src/raven/notifications_view.vala"
	gtk_scrolled_window_set_policy (_tmp36_, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 139 "../src/raven/notifications_view.vala"
	_tmp37_ = scrolledwindow;
#line 139 "../src/raven/notifications_view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp37_, TRUE, TRUE, (guint) 0);
#line 141 "../src/raven/notifications_view.vala"
	_tmp38_ = (GtkListBox*) gtk_list_box_new ();
#line 141 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp38_);
#line 141 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->listbox);
#line 141 "../src/raven/notifications_view.vala"
	self->priv->listbox = _tmp38_;
#line 142 "../src/raven/notifications_view.vala"
	_tmp39_ = self->priv->listbox;
#line 142 "../src/raven/notifications_view.vala"
	gtk_list_box_set_selection_mode (_tmp39_, GTK_SELECTION_NONE);
#line 143 "../src/raven/notifications_view.vala"
	_tmp40_ = budgie_notification_placeholder_new ();
#line 143 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp40_);
#line 143 "../src/raven/notifications_view.vala"
	placeholder = _tmp40_;
#line 144 "../src/raven/notifications_view.vala"
	_tmp41_ = self->priv->listbox;
#line 144 "../src/raven/notifications_view.vala"
	_tmp42_ = placeholder;
#line 144 "../src/raven/notifications_view.vala"
	gtk_list_box_set_placeholder (_tmp41_, (GtkWidget*) _tmp42_);
#line 145 "../src/raven/notifications_view.vala"
	_tmp43_ = scrolledwindow;
#line 145 "../src/raven/notifications_view.vala"
	_tmp44_ = self->priv->listbox;
#line 145 "../src/raven/notifications_view.vala"
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 147 "../src/raven/notifications_view.vala"
	_tmp45_ = self->priv->raven_settings;
#line 147 "../src/raven/notifications_view.vala"
	g_signal_connect_object (_tmp45_, "changed::notification-sort", (GCallback) __budgie_notifications_view___lambda24__g_settings_changed, self, 0);
#line 154 "../src/raven/notifications_view.vala"
	_tmp46_ = self->priv->raven_settings;
#line 154 "../src/raven/notifications_view.vala"
	budgie_notifications_view_set_sort_mode (self, (BudgieNotificationSort) g_settings_get_enum (_tmp46_, "notification-sort"));
#line 156 "../src/raven/notifications_view.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 157 "../src/raven/notifications_view.vala"
	budgie_notifications_view_update_child_count (self);
#line 159 "../src/raven/notifications_view.vala"
	g_async_initable_new_async (BUDGIE_TYPE_DISPATCHER_PROXY, 0, NULL, _budgie_notifications_view_on_dbus_get_gasync_ready_callback, g_object_ref (self), "g-flags", 0, "g-name", BUDGIE_NOTIFICATION_DBUS_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", BUDGIE_NOTIFICATION_DBUS_OBJECT_PATH, "g-interface-name", "org.buddiesofbudgie.budgie.Dispatcher", NULL);
#line 168 "../src/raven/notifications_view.vala"
	g_async_initable_new_async (BUDGIE_TYPE_RAVEN_INTERFACE_PROXY, 0, NULL, _budgie_notifications_view_on_raven_get_gasync_ready_callback, g_object_ref (self), "g-flags", 0, "g-name", BUDGIE_RAVEN_DBUS_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", BUDGIE_RAVEN_DBUS_OBJECT_PATH, "g-interface-name", "org.budgie_desktop.Raven", NULL);
#line 100 "../src/raven/notifications_view.vala"
	_g_object_unref0 (placeholder);
#line 100 "../src/raven/notifications_view.vala"
	_g_object_unref0 (scrolledwindow);
#line 100 "../src/raven/notifications_view.vala"
	_g_object_unref0 (control_buttons);
#line 100 "../src/raven/notifications_view.vala"
	return obj;
#line 3525 "notifications_view.c"
}

static void
budgie_notifications_view_class_init (BudgieNotificationsViewClass * klass,
                                      gpointer klass_data)
{
#line 71 "../src/raven/notifications_view.vala"
	budgie_notifications_view_parent_class = g_type_class_peek_parent (klass);
#line 71 "../src/raven/notifications_view.vala"
	g_type_class_adjust_private_offset (klass, &BudgieNotificationsView_private_offset);
#line 71 "../src/raven/notifications_view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_notifications_view_get_property;
#line 71 "../src/raven/notifications_view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_notifications_view_set_property;
#line 71 "../src/raven/notifications_view.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_notifications_view_constructor;
#line 71 "../src/raven/notifications_view.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_notifications_view_finalize;
#line 3544 "notifications_view.c"
}

static void
budgie_notifications_view_instance_init (BudgieNotificationsView * self,
                                         gpointer klass)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
#line 71 "../src/raven/notifications_view.vala"
	self->priv = budgie_notifications_view_get_instance_private (self);
#line 78 "../src/raven/notifications_view.vala"
	self->priv->max_per_group = BUDGIE_NOTIFICATIONS_VIEW_DEFAULT_MAX_PERGROUP;
#line 80 "../src/raven/notifications_view.vala"
	self->priv->header = NULL;
#line 84 "../src/raven/notifications_view.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("notification-disabled-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 84 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp0_);
#line 84 "../src/raven/notifications_view.vala"
	self->priv->image_notifications_disabled = _tmp0_;
#line 85 "../src/raven/notifications_view.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("notification-alert-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 85 "../src/raven/notifications_view.vala"
	g_object_ref_sink (_tmp1_);
#line 85 "../src/raven/notifications_view.vala"
	self->priv->image_notifications_enabled = _tmp1_;
#line 87 "../src/raven/notifications_view.vala"
	self->priv->_do_not_disturb = FALSE;
#line 88 "../src/raven/notifications_view.vala"
	self->priv->_performing_clear_all = FALSE;
#line 89 "../src/raven/notifications_view.vala"
	self->priv->_sort_mode = BUDGIE_NOTIFICATION_SORT_NEW_OLD;
#line 3577 "notifications_view.c"
}

static void
budgie_notifications_view_finalize (GObject * obj)
{
	BudgieNotificationsView * self;
#line 71 "../src/raven/notifications_view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATIONS_VIEW, BudgieNotificationsView);
#line 80 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->header);
#line 81 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->button_mute);
#line 82 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->clear_notifications_button);
#line 83 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->listbox);
#line 84 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->image_notifications_disabled);
#line 85 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->image_notifications_enabled);
#line 91 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->dispatcher);
#line 92 "../src/raven/notifications_view.vala"
	_g_hash_table_unref0 (self->priv->notifications);
#line 93 "../src/raven/notifications_view.vala"
	_g_hash_table_unref0 (self->priv->notification_groups);
#line 95 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->budgie_settings);
#line 96 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 98 "../src/raven/notifications_view.vala"
	_g_object_unref0 (self->priv->raven);
#line 71 "../src/raven/notifications_view.vala"
	G_OBJECT_CLASS (budgie_notifications_view_parent_class)->finalize (obj);
#line 3612 "notifications_view.c"
}

static GType
budgie_notifications_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notifications_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotificationsView), 0, (GInstanceInitFunc) budgie_notifications_view_instance_init, NULL };
	GType budgie_notifications_view_type_id;
	budgie_notifications_view_type_id = g_type_register_static (gtk_box_get_type (), "BudgieNotificationsView", &g_define_type_info, 0);
	BudgieNotificationsView_private_offset = g_type_add_instance_private (budgie_notifications_view_type_id, sizeof (BudgieNotificationsViewPrivate));
	return budgie_notifications_view_type_id;
}

GType
budgie_notifications_view_get_type (void)
{
	static volatile gsize budgie_notifications_view_type_id__once = 0;
	if (g_once_init_enter (&budgie_notifications_view_type_id__once)) {
		GType budgie_notifications_view_type_id;
		budgie_notifications_view_type_id = budgie_notifications_view_get_type_once ();
		g_once_init_leave (&budgie_notifications_view_type_id__once, budgie_notifications_view_type_id);
	}
	return budgie_notifications_view_type_id__once;
}

static void
_vala_budgie_notifications_view_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	BudgieNotificationsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATIONS_VIEW, BudgieNotificationsView);
#line 71 "../src/raven/notifications_view.vala"
	switch (property_id) {
#line 3647 "notifications_view.c"
		default:
#line 71 "../src/raven/notifications_view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 71 "../src/raven/notifications_view.vala"
		break;
#line 3653 "notifications_view.c"
	}
}

static void
_vala_budgie_notifications_view_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	BudgieNotificationsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATIONS_VIEW, BudgieNotificationsView);
#line 71 "../src/raven/notifications_view.vala"
	switch (property_id) {
#line 3667 "notifications_view.c"
		default:
#line 71 "../src/raven/notifications_view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 71 "../src/raven/notifications_view.vala"
		break;
#line 3673 "notifications_view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

